from collections import namedtuple
from typing import Optional

BAGL_FONT_ID_MASK = 0x0fff

BAGL_FONT_LUCIDA_CONSOLE_8PX = 0
BAGL_FONT_OPEN_SANS_LIGHT_16_22PX = 1
BAGL_FONT_OPEN_SANS_REGULAR_8_11PX = 2
BAGL_FONT_OPEN_SANS_REGULAR_10_13PX = 3
BAGL_FONT_OPEN_SANS_REGULAR_11_14PX = 4
BAGL_FONT_OPEN_SANS_REGULAR_13_18PX = 5
BAGL_FONT_OPEN_SANS_REGULAR_22_30PX = 6
BAGL_FONT_OPEN_SANS_SEMIBOLD_8_11PX = 7
BAGL_FONT_OPEN_SANS_EXTRABOLD_11px = 8
BAGL_FONT_OPEN_SANS_LIGHT_16px = 9
BAGL_FONT_OPEN_SANS_REGULAR_11px = 10
BAGL_FONT_OPEN_SANS_SEMIBOLD_10_13PX = 11
BAGL_FONT_OPEN_SANS_SEMIBOLD_11_16PX = 12
BAGL_FONT_OPEN_SANS_SEMIBOLD_13_18PX = 13
BAGL_FONT_SYMBOLS_0 = 14
BAGL_FONT_SYMBOLS_1 = 15

'''
typedef struct {
  unsigned int font_id; // to allow for sparse font embedding with a linear enum
  unsigned char bpp; // for antialiased fonts
  unsigned char char_height;
  unsigned char baseline_height;
  unsigned char char_kerning; // specific to the font
  unsigned short first_char;
  unsigned short last_char;
  const bagl_font_character_t * const characters;
  #define PIC_CHAR(x) ((const bagl_font_character_t *)PIC(x))
  unsigned char const * bitmap; // single bitmap for all chars of a font
  #define PIC_BMP(x) ((unsigned char const*)PIC(x))
} bagl_font_t;

typedef struct {
  unsigned char char_width;
  unsigned char bitmap_byte_count;
  //unsigned char const * bitmap; // save space by only keeping the offset (2 bytes) instead of the char address
  //(4 bytes)
  unsigned short bitmap_offset;
} bagl_font_character_t;
'''

Font = namedtuple("Font", "font_id bpp char_height baseline_height char_kerning first_char last_char characters bitmap")
FontCharacter = namedtuple("FontCharacter", "char_width bitmap_byte_count bitmap_offset")

bitmapLUCIDA_CONSOLE_6PT_8H = [
  0x00,  0x00,  0x00,  0x00,  0x00,
  0x84,  0x10,  0x02,  0x08,  0x00,
  0x4A,  0x01,  0x00,  0x00,  0x00,
  0x80,  0x7E,  0xF5,  0x0B,  0x00,
  0xC4,  0x19,  0xC2,  0x1C,  0x01,
  0xB2,  0x3A,  0x57,  0x13,  0x00,
  0x44,  0x99,  0x9A,  0x2C,  0x00,
  0x84,  0x00,  0x00,  0x00,  0x00,
  0x98,  0x08,  0x21,  0x08,  0x06,
  0x83,  0x20,  0x84,  0xC8,  0x00,
  0x44,  0x11,  0x05,  0x00,  0x00,
  0x00,  0x00,  0xE2,  0x08,  0x00,
  0x00,  0x00,  0x00,  0x08,  0x11,
  0x00,  0x00,  0x07,  0x00,  0x00,
  0x00,  0x00,  0x00,  0x08,  0x00,
  0x10,  0x21,  0x42,  0x84,  0x00,
  0x4C,  0x4A,  0x29,  0x19,  0x00,
  0xC4,  0x10,  0x42,  0x1C,  0x00,
  0x06,  0x21,  0x22,  0x1C,  0x00,
  0x06,  0x19,  0x84,  0x0C,  0x00,
  0x88,  0x29,  0x8F,  0x10,  0x00,
  0x4E,  0x18,  0x84,  0x0C,  0x00,
  0x4C,  0x38,  0x29,  0x19,  0x00,
  0x1E,  0x22,  0x42,  0x08,  0x00,
  0x4C,  0x32,  0x29,  0x19,  0x00,
  0x4C,  0x4A,  0x0E,  0x19,  0x00,
  0x00,  0x10,  0x00,  0x08,  0x00,
  0x00,  0x10,  0x00,  0x08,  0x11,
  0x00,  0x22,  0x83,  0x20,  0x00,
  0x00,  0x78,  0xE0,  0x01,  0x00,
  0x40,  0x10,  0x4C,  0x04,  0x00,
  0x0E,  0x22,  0x02,  0x08,  0x00,
  0x4C,  0xE6,  0xDA,  0x83,  0x07,
  0x80,  0x28,  0xF5,  0x23,  0x00,
  0xC0,  0x29,  0xA3,  0x1C,  0x00,
  0x80,  0x0B,  0x21,  0x38,  0x00,
  0xC0,  0x49,  0x29,  0x1D,  0x00,
  0xC0,  0x09,  0x27,  0x1C,  0x00,
  0xC0,  0x09,  0x27,  0x04,  0x00,
  0x80,  0x0B,  0x2D,  0x39,  0x00,
  0x40,  0x4A,  0x2F,  0x25,  0x00,
  0xC0,  0x11,  0x42,  0x1C,  0x00,
  0xC0,  0x21,  0x84,  0x0C,  0x00,
  0x40,  0x2A,  0xA3,  0x24,  0x00,
  0x40,  0x08,  0x21,  0x3C,  0x00,
  0x20,  0xEE,  0x5A,  0x23,  0x00,
  0x40,  0x5A,  0x2D,  0x25,  0x00,
  0xC0,  0xC5,  0x18,  0x1D,  0x00,
  0xC0,  0x49,  0x27,  0x04,  0x00,
  0xC0,  0xC5,  0x18,  0x1D,  0x82,
  0xC0,  0x28,  0xA3,  0x24,  0x00,
  0x80,  0x09,  0x82,  0x0C,  0x00,
  0xE0,  0x13,  0x42,  0x08,  0x00,
  0x40,  0x4A,  0x29,  0x19,  0x00,
  0x40,  0x4A,  0xC9,  0x18,  0x00,
  0x20,  0xD6,  0xAA,  0x14,  0x00,
  0x20,  0x2A,  0xA2,  0x22,  0x00,
  0x20,  0x2A,  0x42,  0x08,  0x00,
  0xC0,  0x43,  0x26,  0x3C,  0x00,
  0x8C,  0x10,  0x42,  0x08,  0x03,
  0x41,  0x08,  0x42,  0x10,  0x02,
  0x86,  0x10,  0x42,  0x88,  0x01,
  0x44,  0xA9,  0x18,  0x01,  0x00,
  0x00,  0x00,  0x00,  0xC0,  0x07,
  0x82,  0x00,  0x00,  0x00,  0x00,
  0x00,  0x18,  0xE4,  0x3C,  0x00,
  0x42,  0x38,  0x29,  0x1D,  0x00,
  0x00,  0x30,  0x21,  0x18,  0x00,
  0x08,  0xB9,  0x94,  0x1C,  0x00,
  0x00,  0x10,  0x27,  0x18,  0x00,
  0x98,  0x78,  0x42,  0x08,  0x00,
  0x00,  0x70,  0xE9,  0xA1,  0x03,
  0x42,  0x28,  0x2B,  0x25,  0x00,
  0x04,  0x18,  0x42,  0x08,  0x00,
  0x08,  0x38,  0x84,  0x90,  0x01,
  0x42,  0x28,  0xA3,  0x24,  0x00,
  0x86,  0x10,  0x42,  0x08,  0x00,
  0x00,  0xD4,  0x5F,  0x2B,  0x00,
  0x00,  0x28,  0x2B,  0x25,  0x00,
  0x00,  0x30,  0x29,  0x19,  0x00,
  0x00,  0x38,  0x29,  0x9D,  0x00,
  0x00,  0xB8,  0x94,  0x1C,  0x02,
  0x00,  0x28,  0x23,  0x04,  0x00,
  0x00,  0x30,  0x83,  0x0C,  0x00,
  0x80,  0x78,  0x42,  0x10,  0x00,
  0x00,  0x48,  0xA9,  0x29,  0x00,
  0x00,  0x48,  0xC9,  0x18,  0x00,
  0x00,  0xD4,  0xEA,  0x14,  0x00,
  0x00,  0x48,  0xC6,  0x24,  0x00,
  0x00,  0x48,  0xC9,  0xD8,  0x01,
  0x00,  0x38,  0x26,  0x1C,  0x00,
  0x88,  0x10,  0x41,  0x08,  0x02,
  0x84,  0x10,  0x42,  0x08,  0x01,
  0x82,  0x10,  0x44,  0x88,  0x00,
  0x00,  0x00,  0x9B,  0x00,  0x00,
  0xC0,  0x29,  0xA5,  0x1C,  0x00,
  0x00,  0x00,  0x00,  0x00,  0x00,
  0x00,  0x10,  0x40,  0x08,  0x01,
  0x80,  0x38,  0xE1,  0x08,  0x00,
  0x80,  0x08,  0x33,  0x1C,  0x00,
  0x20,  0x3A,  0xE5,  0x22,  0x00,
  0x20,  0x2A,  0xE2,  0x08,  0x00,
  0x84,  0x10,  0x00,  0x08,  0x21,
  0x4C,  0x10,  0x45,  0x90,  0x01,
  0x0A,  0x00,  0x00,  0x00,  0x00,
  0x2E,  0xF6,  0xDA,  0xA3,  0x03,
  0x06,  0x39,  0xE5,  0x00,  0x00,
  0x80,  0xAA,  0xA2,  0x28,  0x00,
  0x00,  0x00,  0x87,  0x10,  0x00,
  0x00,  0x00,  0x07,  0x00,  0x00,
  0xAE,  0xF7,  0xDA,  0x1D,  0x00,
  0x1F,  0x00,  0x00,  0x00,  0x00,
  0x4C,  0x4A,  0x06,  0x00,  0x00,
  0x00,  0x10,  0x47,  0x1C,  0x00,
  0x06,  0x11,  0xE1,  0x00,  0x00,
  0x06,  0x19,  0x64,  0x00,  0x00,
  0x88,  0x00,  0x00,  0x00,  0x00,
  0x00,  0x48,  0xA9,  0xAD,  0x00,
  0x6E,  0x2D,  0xA5,  0x94,  0x02,
  0x00,  0x00,  0x02,  0x00,  0x00,
  0x00,  0x00,  0x00,  0x00,  0x11,
  0x86,  0x10,  0xE2,  0x00,  0x00,
  0x44,  0x29,  0x45,  0x00,  0x00,
  0xA0,  0x28,  0xAA,  0x0A,  0x00,
  0x53,  0x29,  0xAA,  0x23,  0x00,
  0x53,  0x79,  0xAA,  0x32,  0x00,
  0x73,  0xA9,  0xAB,  0x23,  0x00,
  0x80,  0x00,  0x42,  0x90,  0x01,
  0x82,  0x28,  0xF5,  0x23,  0x00,
  0x88,  0x28,  0xF5,  0x23,  0x00,
  0x4C,  0x12,  0xF5,  0x23,  0x00,
  0x36,  0x11,  0xF5,  0x23,  0x00,
  0x8A,  0x28,  0xF5,  0x23,  0x00,
  0x44,  0x11,  0xF5,  0x23,  0x00,
  0x80,  0x2B,  0xFD,  0x32,  0x00,
  0x80,  0x0B,  0x21,  0x38,  0x22,
  0xC1,  0x09,  0x27,  0x1C,  0x00,
  0xD0,  0x09,  0x27,  0x1C,  0x00,
  0xCE,  0x09,  0x27,  0x1C,  0x00,
  0xD1,  0x09,  0x27,  0x1C,  0x00,
  0xC1,  0x11,  0x42,  0x1C,  0x00,
  0xD0,  0x11,  0x42,  0x1C,  0x00,
  0xCE,  0x11,  0x42,  0x1C,  0x00,
  0xD1,  0x11,  0x42,  0x1C,  0x00,
  0xC0,  0xC9,  0x2B,  0x1D,  0x00,
  0x5F,  0x5A,  0x2D,  0x25,  0x00,
  0xC1,  0xC5,  0x18,  0x1D,  0x00,
  0xD0,  0xC5,  0x18,  0x1D,  0x00,
  0xCE,  0xC5,  0x18,  0x1D,  0x00,
  0xCF,  0xC5,  0x18,  0x1D,  0x00,
  0xD1,  0xC5,  0x18,  0x1D,  0x00,
  0x00,  0x48,  0xC6,  0x24,  0x00,
  0xD0,  0xE5,  0x3A,  0x5D,  0x00,
  0x41,  0x4A,  0x29,  0x19,  0x00,
  0x30,  0xA5,  0x94,  0x0C,  0x00,
  0x5E,  0x4A,  0x29,  0x19,  0x00,
  0x49,  0x4A,  0x29,  0x19,  0x00,
  0xA8,  0x2A,  0x42,  0x08,  0x00,
  0x40,  0x38,  0xE9,  0x04,  0x00,
  0x44,  0x29,  0x25,  0x15,  0x00,
  0x41,  0x18,  0xE4,  0x3C,  0x00,
  0x10,  0x19,  0xE4,  0x3C,  0x00,
  0x4C,  0x1A,  0xE4,  0x3C,  0x00,
  0x36,  0x19,  0xE4,  0x3C,  0x00,
  0x0A,  0x18,  0xE4,  0x3C,  0x00,
  0x44,  0x19,  0xE4,  0x3C,  0x00,
  0x00,  0x2C,  0x7E,  0x32,  0x00,
  0x00,  0x30,  0x21,  0x18,  0x22,
  0x41,  0x10,  0x27,  0x18,  0x00,
  0x10,  0x11,  0x27,  0x18,  0x00,
  0x4C,  0x12,  0x27,  0x18,  0x00,
  0x0A,  0x10,  0x27,  0x18,  0x00,
  0x41,  0x18,  0x42,  0x08,  0x00,
  0x10,  0x19,  0x42,  0x08,  0x00,
  0x4C,  0x1A,  0x42,  0x08,  0x00,
  0x0A,  0x18,  0x42,  0x08,  0x00,
  0x8F,  0xB8,  0x94,  0x0C,  0x00,
  0x1E,  0x28,  0x2B,  0x25,  0x00,
  0x41,  0x30,  0x29,  0x19,  0x00,
  0x10,  0x31,  0x29,  0x19,  0x00,
  0x26,  0x31,  0x29,  0x19,  0x00,
  0x36,  0x31,  0x29,  0x19,  0x00,
  0x12,  0x30,  0x29,  0x19,  0x00,
  0x80,  0x00,  0x07,  0x08,  0x00,
  0x00,  0x32,  0x6D,  0x99,  0x00,
  0x82,  0x48,  0xA9,  0x29,  0x00,
  0x10,  0x49,  0xA9,  0x29,  0x00,
  0x26,  0x49,  0xA9,  0x29,  0x00,
  0x12,  0x48,  0xA9,  0x29,  0x00,
  0x10,  0x49,  0xC9,  0xD8,  0x00,
  0x42,  0x38,  0x29,  0x9D,  0x00,
  0x12,  0x48,  0xC9,  0xD8,  0x01
]

charactersLUCIDA_CONSOLE_6PT_8H = [
   FontCharacter(5, 5, 0),
   FontCharacter(5, 5, 5),
   FontCharacter(5, 5, 10),
   FontCharacter(5, 5, 15),
   FontCharacter(5, 5, 20),
   FontCharacter(5, 5, 25),
   FontCharacter(5, 5, 30),
   FontCharacter(5, 5, 35),
   FontCharacter(5, 5, 40),
   FontCharacter(5, 5, 45),
   FontCharacter(5, 5, 50),
   FontCharacter(5, 5, 55),
   FontCharacter(5, 5, 60),
   FontCharacter(5, 5, 65),
   FontCharacter(5, 5, 70),
   FontCharacter(5, 5, 75),
   FontCharacter(5, 5, 80),
   FontCharacter(5, 5, 85),
   FontCharacter(5, 5, 90),
   FontCharacter(5, 5, 95),
   FontCharacter(5, 5, 100),
   FontCharacter(5, 5, 105),
   FontCharacter(5, 5, 110),
   FontCharacter(5, 5, 115),
   FontCharacter(5, 5, 120),
   FontCharacter(5, 5, 125),
   FontCharacter(5, 5, 130),
   FontCharacter(5, 5, 135),
   FontCharacter(5, 5, 140),
   FontCharacter(5, 5, 145),
   FontCharacter(5, 5, 150),
   FontCharacter(5, 5, 155),
   FontCharacter(5, 5, 160),
   FontCharacter(5, 5, 165),
   FontCharacter(5, 5, 170),
   FontCharacter(5, 5, 175),
   FontCharacter(5, 5, 180),
   FontCharacter(5, 5, 185),
   FontCharacter(5, 5, 190),
   FontCharacter(5, 5, 195),
   FontCharacter(5, 5, 200),
   FontCharacter(5, 5, 205),
   FontCharacter(5, 5, 210),
   FontCharacter(5, 5, 215),
   FontCharacter(5, 5, 220),
   FontCharacter(5, 5, 225),
   FontCharacter(5, 5, 230),
   FontCharacter(5, 5, 235),
   FontCharacter(5, 5, 240),
   FontCharacter(5, 5, 245),
   FontCharacter(5, 5, 250),
   FontCharacter(5, 5, 255),
   FontCharacter(5, 5, 260),
   FontCharacter(5, 5, 265),
   FontCharacter(5, 5, 270),
   FontCharacter(5, 5, 275),
   FontCharacter(5, 5, 280),
   FontCharacter(5, 5, 285),
   FontCharacter(5, 5, 290),
   FontCharacter(5, 5, 295),
   FontCharacter(5, 5, 300),
   FontCharacter(5, 5, 305),
   FontCharacter(5, 5, 310),
   FontCharacter(5, 5, 315),
   FontCharacter(5, 5, 320),
   FontCharacter(5, 5, 325),
   FontCharacter(5, 5, 330),
   FontCharacter(5, 5, 335),
   FontCharacter(5, 5, 340),
   FontCharacter(5, 5, 345),
   FontCharacter(5, 5, 350),
   FontCharacter(5, 5, 355),
   FontCharacter(5, 5, 360),
   FontCharacter(5, 5, 365),
   FontCharacter(5, 5, 370),
   FontCharacter(5, 5, 375),
   FontCharacter(5, 5, 380),
   FontCharacter(5, 5, 385),
   FontCharacter(5, 5, 390),
   FontCharacter(5, 5, 395),
   FontCharacter(5, 5, 400),
   FontCharacter(5, 5, 405),
   FontCharacter(5, 5, 410),
   FontCharacter(5, 5, 415),
   FontCharacter(5, 5, 420),
   FontCharacter(5, 5, 425),
   FontCharacter(5, 5, 430),
   FontCharacter(5, 5, 435),
   FontCharacter(5, 5, 440),
   FontCharacter(5, 5, 445),
   FontCharacter(5, 5, 450),
   FontCharacter(5, 5, 455),
   FontCharacter(5, 5, 460),
   FontCharacter(5, 5, 465),
   FontCharacter(5, 5, 470),
   FontCharacter(5, 5, 475),
   FontCharacter(5, 5, 480),
   FontCharacter(5, 5, 485),
   FontCharacter(5, 5, 490),
   FontCharacter(5, 5, 495),
   FontCharacter(5, 5, 500),
   FontCharacter(5, 5, 505),
   FontCharacter(5, 5, 510),
   FontCharacter(5, 5, 515),
   FontCharacter(5, 5, 520),
   FontCharacter(5, 5, 525),
   FontCharacter(5, 5, 530),
   FontCharacter(5, 5, 535),
   FontCharacter(5, 5, 540),
   FontCharacter(5, 5, 545),
   FontCharacter(5, 5, 550),
   FontCharacter(5, 5, 555),
   FontCharacter(5, 5, 560),
   FontCharacter(5, 5, 565),
   FontCharacter(5, 5, 570),
   FontCharacter(5, 5, 575),
   FontCharacter(5, 5, 580),
   FontCharacter(5, 5, 585),
   FontCharacter(5, 5, 590),
   FontCharacter(5, 5, 595),
   FontCharacter(5, 5, 600),
   FontCharacter(5, 5, 605),
   FontCharacter(5, 5, 610),
   FontCharacter(5, 5, 615),
   FontCharacter(5, 5, 620),
   FontCharacter(5, 5, 625),
   FontCharacter(5, 5, 630),
   FontCharacter(5, 5, 635),
   FontCharacter(5, 5, 640),
   FontCharacter(5, 5, 645),
   FontCharacter(5, 5, 650),
   FontCharacter(5, 5, 655),
   FontCharacter(5, 5, 660),
   FontCharacter(5, 5, 665),
   FontCharacter(5, 5, 670),
   FontCharacter(5, 5, 675),
   FontCharacter(5, 5, 680),
   FontCharacter(5, 5, 685),
   FontCharacter(5, 5, 690),
   FontCharacter(5, 5, 695),
   FontCharacter(5, 5, 700),
   FontCharacter(5, 5, 705),
   FontCharacter(5, 5, 710),
   FontCharacter(5, 5, 715),
   FontCharacter(5, 5, 720),
   FontCharacter(5, 5, 725),
   FontCharacter(5, 5, 730),
   FontCharacter(5, 5, 735),
   FontCharacter(5, 5, 740),
   FontCharacter(5, 5, 745),
   FontCharacter(5, 5, 750),
   FontCharacter(5, 5, 755),
   FontCharacter(5, 5, 760),
   FontCharacter(5, 5, 765),
   FontCharacter(5, 5, 770),
   FontCharacter(5, 5, 775),
   FontCharacter(5, 5, 780),
   FontCharacter(5, 5, 785),
   FontCharacter(5, 5, 790),
   FontCharacter(5, 5, 795),
   FontCharacter(5, 5, 800),
   FontCharacter(5, 5, 805),
   FontCharacter(5, 5, 810),
   FontCharacter(5, 5, 815),
   FontCharacter(5, 5, 820),
   FontCharacter(5, 5, 825),
   FontCharacter(5, 5, 830),
   FontCharacter(5, 5, 835),
   FontCharacter(5, 5, 840),
   FontCharacter(5, 5, 845),
   FontCharacter(5, 5, 850),
   FontCharacter(5, 5, 855),
   FontCharacter(5, 5, 860),
   FontCharacter(5, 5, 865),
   FontCharacter(5, 5, 870),
   FontCharacter(5, 5, 875),
   FontCharacter(5, 5, 880),
   FontCharacter(5, 5, 885),
   FontCharacter(5, 5, 890),
   FontCharacter(5, 5, 895),
   FontCharacter(5, 5, 900),
   FontCharacter(5, 5, 905),
   FontCharacter(5, 5, 910),
   FontCharacter(5, 5, 915),
   FontCharacter(5, 5, 920),
   FontCharacter(5, 5, 925),
   FontCharacter(5, 5, 930),
   FontCharacter(5, 5, 935),
   FontCharacter(5, 5, 940),
   FontCharacter(5, 5, 945),
   FontCharacter(5, 5, 950),
   FontCharacter(5, 5, 955)
]

bitmapOPEN_SANS_LIGHT_16_22PX = [
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xf1, 0x01, 0x10, 0x1f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xd0, 0x00, 0x00,
    0x0b, 0x00, 0xb0, 0x00, 0x00, 0x0b, 0x00, 0xb0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x3f, 0x00, 0xf3, 0x02,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x8a, 0x80, 0x0a, 0x90, 0x07, 0x97, 0x00, 0x68, 0x50, 0x08, 0x70, 0x05, 0x75, 0x00, 0x35, 0x30, 0x05, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x07, 0x00, 0x3a, 0x00, 0x00, 0x00, 0x90, 0x04, 0x00, 0x0c, 0x00, 0x00,
    0x00, 0xc0, 0x01, 0x00, 0x0d, 0x00, 0x00, 0x00, 0xe0, 0x00, 0x20, 0x0a, 0x00, 0x00, 0x00, 0xa2, 0x00, 0x60, 0x07,
    0x00, 0x60, 0xdd, 0xee, 0xdd, 0xfd, 0xdd, 0x4d, 0x00, 0x00, 0x49, 0x00, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x00,
    0xc1, 0x00, 0x00, 0x00, 0x10, 0x0c, 0x00, 0x85, 0x00, 0x00, 0xd4, 0xed, 0xde, 0xdd, 0xef, 0xdd, 0x08, 0x00, 0x80,
    0x05, 0x00, 0x1c, 0x00, 0x00, 0x00, 0xa0, 0x02, 0x00, 0x0e, 0x00, 0x00, 0x00, 0xd0, 0x00, 0x20, 0x0b, 0x00, 0x00,
    0x00, 0xc0, 0x00, 0x40, 0x08, 0x00, 0x00, 0x00, 0xa3, 0x00, 0x80, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x70, 0x05, 0x00, 0x00, 0x00, 0x00, 0x70, 0x05, 0x00, 0x00, 0x00, 0x40, 0xfb, 0xee, 0x6b, 0x00, 0x00, 0xd6,
    0x73, 0x05, 0x53, 0x00, 0x00, 0x3e, 0x70, 0x05, 0x00, 0x00, 0x00, 0x1f, 0x70, 0x05, 0x00, 0x00, 0x00, 0x4e, 0x70,
    0x05, 0x00, 0x00, 0x00, 0xe5, 0x86, 0x05, 0x00, 0x00, 0x00, 0x30, 0xfa, 0x4b, 0x00, 0x00, 0x00, 0x00, 0x70, 0xca,
    0x2d, 0x00, 0x00, 0x00, 0x70, 0x05, 0xd7, 0x00, 0x00, 0x00, 0x70, 0x05, 0xf0, 0x01, 0x00, 0x00, 0x70, 0x05, 0xf1,
    0x00, 0x40, 0x27, 0x70, 0x35, 0x8d, 0x00, 0x10, 0xc8, 0xee, 0xbe, 0x04, 0x00, 0x00, 0x00, 0x70, 0x05, 0x00, 0x00,
    0x00, 0x00, 0x70, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xee, 0x09, 0x00, 0x00, 0xc1, 0x00, 0x00, 0x40, 0x0c, 0xa0, 0x07,
    0x00, 0xa0, 0x04, 0x00, 0x00, 0x59, 0x00, 0xd2, 0x00, 0x30, 0x0b, 0x00, 0x00, 0xc0, 0x02, 0x00, 0x0f, 0x00, 0x3b,
    0x00, 0x00, 0x00, 0x1d, 0x00, 0xf0, 0x01, 0xa4, 0x00, 0x00, 0x00, 0xc0, 0x02, 0x00, 0x0f, 0xc0, 0x01, 0x00, 0x00,
    0x00, 0x59, 0x00, 0xd2, 0x60, 0x08, 0xd9, 0x6d, 0x00, 0x30, 0x0c, 0xa0, 0x07, 0x0d, 0x97, 0x00, 0x3c, 0x00, 0x60,
    0xed, 0x09, 0x68, 0xd0, 0x02, 0x60, 0x09, 0x00, 0x00, 0x00, 0xc1, 0x00, 0x0f, 0x00, 0xc3, 0x00, 0x00, 0x00, 0xa0,
    0x04, 0xf1, 0x00, 0x10, 0x0d, 0x00, 0x00, 0x30, 0x0b, 0x00, 0x0f, 0x00, 0xc3, 0x00, 0x00, 0x00, 0x3b, 0x00, 0xd0,
    0x02, 0x60, 0x09, 0x00, 0x00, 0xa4, 0x00, 0x00, 0xa7, 0x10, 0x3d, 0x00, 0x00, 0xc0, 0x01, 0x00, 0x00, 0xf9, 0x6e,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x91, 0xee, 0x6d, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x08, 0x20, 0x6d, 0x00, 0x00, 0x00, 0x20,
    0x0e, 0x00, 0x50, 0x0b, 0x00, 0x00, 0x00, 0xd3, 0x00, 0x00, 0xb4, 0x00, 0x00, 0x00, 0x00, 0x2e, 0x00, 0xb0, 0x06,
    0x00, 0x00, 0x00, 0x50, 0x1d, 0xa0, 0x09, 0x00, 0x00, 0x00, 0x00, 0x70, 0xdd, 0x05, 0x00, 0x00, 0x00, 0x00, 0x60,
    0xad, 0x2e, 0x00, 0x00, 0x00, 0x00, 0xa0, 0x0a, 0x60, 0x2e, 0x00, 0x20, 0x0c, 0x50, 0x0b, 0x00, 0x60, 0x2e, 0x00,
    0x68, 0x00, 0x6a, 0x00, 0x00, 0x60, 0x2e, 0xe1, 0x00, 0xb0, 0x05, 0x00, 0x00, 0x60, 0xce, 0x05, 0x00, 0xa7, 0x00,
    0x00, 0x00, 0xc0, 0x2f, 0x00, 0x00, 0x8d, 0x01, 0x00, 0xd5, 0x58, 0x2d, 0x00, 0x00, 0xd8, 0xee, 0x9d, 0x02, 0x40,
    0x2d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0x09, 0x70, 0x08, 0x70, 0x07, 0x50, 0x06, 0x50,
    0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30,
    0x0d, 0x00, 0xd0, 0x03, 0x00, 0x98, 0x00, 0x00, 0x1f, 0x00, 0x50, 0x0b, 0x00, 0xa0, 0x06, 0x00, 0xe0, 0x03, 0x00,
    0xf0, 0x01, 0x00, 0xf1, 0x00, 0x00, 0xf1, 0x00, 0x00, 0xf0, 0x00, 0x00, 0xe0, 0x02, 0x00, 0xb0, 0x06, 0x00, 0x60,
    0x0b, 0x00, 0x10, 0x2f, 0x00, 0x00, 0x99, 0x00, 0x00, 0xe0, 0x03, 0x00, 0x30, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x03, 0x00, 0x30, 0x0d, 0x00, 0x00, 0x89, 0x00, 0x00, 0xf1, 0x00,
    0x00, 0xb0, 0x05, 0x00, 0x60, 0x0a, 0x00, 0x30, 0x0e, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x1f, 0x00, 0x00, 0x1f, 0x00,
    0x00, 0x0f, 0x00, 0x20, 0x0e, 0x00, 0x60, 0x0b, 0x00, 0xb0, 0x06, 0x00, 0xf2, 0x01, 0x00, 0x99, 0x00, 0x30, 0x0e,
    0x00, 0xd0, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x09, 0x00, 0x00,
    0x00, 0x00, 0xa0, 0x08, 0x00, 0x00, 0x00, 0x00, 0x90, 0x07, 0x00, 0x00, 0x90, 0x59, 0x71, 0x25, 0xa6, 0x09, 0x60,
    0x98, 0xeb, 0xbd, 0x89, 0x05, 0x00, 0x00, 0xb3, 0x2d, 0x00, 0x00, 0x00, 0x10, 0x3e, 0xd5, 0x00, 0x00, 0x00, 0xb0,
    0x0b, 0xc0, 0x0a, 0x00, 0x00, 0xb0, 0x03, 0x40, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x02, 0x00, 0x00, 0x00, 0x00,
    0x50, 0x05, 0x00, 0x00, 0x00, 0x00, 0x50, 0x05, 0x00, 0x00, 0x00, 0x00, 0x50, 0x05, 0x00, 0x00, 0x00, 0x00, 0x50,
    0x05, 0x00, 0x00, 0xb0, 0xdd, 0xed, 0xde, 0xdd, 0x0b, 0x00, 0x00, 0x50, 0x05, 0x00, 0x00, 0x00, 0x00, 0x50, 0x05,
    0x00, 0x00, 0x00, 0x00, 0x50, 0x05, 0x00, 0x00, 0x00, 0x00, 0x50, 0x05, 0x00, 0x00, 0x00, 0x00, 0x10, 0x01, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5f, 0x00, 0xf4, 0x00, 0x70, 0x0a, 0x00, 0x3c, 0x00, 0xb0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xdd, 0xdd, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x3f, 0x00, 0xf3, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x87, 0x00, 0x00, 0xd0, 0x03,
    0x00, 0x30, 0x0d, 0x00, 0x00, 0x78, 0x00, 0x00, 0xe0, 0x01, 0x00, 0x40, 0x0b, 0x00, 0x00, 0x6a, 0x00, 0x00, 0xe0,
    0x00, 0x00, 0x50, 0x0a, 0x00, 0x00, 0x4b, 0x00, 0x00, 0xe1, 0x00, 0x00, 0x70, 0x09, 0x00, 0x00, 0x3d, 0x00, 0x00,
    0xd2, 0x00, 0x00, 0x80, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0xeb, 0xbe,
    0x03, 0x00, 0x00, 0xe5, 0x03, 0x30, 0x4d, 0x00, 0x00, 0x3e, 0x00, 0x00, 0xe3, 0x00, 0x50, 0x0c, 0x00, 0x00, 0xc0,
    0x04, 0x80, 0x08, 0x00, 0x00, 0x80, 0x08, 0xb0, 0x05, 0x00, 0x00, 0x50, 0x0b, 0xb0, 0x04, 0x00, 0x00, 0x40, 0x0c,
    0xb0, 0x03, 0x00, 0x00, 0x30, 0x0d, 0xb0, 0x04, 0x00, 0x00, 0x50, 0x0c, 0xa0, 0x05, 0x00, 0x00, 0x60, 0x0b, 0x80,
    0x08, 0x00, 0x00, 0x80, 0x08, 0x40, 0x0c, 0x00, 0x00, 0xc0, 0x05, 0x00, 0x3e, 0x00, 0x00, 0xe3, 0x00, 0x00, 0xd4,
    0x03, 0x30, 0x5e, 0x00, 0x00, 0x30, 0xeb, 0xbe, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x0f, 0x00,
    0x00, 0x00, 0x10, 0x7b, 0x0d, 0x00, 0x00, 0x00, 0xd4, 0x04, 0x0f, 0x00, 0x00, 0x00, 0x26, 0x00, 0x0f, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x91, 0xed, 0xbe, 0x02, 0x00,
    0x30, 0x6d, 0x00, 0x60, 0x2e, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa7, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd2, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xd3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x96, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3d, 0x00, 0x00, 0x00,
    0x00, 0x90, 0x09, 0x00, 0x00, 0x00, 0x00, 0xc6, 0x00, 0x00, 0x00, 0x00, 0x50, 0x1d, 0x00, 0x00, 0x00, 0x00, 0xc4,
    0x01, 0x00, 0x00, 0x00, 0x40, 0x1c, 0x00, 0x00, 0x00, 0x00, 0xc4, 0x01, 0x00, 0x00, 0x00, 0x40, 0x1c, 0x00, 0x00,
    0x00, 0x00, 0xd0, 0xff, 0xff, 0xff, 0xff, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa4, 0xdd, 0xbe, 0x04, 0x00, 0x90,
    0x4b, 0x00, 0x40, 0x5e, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd4, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x99, 0x00, 0x00, 0x00, 0x00, 0xa2, 0x0a, 0x00, 0x00, 0xb0, 0xff,
    0x9f, 0x02, 0x00, 0x00, 0x00, 0x00, 0x51, 0x8d, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x03, 0x00, 0x00, 0x00, 0x00,
    0x80, 0x07, 0x00, 0x00, 0x00, 0x00, 0x90, 0x07, 0x00, 0x00, 0x00, 0x00, 0xe1, 0x02, 0x90, 0x03, 0x00, 0x40, 0x7d,
    0x00, 0x50, 0xea, 0xee, 0xad, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x1f, 0x00, 0x00, 0x00,
    0x00, 0xc2, 0x1b, 0x00, 0x00, 0x00, 0x00, 0x2d, 0x1b, 0x00, 0x00, 0x00, 0x90, 0x06, 0x1b, 0x00, 0x00, 0x00, 0xb5,
    0x00, 0x1d, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x1d, 0x00, 0x00, 0xc0, 0x04, 0x00, 0x1d, 0x00, 0x00, 0x88, 0x00, 0x00,
    0x1d, 0x00, 0x30, 0x0c, 0x00, 0x00, 0x1d, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x1d, 0x00, 0xf8, 0xdd, 0xdd, 0xdd, 0xdf,
    0xad, 0x00, 0x00, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1d, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf8, 0xff, 0xff, 0xbf, 0x00, 0x00, 0x69, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x5b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1d, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0xcf, 0xdd, 0xbe, 0x05, 0x00, 0x00, 0x02, 0x00, 0x30, 0xac,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x04, 0x00, 0x00, 0x00, 0x00, 0x70, 0x09, 0x00, 0x00, 0x00, 0x00, 0x50, 0x09,
    0x00, 0x00, 0x00, 0x00, 0x80, 0x08, 0x00, 0x00, 0x00, 0x00, 0xe1, 0x02, 0x50, 0x16, 0x00, 0x40, 0x6d, 0x00, 0x20,
    0xd9, 0xde, 0xae, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x91, 0xdd, 0x9d, 0x00, 0x00, 0x40, 0x5d, 0x00,
    0x00, 0x00, 0x00, 0xe2, 0x02, 0x00, 0x00, 0x00, 0x00, 0x5b, 0x00, 0x00, 0x00, 0x00, 0x10, 0x0e, 0x00, 0x00, 0x00,
    0x00, 0x50, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x80, 0x17, 0xd9, 0xdd, 0x19, 0x00, 0x90, 0xb8, 0x03, 0x00, 0xd6, 0x01,
    0x90, 0x0e, 0x00, 0x00, 0x80, 0x08, 0x90, 0x08, 0x00, 0x00, 0x30, 0x0c, 0x70, 0x08, 0x00, 0x00, 0x30, 0x0d, 0x30,
    0x0c, 0x00, 0x00, 0x40, 0x0b, 0x00, 0x4d, 0x00, 0x00, 0xa0, 0x06, 0x00, 0xe2, 0x06, 0x00, 0xb9, 0x00, 0x00, 0x20,
    0xea, 0xdd, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xff, 0xff, 0xff, 0xff, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x90,
    0x07, 0x00, 0x00, 0x00, 0x00, 0xe1, 0x01, 0x00, 0x00, 0x00, 0x00, 0x97, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2e, 0x00,
    0x00, 0x00, 0x00, 0x50, 0x0b, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x04, 0x00, 0x00, 0x00, 0x00, 0xd3, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x6a, 0x00, 0x00, 0x00, 0x00, 0x20, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x90, 0x08, 0x00, 0x00, 0x00, 0x00,
    0xf0, 0x02, 0x00, 0x00, 0x00, 0x00, 0xa7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4e, 0x00, 0x00, 0x00, 0x00, 0x50, 0x0d,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0xec, 0xce, 0x06, 0x00, 0x00, 0xb8, 0x02, 0x20, 0x7c, 0x00,
    0x10, 0x0e, 0x00, 0x00, 0xe1, 0x00, 0x30, 0x0b, 0x00, 0x00, 0xd0, 0x03, 0x20, 0x0d, 0x00, 0x00, 0xe0, 0x01, 0x00,
    0x8b, 0x00, 0x00, 0x97, 0x00, 0x00, 0xa0, 0x3b, 0xa2, 0x09, 0x00, 0x00, 0x00, 0xeb, 0xaf, 0x00, 0x00, 0x00, 0xc5,
    0x05, 0x81, 0x5e, 0x00, 0x30, 0x1d, 0x00, 0x00, 0xe1, 0x03, 0xa0, 0x06, 0x00, 0x00, 0x60, 0x09, 0xb0, 0x04, 0x00,
    0x00, 0x50, 0x0b, 0x80, 0x08, 0x00, 0x00, 0xa0, 0x07, 0x10, 0x7d, 0x00, 0x10, 0xd9, 0x00, 0x00, 0x91, 0xed, 0xce,
    0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xed, 0xae, 0x02, 0x00, 0x00, 0x9a, 0x01, 0x50, 0x2e, 0x00, 0x50,
    0x0b, 0x00, 0x00, 0xc3, 0x00, 0xa0, 0x04, 0x00, 0x00, 0xb0, 0x03, 0xd0, 0x03, 0x00, 0x00, 0x70, 0x07, 0xc0, 0x03,
    0x00, 0x00, 0x80, 0x09, 0x90, 0x08, 0x00, 0x00, 0xe1, 0x09, 0x10, 0x6d, 0x00, 0x30, 0x8b, 0x09, 0x00, 0x91, 0xdd,
    0x9c, 0x71, 0x07, 0x00, 0x00, 0x00, 0x00, 0xa0, 0x05, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x01, 0x00, 0x00, 0x00, 0x00,
    0xb6, 0x00, 0x00, 0x00, 0x00, 0x20, 0x3e, 0x00, 0x00, 0x00, 0x00, 0xe5, 0x04, 0x00, 0x00, 0xdc, 0xdd, 0x19, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x2f, 0x00, 0xf3, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x3f, 0x00, 0xf3,
    0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x2f, 0x00, 0xf3, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x1f, 0x00, 0xc5, 0x00, 0x80,
    0x07, 0x00, 0x1c, 0x00, 0xa0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x40, 0x0a, 0x00, 0x00, 0x00, 0x30, 0xac, 0x02, 0x00, 0x00, 0x30, 0xab, 0x02, 0x00, 0x00,
    0x30, 0xab, 0x02, 0x00, 0x00, 0x20, 0xaa, 0x02, 0x00, 0x00, 0x00, 0xb0, 0x4d, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa3,
    0x5c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x81, 0x7d, 0x01, 0x00, 0x00, 0x00, 0x00, 0x70, 0x9d, 0x02, 0x00, 0x00, 0x00,
    0x00, 0x50, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0xdd, 0xdd, 0xdd, 0xdd, 0x0b, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0xdd, 0xdd,
    0xdd, 0xdd, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa0, 0x04,
    0x00, 0x00, 0x00, 0x00, 0x20, 0xca, 0x03, 0x00, 0x00, 0x00, 0x00, 0x20, 0xba, 0x03, 0x00, 0x00, 0x00, 0x00, 0x20,
    0xba, 0x03, 0x00, 0x00, 0x00, 0x00, 0x20, 0xba, 0x02, 0x00, 0x00, 0x00, 0x00, 0xc3, 0x0b, 0x00, 0x00, 0x00, 0xc5,
    0x3a, 0x00, 0x00, 0x10, 0xd7, 0x19, 0x00, 0x00, 0x20, 0xd9, 0x07, 0x00, 0x00, 0x00, 0xa0, 0x05, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0xc7, 0xdd, 0x7c,
    0x00, 0x61, 0x00, 0x10, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x0e, 0x00, 0x00, 0x00, 0xb0, 0x03, 0x00, 0x00, 0x00, 0x1d,
    0x00, 0x00, 0x00, 0xa7, 0x00, 0x00, 0x00, 0xb7, 0x00, 0x00, 0x00, 0x9a, 0x00, 0x00, 0x00, 0x97, 0x00, 0x00, 0x00,
    0xc0, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf2,
    0x03, 0x00, 0x00, 0x20, 0x3f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0xd9, 0xde, 0xbe, 0x06, 0x00, 0x00, 0x00, 0x00, 0xc2, 0x39,
    0x00, 0x00, 0x93, 0x2d, 0x00, 0x00, 0x00, 0xd3, 0x03, 0x00, 0x00, 0x00, 0x30, 0x2e, 0x00, 0x00, 0xd1, 0x01, 0x00,
    0x00, 0x00, 0x00, 0x40, 0x0c, 0x00, 0xa0, 0x04, 0x00, 0xb3, 0xdd, 0xad, 0x00, 0xb0, 0x03, 0x20, 0x0c, 0x00, 0xc4,
    0x02, 0x00, 0x0f, 0x00, 0x85, 0x00, 0x77, 0x00, 0xe0, 0x02, 0x00, 0xf0, 0x00, 0x20, 0x0b, 0xa0, 0x04, 0x40, 0x0c,
    0x00, 0x00, 0x0f, 0x00, 0xb1, 0x00, 0x1b, 0x00, 0x96, 0x00, 0x00, 0xd1, 0x00, 0x10, 0x0b, 0xb0, 0x01, 0x60, 0x09,
    0x00, 0x30, 0x0d, 0x00, 0x93, 0x00, 0x3b, 0x00, 0xc4, 0x00, 0x00, 0xd8, 0x00, 0x80, 0x05, 0x80, 0x06, 0x00, 0x5d,
    0x00, 0xa4, 0x3b, 0x30, 0x0c, 0x00, 0xb3, 0x00, 0x20, 0xdb, 0x9d, 0x20, 0xdc, 0x1b, 0x00, 0x00, 0x4c, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x3d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x9d, 0x03,
    0x00, 0x30, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb6, 0xee, 0xde, 0x6a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x01, 0x00, 0x00, 0x00, 0x00, 0x60, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x6c,
    0x0d, 0x00, 0x00, 0x00, 0x00, 0xd3, 0xc0, 0x04, 0x00, 0x00, 0x00, 0xa0, 0x07, 0xb6, 0x00, 0x00, 0x00, 0x10, 0x1f,
    0x00, 0x1f, 0x00, 0x00, 0x00, 0xb7, 0x00, 0xa0, 0x08, 0x00, 0x00, 0xd0, 0x04, 0x00, 0xe4, 0x00, 0x00, 0x40, 0x0e,
    0x00, 0x00, 0x5d, 0x00, 0x00, 0xfb, 0xff, 0xff, 0xff, 0x0b, 0x00, 0xf1, 0x01, 0x00, 0x00, 0xf1, 0x02, 0x80, 0x0a,
    0x00, 0x00, 0x00, 0x8a, 0x00, 0x3e, 0x00, 0x00, 0x00, 0x30, 0x0e, 0xc5, 0x00, 0x00, 0x00, 0x00, 0xc0, 0xc6, 0x05,
    0x00, 0x00, 0x00, 0x00, 0xc6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xdd, 0xed, 0xbe, 0x06, 0x00,
    0x00, 0x1d, 0x00, 0x00, 0xc4, 0x0a, 0x00, 0xd0, 0x01, 0x00, 0x00, 0xe0, 0x03, 0x00, 0x1d, 0x00, 0x00, 0x00, 0x6a,
    0x00, 0xd0, 0x01, 0x00, 0x00, 0xa0, 0x06, 0x00, 0x1d, 0x00, 0x00, 0x00, 0x2e, 0x00, 0xd0, 0x01, 0x00, 0x40, 0x6b,
    0x00, 0x00, 0xdd, 0xdd, 0xfd, 0x5d, 0x00, 0x00, 0xd0, 0x01, 0x00, 0x20, 0xc9, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x00,
    0x99, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x40, 0x0c, 0x00, 0x1d, 0x00, 0x00, 0x00, 0xc5, 0x00, 0xd0, 0x01, 0x00, 0x00,
    0xa0, 0x08, 0x00, 0x1d, 0x00, 0x00, 0x92, 0x0d, 0x00, 0xd0, 0xdd, 0xdd, 0xce, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc7, 0xfe, 0xce, 0x17, 0x00, 0x30, 0x9e, 0x02, 0x00, 0x83, 0x00, 0x20, 0x4e,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x7c, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x0a,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x79, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x79,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x5d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x3e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x8e, 0x02, 0x00, 0x32, 0x00,
    0x00, 0x10, 0xd9, 0xff, 0xce, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xde, 0xed, 0xce,
    0x17, 0x00, 0x00, 0x00, 0x3d, 0x00, 0x00, 0x93, 0x5e, 0x00, 0x00, 0xd0, 0x03, 0x00, 0x00, 0x30, 0x4e, 0x00, 0x00,
    0x3d, 0x00, 0x00, 0x00, 0x50, 0x0d, 0x00, 0xd0, 0x03, 0x00, 0x00, 0x00, 0xe0, 0x03, 0x00, 0x3d, 0x00, 0x00, 0x00,
    0x00, 0x7a, 0x00, 0xd0, 0x03, 0x00, 0x00, 0x00, 0x70, 0x09, 0x00, 0x3d, 0x00, 0x00, 0x00, 0x00, 0x97, 0x00, 0xd0,
    0x03, 0x00, 0x00, 0x00, 0x80, 0x09, 0x00, 0x3d, 0x00, 0x00, 0x00, 0x00, 0x6a, 0x00, 0xd0, 0x03, 0x00, 0x00, 0x00,
    0xe0, 0x02, 0x00, 0x3d, 0x00, 0x00, 0x00, 0x70, 0x0c, 0x00, 0xd0, 0x03, 0x00, 0x00, 0x50, 0x2e, 0x00, 0x00, 0x3d,
    0x00, 0x00, 0xa4, 0x3d, 0x00, 0x00, 0xd0, 0xde, 0xed, 0xad, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfb, 0xff, 0xff, 0xff, 0x0b, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x3b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x3b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfb, 0xff, 0xff, 0xff, 0x03, 0x00, 0x3b,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3b, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfb, 0xff, 0xff,
    0xff, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0xff, 0xff, 0xff, 0xbf, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x03, 0x00, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00,
    0x00, 0xb0, 0x03, 0x00, 0x00, 0x00, 0x00, 0xfb, 0xff, 0xff, 0xff, 0x05, 0xb0, 0x03, 0x00, 0x00, 0x00, 0x00, 0x3b,
    0x00, 0x00, 0x00, 0x00, 0xb0, 0x03, 0x00, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x03, 0x00, 0x00,
    0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa5, 0xfe,
    0xdf, 0x5a, 0x00, 0x00, 0x10, 0xac, 0x03, 0x00, 0x51, 0x0a, 0x00, 0x10, 0x6e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x8a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x0a, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x79, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0x07, 0x00, 0x10, 0xff, 0xff, 0x5f, 0x00, 0x79,
    0x00, 0x00, 0x00, 0x00, 0xb0, 0x05, 0x70, 0x09, 0x00, 0x00, 0x00, 0x00, 0x5b, 0x00, 0xd3, 0x00, 0x00, 0x00, 0x00,
    0xb0, 0x05, 0x00, 0x5d, 0x00, 0x00, 0x00, 0x00, 0x5b, 0x00, 0x40, 0x3e, 0x00, 0x00, 0x00, 0xb0, 0x05, 0x00, 0x50,
    0x8e, 0x03, 0x00, 0x30, 0x5d, 0x00, 0x00, 0x10, 0xc7, 0xee, 0xde, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x1d, 0x00,
    0x00, 0x00, 0x10, 0x0d, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x00, 0x10, 0x0d,
    0x00, 0xd0, 0x01, 0x00, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x00, 0x10, 0x0d, 0x00, 0xd0, 0x01, 0x00,
    0x00, 0x00, 0xd1, 0x00, 0x00, 0xfd, 0xff, 0xff, 0xff, 0xff, 0x0d, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x00, 0xd1, 0x00,
    0x00, 0x1d, 0x00, 0x00, 0x00, 0x10, 0x0d, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x1d, 0x00, 0x00,
    0x00, 0x10, 0x0d, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x00, 0x10, 0x0d, 0x00,
    0xd0, 0x01, 0x00, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00,
    0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0,
    0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1f, 0x00,
    0x00, 0x1f, 0x00, 0x00, 0x1f, 0x00, 0x00, 0x1f, 0x00, 0x00, 0x1f, 0x00, 0x00, 0x1f, 0x00, 0x00, 0x1f, 0x00, 0x00,
    0x1f, 0x00, 0x00, 0x1f, 0x00, 0x00, 0x1f, 0x00, 0x00, 0x1f, 0x00, 0x00, 0x1f, 0x00, 0x00, 0x1f, 0x00, 0x00, 0x1f,
    0x00, 0x00, 0x1f, 0x00, 0x00, 0x1f, 0x00, 0x10, 0x0e, 0x00, 0xb1, 0x08, 0xfd, 0x8e, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x10, 0x5d, 0x00, 0x1d, 0x00, 0x00, 0xd0,
    0x06, 0x00, 0x1d, 0x00, 0x00, 0x6b, 0x00, 0x00, 0x1d, 0x00, 0xb0, 0x07, 0x00, 0x00, 0x1d, 0x00, 0x8a, 0x00, 0x00,
    0x00, 0x1d, 0x90, 0x08, 0x00, 0x00, 0x00, 0x1d, 0xf8, 0x00, 0x00, 0x00, 0x00, 0xad, 0x99, 0x09, 0x00, 0x00, 0x00,
    0x8d, 0x00, 0x5d, 0x00, 0x00, 0x00, 0x1d, 0x00, 0xe3, 0x01, 0x00, 0x00, 0x1d, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x1d,
    0x00, 0x00, 0x7b, 0x00, 0x00, 0x1d, 0x00, 0x00, 0xe1, 0x03, 0x00, 0x1d, 0x00, 0x00, 0x50, 0x0d, 0x00, 0x1d, 0x00,
    0x00, 0x00, 0x99, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x03, 0x00, 0x00, 0x00, 0x00, 0x3d, 0x00, 0x00, 0x00, 0x00, 0xd0,
    0x03, 0x00, 0x00, 0x00, 0x00, 0x3d, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x03, 0x00, 0x00, 0x00, 0x00, 0x3d, 0x00, 0x00,
    0x00, 0x00, 0xd0, 0x03, 0x00, 0x00, 0x00, 0x00, 0x3d, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x03, 0x00, 0x00, 0x00, 0x00,
    0x3d, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x03, 0x00, 0x00, 0x00, 0x00, 0x3d, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x03, 0x00,
    0x00, 0x00, 0x00, 0x3d, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xff, 0xff, 0xff, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xed,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xdd, 0x00, 0x00, 0xcd, 0x04, 0x00, 0x00, 0x00, 0x40, 0xdc, 0x00, 0x00, 0x7d, 0x0b,
    0x00, 0x00, 0x00, 0xa0, 0xd7, 0x00, 0x00, 0x2d, 0x1e, 0x00, 0x00, 0x00, 0xe1, 0xd2, 0x00, 0x00, 0x1d, 0x88, 0x00,
    0x00, 0x00, 0x87, 0xd1, 0x00, 0x00, 0x1d, 0xe2, 0x00, 0x00, 0x00, 0x2d, 0xd1, 0x00, 0x00, 0x1d, 0xb0, 0x04, 0x00,
    0x40, 0x0b, 0xd1, 0x00, 0x00, 0x1d, 0x50, 0x0b, 0x00, 0xa0, 0x05, 0xd1, 0x00, 0x00, 0x1d, 0x00, 0x1e, 0x00, 0xe1,
    0x00, 0xd1, 0x00, 0x00, 0x1d, 0x00, 0x88, 0x00, 0x87, 0x00, 0xd1, 0x00, 0x00, 0x1d, 0x00, 0xe1, 0x00, 0x2d, 0x00,
    0xd1, 0x00, 0x00, 0x1d, 0x00, 0xb0, 0x44, 0x0b, 0x00, 0xd1, 0x00, 0x00, 0x1d, 0x00, 0x40, 0xab, 0x04, 0x00, 0xd1,
    0x00, 0x00, 0x1d, 0x00, 0x00, 0xde, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x88, 0x00, 0x00, 0xd1, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x07, 0x00, 0x00, 0x00, 0xd1, 0x00, 0x00, 0xed, 0x02, 0x00, 0x00, 0x10, 0x0d,
    0x00, 0xd0, 0xc5, 0x00, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x0d, 0x6b, 0x00, 0x00, 0x10, 0x0d, 0x00, 0xd0, 0x11, 0x2e,
    0x00, 0x00, 0xd1, 0x00, 0x00, 0x1d, 0x60, 0x0c, 0x00, 0x10, 0x0d, 0x00, 0xd0, 0x01, 0xb0, 0x06, 0x00, 0xd1, 0x00,
    0x00, 0x1d, 0x00, 0xe1, 0x01, 0x10, 0x0d, 0x00, 0xd0, 0x01, 0x00, 0xb6, 0x00, 0xd1, 0x00, 0x00, 0x1d, 0x00, 0x00,
    0x6c, 0x10, 0x0d, 0x00, 0xd0, 0x01, 0x00, 0x20, 0x1e, 0xd1, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x60, 0x1a, 0x0d, 0x00,
    0xd0, 0x01, 0x00, 0x00, 0xc0, 0xd6, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x00, 0xe2, 0x0d, 0x00, 0xd0, 0x01, 0x00, 0x00,
    0x00, 0xd7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x91, 0xfd, 0xdf, 0x29, 0x00, 0x00, 0x00, 0x60, 0x7e, 0x02, 0x20, 0xe7, 0x06, 0x00, 0x00, 0xe4, 0x02, 0x00,
    0x00, 0x20, 0x4e, 0x00, 0x00, 0x5d, 0x00, 0x00, 0x00, 0x00, 0xd4, 0x00, 0x30, 0x0d, 0x00, 0x00, 0x00, 0x00, 0xd0,
    0x03, 0x70, 0x09, 0x00, 0x00, 0x00, 0x00, 0x90, 0x07, 0x90, 0x07, 0x00, 0x00, 0x00, 0x00, 0x70, 0x09, 0x90, 0x07,
    0x00, 0x00, 0x00, 0x00, 0x70, 0x09, 0x90, 0x07, 0x00, 0x00, 0x00, 0x00, 0x70, 0x09, 0x70, 0x09, 0x00, 0x00, 0x00,
    0x00, 0x90, 0x07, 0x30, 0x0d, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x03, 0x00, 0x4d, 0x00, 0x00, 0x00, 0x00, 0xd4, 0x00,
    0x00, 0xe4, 0x02, 0x00, 0x00, 0x20, 0x4e, 0x00, 0x00, 0x60, 0x7e, 0x01, 0x10, 0xe6, 0x06, 0x00, 0x00, 0x00, 0x92,
    0xfd, 0xdf, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xfd, 0xff, 0xcf, 0x08, 0x00, 0x00, 0x1d, 0x00, 0x20, 0xd9, 0x00, 0x00, 0x1d, 0x00, 0x00, 0xa0,
    0x08, 0x00, 0x1d, 0x00, 0x00, 0x40, 0x0c, 0x00, 0x1d, 0x00, 0x00, 0x30, 0x0d, 0x00, 0x1d, 0x00, 0x00, 0x50, 0x0c,
    0x00, 0x1d, 0x00, 0x00, 0xb0, 0x06, 0x00, 0x1d, 0x00, 0x40, 0xab, 0x00, 0x00, 0xdd, 0xdd, 0xad, 0x04, 0x00, 0x00,
    0x1d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1d,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x91, 0xfd, 0xdf, 0x29, 0x00, 0x00, 0x00, 0x60, 0x7e, 0x02, 0x20, 0xe7, 0x06, 0x00,
    0x00, 0xe4, 0x02, 0x00, 0x00, 0x20, 0x4e, 0x00, 0x00, 0x5d, 0x00, 0x00, 0x00, 0x00, 0xd4, 0x00, 0x30, 0x0d, 0x00,
    0x00, 0x00, 0x00, 0xd0, 0x03, 0x70, 0x09, 0x00, 0x00, 0x00, 0x00, 0x90, 0x07, 0x90, 0x07, 0x00, 0x00, 0x00, 0x00,
    0x70, 0x09, 0x90, 0x07, 0x00, 0x00, 0x00, 0x00, 0x70, 0x09, 0x90, 0x07, 0x00, 0x00, 0x00, 0x00, 0x70, 0x09, 0x70,
    0x09, 0x00, 0x00, 0x00, 0x00, 0x90, 0x07, 0x30, 0x0d, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x03, 0x00, 0x4d, 0x00, 0x00,
    0x00, 0x00, 0xd4, 0x00, 0x00, 0xe4, 0x02, 0x00, 0x00, 0x20, 0x4e, 0x00, 0x00, 0x60, 0x7e, 0x01, 0x10, 0xe6, 0x06,
    0x00, 0x00, 0x00, 0x92, 0xfd, 0xff, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x08, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x10, 0xad, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd1, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xce, 0x07, 0x00, 0x00, 0x1f, 0x00, 0x20, 0xba, 0x00, 0x00,
    0x1f, 0x00, 0x00, 0xc0, 0x06, 0x00, 0x1f, 0x00, 0x00, 0x70, 0x0a, 0x00, 0x1f, 0x00, 0x00, 0x50, 0x0b, 0x00, 0x1f,
    0x00, 0x00, 0x80, 0x09, 0x00, 0x1f, 0x00, 0x00, 0xd0, 0x03, 0x00, 0x1f, 0x00, 0x40, 0x8c, 0x00, 0x00, 0xdf, 0xdd,
    0xee, 0x03, 0x00, 0x00, 0x1f, 0x00, 0xe0, 0x03, 0x00, 0x00, 0x1f, 0x00, 0x60, 0x0c, 0x00, 0x00, 0x1f, 0x00, 0x00,
    0x6c, 0x00, 0x00, 0x1f, 0x00, 0x00, 0xe3, 0x01, 0x00, 0x1f, 0x00, 0x00, 0x90, 0x09, 0x00, 0x1f, 0x00, 0x00, 0x00,
    0x3e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd8, 0xee, 0x9d, 0x02, 0x00, 0x8d, 0x01, 0x10, 0x36, 0x00, 0x97, 0x00, 0x00,
    0x00, 0x00, 0xb0, 0x05, 0x00, 0x00, 0x00, 0x00, 0x6a, 0x00, 0x00, 0x00, 0x00, 0x40, 0x2e, 0x00, 0x00, 0x00, 0x00,
    0x60, 0x9e, 0x02, 0x00, 0x00, 0x00, 0x10, 0xd7, 0x5c, 0x00, 0x00, 0x00, 0x00, 0x30, 0xcb, 0x01, 0x00, 0x00, 0x00,
    0x00, 0xa9, 0x00, 0x00, 0x00, 0x00, 0x20, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xf2, 0x00, 0x00, 0x00, 0x00, 0x80, 0x0b,
    0x60, 0x03, 0x00, 0x82, 0x2e, 0x00, 0xc7, 0xfe, 0xdf, 0x19, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xff, 0xff, 0xff, 0xff, 0xdf, 0x00, 0x00,
    0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00,
    0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf1, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x01, 0x10, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x1f, 0x00, 0xf1, 0x00,
    0x00, 0x00, 0x00, 0xf0, 0x01, 0x10, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x1f, 0x00, 0xf1, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x01, 0x10, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x1f, 0x00, 0xf1, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x01, 0x10, 0x0f, 0x00,
    0x00, 0x00, 0x00, 0x1f, 0x00, 0xf1, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x01, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x0f,
    0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x4c, 0x00, 0x00, 0x00, 0x40, 0x0c, 0x00, 0x50, 0x0c, 0x00,
    0x00, 0x00, 0x5c, 0x00, 0x00, 0xa0, 0x4c, 0x00, 0x30, 0x9c, 0x00, 0x00, 0x00, 0x50, 0xeb, 0xed, 0x4b, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x4c, 0x00, 0x00, 0x00, 0x00, 0xc4,
    0xa6, 0x00, 0x00, 0x00, 0x00, 0x6a, 0xe1, 0x00, 0x00, 0x00, 0x00, 0x1e, 0xa0, 0x05, 0x00, 0x00, 0x60, 0x0a, 0x50,
    0x0b, 0x00, 0x00, 0xb0, 0x05, 0x00, 0x1e, 0x00, 0x00, 0xe1, 0x00, 0x00, 0x79, 0x00, 0x00, 0x97, 0x00, 0x00, 0xd3,
    0x00, 0x00, 0x3d, 0x00, 0x00, 0xd0, 0x03, 0x30, 0x0d, 0x00, 0x00, 0x70, 0x09, 0x80, 0x07, 0x00, 0x00, 0x10, 0x0e,
    0xe0, 0x01, 0x00, 0x00, 0x00, 0x4b, 0xb4, 0x00, 0x00, 0x00, 0x00, 0x95, 0x59, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x0e,
    0x00, 0x00, 0x00, 0x00, 0xa0, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x0c, 0x00, 0x00,
    0x30, 0x2f, 0x00, 0x00, 0x00, 0x4b, 0xf0, 0x00, 0x00, 0x00, 0xc8, 0x07, 0x00, 0x00, 0xe0, 0x00, 0x5b, 0x00, 0x00,
    0xd0, 0xb5, 0x00, 0x00, 0x40, 0x0b, 0x70, 0x09, 0x00, 0x10, 0x0d, 0x0e, 0x00, 0x00, 0x78, 0x00, 0xd3, 0x00, 0x00,
    0x96, 0x90, 0x05, 0x00, 0xc0, 0x03, 0x00, 0x2e, 0x00, 0xa0, 0x04, 0x95, 0x00, 0x10, 0x0e, 0x00, 0xa0, 0x06, 0x00,
    0x0e, 0x00, 0x0e, 0x00, 0x95, 0x00, 0x00, 0xb5, 0x00, 0xb3, 0x00, 0xb0, 0x03, 0x90, 0x05, 0x00, 0x10, 0x0e, 0x80,
    0x07, 0x00, 0x77, 0x00, 0x1e, 0x00, 0x00, 0xc0, 0x03, 0x2d, 0x00, 0x20, 0x0c, 0xc2, 0x00, 0x00, 0x00, 0x88, 0xd1,
    0x00, 0x00, 0xd0, 0x71, 0x08, 0x00, 0x00, 0x30, 0x5c, 0x09, 0x00, 0x00, 0x59, 0x3b, 0x00, 0x00, 0x00, 0xe0, 0x4a,
    0x00, 0x00, 0x40, 0xea, 0x00, 0x00, 0x00, 0x00, 0xea, 0x00, 0x00, 0x00, 0xe0, 0x0a, 0x00, 0x00, 0x00, 0x60, 0x0b,
    0x00, 0x00, 0x00, 0x6b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x0d, 0x00, 0x00, 0x00, 0x4c, 0x90, 0x08,
    0x00, 0x00, 0xa6, 0x00, 0xe0, 0x02, 0x00, 0xd1, 0x01, 0x00, 0xb5, 0x00, 0xa0, 0x06, 0x00, 0x00, 0x5b, 0x30, 0x0c,
    0x00, 0x00, 0x20, 0x1e, 0x2d, 0x00, 0x00, 0x00, 0x70, 0x8d, 0x00, 0x00, 0x00, 0x00, 0xf4, 0x05, 0x00, 0x00, 0x00,
    0xd0, 0xd6, 0x00, 0x00, 0x00, 0x80, 0x08, 0x88, 0x00, 0x00, 0x20, 0x0d, 0x00, 0x2d, 0x00, 0x00, 0x5c, 0x00, 0x50,
    0x0c, 0x00, 0xb6, 0x00, 0x00, 0xb0, 0x06, 0xe1, 0x01, 0x00, 0x00, 0xe1, 0xa1, 0x07, 0x00, 0x00, 0x00, 0xa7, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0,
    0x07, 0x00, 0x00, 0x00, 0xb5, 0xe2, 0x00, 0x00, 0x00, 0xe0, 0x02, 0x7a, 0x00, 0x00, 0x60, 0x0a, 0x10, 0x1e, 0x00,
    0x00, 0x1e, 0x00, 0x90, 0x08, 0x00, 0x87, 0x00, 0x00, 0xe1, 0x01, 0xe1, 0x01, 0x00, 0x00, 0x97, 0x80, 0x07, 0x00,
    0x00, 0x00, 0x4e, 0x0d, 0x00, 0x00, 0x00, 0x60, 0x6f, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x0f, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0xff, 0xff, 0xff, 0xff, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x06,
    0x00, 0x00, 0x00, 0x00, 0xc6, 0x00, 0x00, 0x00, 0x00, 0x20, 0x2e, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x07, 0x00, 0x00,
    0x00, 0x00, 0xc6, 0x00, 0x00, 0x00, 0x00, 0x10, 0x2e, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x07, 0x00, 0x00, 0x00, 0x00,
    0xc6, 0x00, 0x00, 0x00, 0x00, 0x10, 0x2e, 0x00, 0x00, 0x00, 0x00, 0xa0, 0x08, 0x00, 0x00, 0x00, 0x00, 0xd5, 0x00,
    0x00, 0x00, 0x00, 0x10, 0x3e, 0x00, 0x00, 0x00, 0x00, 0xa0, 0x08, 0x00, 0x00, 0x00, 0x00, 0xf1, 0xff, 0xff, 0xff,
    0xff, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xf1, 0xff, 0x7f, 0x10, 0x0d, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0xd1,
    0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x10, 0x0d, 0x00,
    0x00, 0xd1, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x10,
    0x0d, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x10, 0xff, 0xff, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x80, 0x07, 0x00, 0x00, 0xd2, 0x00, 0x00, 0x00, 0x2d, 0x00, 0x00, 0x70, 0x08, 0x00, 0x00,
    0xe1, 0x00, 0x00, 0x00, 0x4b, 0x00, 0x00, 0x50, 0x0a, 0x00, 0x00, 0xe0, 0x00, 0x00, 0x00, 0x59, 0x00, 0x00, 0x40,
    0x0b, 0x00, 0x00, 0xe0, 0x01, 0x00, 0x00, 0x78, 0x00, 0x00, 0x20, 0x0d, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0x87,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xff, 0xff, 0x01, 0x00, 0x00, 0x1d, 0x00, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x1d,
    0x00, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x1d, 0x00, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x1d, 0x00, 0x00, 0xd0, 0x01, 0x00,
    0x00, 0x1d, 0x00, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x1d, 0x00, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x1d, 0x00, 0x00, 0xd0,
    0x01, 0x00, 0x00, 0x1d, 0x00, 0x00, 0xd0, 0x01, 0xf7, 0xff, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x00, 0x00, 0xd1, 0x2c,
    0x00, 0x00, 0x00, 0x00, 0x49, 0xa4, 0x00, 0x00, 0x00, 0x20, 0x0c, 0xc0, 0x02, 0x00, 0x00, 0xa0, 0x04, 0x30, 0x0b,
    0x00, 0x00, 0xb3, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x3b, 0x00, 0x00, 0xc3, 0x00, 0x40, 0x0a, 0x00, 0x00, 0xa0, 0x04,
    0xc0, 0x02, 0x00, 0x00, 0x20, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xdd, 0xdd, 0xdd, 0xdd, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xba, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x87, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa4, 0xdd, 0x9d, 0x00, 0x00, 0x60, 0x04, 0x00, 0xa8, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x1e, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x03, 0x00, 0x00, 0x00, 0x00, 0x39, 0x00, 0x10, 0xb7,
    0xdd, 0xfd, 0x03, 0x20, 0x7d, 0x02, 0x00, 0x3b, 0x00, 0x5c, 0x00, 0x00, 0xb0, 0x03, 0xf0, 0x01, 0x00, 0x00, 0x3e,
    0x00, 0x2e, 0x00, 0x00, 0xf5, 0x03, 0x80, 0x1b, 0x00, 0xc6, 0x3b, 0x00, 0x80, 0xee, 0x8d, 0x80, 0x03, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x10,
    0x0f, 0x00, 0x00, 0x00, 0x00, 0x10, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x10, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x10, 0x0f,
    0xd7, 0xee, 0x4b, 0x00, 0x10, 0xad, 0x08, 0x00, 0xd3, 0x06, 0x10, 0x9f, 0x00, 0x00, 0x10, 0x1e, 0x10, 0x3f, 0x00,
    0x00, 0x00, 0x6a, 0x10, 0x0f, 0x00, 0x00, 0x00, 0x96, 0x10, 0x0f, 0x00, 0x00, 0x00, 0xb5, 0x10, 0x0f, 0x00, 0x00,
    0x00, 0xb5, 0x10, 0x0f, 0x00, 0x00, 0x00, 0x96, 0x10, 0x3f, 0x00, 0x00, 0x00, 0x6a, 0x10, 0x9f, 0x00, 0x00, 0x20,
    0x0e, 0x10, 0xac, 0x07, 0x00, 0xd3, 0x05, 0x10, 0x0a, 0xc6, 0xed, 0x3b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0xea, 0xed, 0x1b, 0x00, 0xd4,
    0x05, 0x00, 0x03, 0x00, 0x2e, 0x00, 0x00, 0x00, 0x60, 0x0a, 0x00, 0x00, 0x00, 0xa0, 0x06, 0x00, 0x00, 0x00, 0xb0,
    0x04, 0x00, 0x00, 0x00, 0xb0, 0x03, 0x00, 0x00, 0x00, 0xa0, 0x06, 0x00, 0x00, 0x00, 0x60, 0x0a, 0x00, 0x00, 0x00,
    0x10, 0x2e, 0x00, 0x00, 0x00, 0x00, 0xd5, 0x04, 0x00, 0x03, 0x00, 0x30, 0xeb, 0xed, 0x0b, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x40, 0xeb, 0xde, 0x07, 0x0f, 0x00,
    0xd5, 0x03, 0x00, 0xa8, 0x0d, 0x00, 0x2e, 0x00, 0x00, 0x90, 0x0f, 0x60, 0x0a, 0x00, 0x00, 0x30, 0x0f, 0x90, 0x06,
    0x00, 0x00, 0x00, 0x0f, 0xb0, 0x05, 0x00, 0x00, 0x00, 0x0f, 0xb0, 0x05, 0x00, 0x00, 0x00, 0x0f, 0xa0, 0x06, 0x00,
    0x00, 0x00, 0x0f, 0x70, 0x09, 0x00, 0x00, 0x30, 0x0f, 0x10, 0x1e, 0x00, 0x00, 0x90, 0x0f, 0x00, 0xd6, 0x03, 0x00,
    0xa7, 0x0c, 0x00, 0x40, 0xeb, 0xdd, 0x06, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0xea, 0xdd, 0x07, 0x00, 0x00, 0xd3,
    0x04, 0x10, 0x9a, 0x00, 0x00, 0x2d, 0x00, 0x00, 0xd0, 0x03, 0x50, 0x0a, 0x00, 0x00, 0x70, 0x08, 0x90, 0x06, 0x00,
    0x00, 0x50, 0x0b, 0xb0, 0xde, 0xdd, 0xdd, 0xdd, 0x0a, 0xb0, 0x05, 0x00, 0x00, 0x00, 0x00, 0x90, 0x07, 0x00, 0x00,
    0x00, 0x00, 0x50, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3e, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe4, 0x06, 0x00, 0x50,
    0x01, 0x00, 0x20, 0xe9, 0xed, 0x8c, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xde, 0x2e, 0x00, 0xb6, 0x00, 0x00, 0x00, 0x4a, 0x00, 0x00, 0x00, 0x3b,
    0x00, 0x00, 0xc7, 0xef, 0xad, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00,
    0x3b, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00,
    0x00, 0x3b, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xa1, 0xcd, 0xfe, 0xbd, 0x07, 0xd1, 0x04, 0x00, 0xa9, 0x00, 0x70, 0x08, 0x00, 0x00, 0x0e, 0x00, 0x59,
    0x00, 0x00, 0xd0, 0x01, 0x70, 0x08, 0x00, 0x00, 0x0e, 0x00, 0xe1, 0x04, 0x00, 0x89, 0x00, 0x00, 0xd2, 0xcd, 0x6c,
    0x00, 0x00, 0x60, 0x07, 0x00, 0x00, 0x00, 0x00, 0x0e, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x03, 0x00, 0x00, 0x00, 0x00,
    0xf6, 0xff, 0xef, 0x2b, 0x00, 0x89, 0x01, 0x00, 0x61, 0x0e, 0xb4, 0x00, 0x00, 0x00, 0xb0, 0x75, 0x07, 0x00, 0x00,
    0x00, 0x5a, 0xa6, 0x00, 0x00, 0x00, 0xe0, 0x01, 0x6d, 0x00, 0x00, 0xc3, 0x07, 0x10, 0xd9, 0xdd, 0xad, 0x03, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x30, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x30, 0x0d,
    0x00, 0x00, 0x00, 0x00, 0x30, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x30, 0x0d, 0xd8, 0xee, 0x09, 0x00, 0x30, 0xbc, 0x05,
    0x00, 0xa9, 0x00, 0x30, 0x6f, 0x00, 0x00, 0xe0, 0x01, 0x30, 0x0f, 0x00, 0x00, 0xb0, 0x03, 0x30, 0x0d, 0x00, 0x00,
    0xb0, 0x05, 0x30, 0x0d, 0x00, 0x00, 0xb0, 0x05, 0x30, 0x0d, 0x00, 0x00, 0xb0, 0x05, 0x30, 0x0d, 0x00, 0x00, 0xb0,
    0x05, 0x30, 0x0d, 0x00, 0x00, 0xb0, 0x05, 0x30, 0x0d, 0x00, 0x00, 0xb0, 0x05, 0x30, 0x0d, 0x00, 0x00, 0xb0, 0x05,
    0x30, 0x0d, 0x00, 0x00, 0xb0, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x00, 0x00, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00,
    0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0,
    0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0e, 0x00, 0xe0, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0,
    0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00,
    0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x60, 0x0b, 0xfc, 0x2c, 0x00, 0x00, 0x00,
    0x10, 0x0d, 0x00, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00,
    0x00, 0x10, 0x0d, 0x00, 0x10, 0x3d, 0x10, 0x0d, 0x00, 0xc0, 0x05, 0x10, 0x0d, 0x00, 0x7a, 0x00, 0x10, 0x0d, 0x70,
    0x0a, 0x00, 0x10, 0x0d, 0xc4, 0x00, 0x00, 0x10, 0x2d, 0x9e, 0x00, 0x00, 0x10, 0xcc, 0xe3, 0x03, 0x00, 0x10, 0x2e,
    0x40, 0x0d, 0x00, 0x10, 0x0d, 0x00, 0x99, 0x00, 0x10, 0x0d, 0x00, 0xd0, 0x04, 0x10, 0x0d, 0x00, 0x30, 0x0d, 0x10,
    0x0d, 0x00, 0x00, 0xa8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0xf0,
    0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00,
    0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x0c, 0xe8, 0xde, 0x07, 0x80,
    0xee, 0x8e, 0x00, 0x00, 0xe1, 0x5a, 0x00, 0xb1, 0xb7, 0x06, 0x00, 0x9a, 0x00, 0x10, 0x6f, 0x00, 0x00, 0xf2, 0x08,
    0x00, 0x00, 0x0e, 0x00, 0xf1, 0x01, 0x00, 0x00, 0x3f, 0x00, 0x00, 0xc0, 0x02, 0x10, 0x0f, 0x00, 0x00, 0xf0, 0x01,
    0x00, 0x00, 0x3b, 0x00, 0xd1, 0x00, 0x00, 0x00, 0x1f, 0x00, 0x00, 0xb0, 0x03, 0x10, 0x0d, 0x00, 0x00, 0xf0, 0x01,
    0x00, 0x00, 0x3b, 0x00, 0xd1, 0x00, 0x00, 0x00, 0x1f, 0x00, 0x00, 0xb0, 0x03, 0x10, 0x0d, 0x00, 0x00, 0xf0, 0x01,
    0x00, 0x00, 0x3b, 0x00, 0xd1, 0x00, 0x00, 0x00, 0x1f, 0x00, 0x00, 0xb0, 0x03, 0x10, 0x0d, 0x00, 0x00, 0xf0, 0x01,
    0x00, 0x00, 0x3b, 0x00, 0xd1, 0x00, 0x00, 0x00, 0x1f, 0x00, 0x00, 0xb0, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30,
    0x0b, 0xd8, 0xee, 0x09, 0x00, 0x30, 0xbd, 0x05, 0x00, 0xa9, 0x00, 0x30, 0x6f, 0x00, 0x00, 0xe0, 0x01, 0x30, 0x0f,
    0x00, 0x00, 0xb0, 0x03, 0x30, 0x0d, 0x00, 0x00, 0xb0, 0x05, 0x30, 0x0d, 0x00, 0x00, 0xb0, 0x05, 0x30, 0x0d, 0x00,
    0x00, 0xb0, 0x05, 0x30, 0x0d, 0x00, 0x00, 0xb0, 0x05, 0x30, 0x0d, 0x00, 0x00, 0xb0, 0x05, 0x30, 0x0d, 0x00, 0x00,
    0xb0, 0x05, 0x30, 0x0d, 0x00, 0x00, 0xb0, 0x05, 0x30, 0x0d, 0x00, 0x00, 0xb0, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40,
    0xeb, 0xce, 0x04, 0x00, 0x00, 0xd6, 0x02, 0x30, 0x6d, 0x00, 0x10, 0x1e, 0x00, 0x00, 0xe1, 0x01, 0x70, 0x09, 0x00,
    0x00, 0x90, 0x07, 0xa0, 0x05, 0x00, 0x00, 0x50, 0x0a, 0xb0, 0x03, 0x00, 0x00, 0x30, 0x0b, 0xb0, 0x03, 0x00, 0x00,
    0x30, 0x0b, 0xa0, 0x05, 0x00, 0x00, 0x50, 0x0a, 0x70, 0x09, 0x00, 0x00, 0x90, 0x07, 0x10, 0x1e, 0x00, 0x00, 0xe1,
    0x01, 0x00, 0xd6, 0x03, 0x30, 0x6d, 0x00, 0x00, 0x40, 0xeb, 0xbe, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x0d, 0xc6,
    0xee, 0x4b, 0x00, 0x10, 0x9f, 0x18, 0x00, 0xd3, 0x06, 0x10, 0x9f, 0x00, 0x00, 0x10, 0x1e, 0x10, 0x2f, 0x00, 0x00,
    0x00, 0x6a, 0x10, 0x0f, 0x00, 0x00, 0x00, 0x96, 0x10, 0x0f, 0x00, 0x00, 0x00, 0xb5, 0x10, 0x0f, 0x00, 0x00, 0x00,
    0xb5, 0x10, 0x0f, 0x00, 0x00, 0x00, 0x96, 0x10, 0x3f, 0x00, 0x00, 0x00, 0x6a, 0x10, 0x9f, 0x00, 0x00, 0x20, 0x0e,
    0x10, 0xad, 0x08, 0x00, 0xd3, 0x05, 0x10, 0x0e, 0xc6, 0xee, 0x3b, 0x00, 0x10, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x10,
    0x0f, 0x00, 0x00, 0x00, 0x00, 0x10, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x10, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x10, 0x0f,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0xeb, 0xce,
    0x06, 0x0d, 0x00, 0xe5, 0x03, 0x00, 0xa8, 0x0f, 0x00, 0x2e, 0x00, 0x00, 0x90, 0x0f, 0x50, 0x0a, 0x00, 0x00, 0x30,
    0x0f, 0x90, 0x06, 0x00, 0x00, 0x00, 0x0f, 0xb0, 0x05, 0x00, 0x00, 0x00, 0x0f, 0xb0, 0x05, 0x00, 0x00, 0x00, 0x0f,
    0x90, 0x06, 0x00, 0x00, 0x00, 0x0f, 0x60, 0x09, 0x00, 0x00, 0x30, 0x0f, 0x10, 0x1e, 0x00, 0x00, 0x90, 0x0f, 0x00,
    0xd6, 0x03, 0x00, 0xa8, 0x0d, 0x00, 0x40, 0xeb, 0xce, 0x06, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x0b, 0xe8, 0x7f, 0x10, 0x9b, 0x06, 0x00, 0x10, 0x8e, 0x00, 0x00, 0x10,
    0x1f, 0x00, 0x00, 0x10, 0x0e, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00,
    0x10, 0x0d, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xc6, 0xee, 0xbe, 0x04, 0x70, 0x2b, 0x00, 0x40, 0x03, 0xc0, 0x02, 0x00, 0x00, 0x00, 0xb0,
    0x05, 0x00, 0x00, 0x00, 0x40, 0x5e, 0x00, 0x00, 0x00, 0x00, 0xa2, 0x8e, 0x02, 0x00, 0x00, 0x00, 0x71, 0x9e, 0x00,
    0x00, 0x00, 0x00, 0xa0, 0x09, 0x00, 0x00, 0x00, 0x10, 0x0e, 0x00, 0x00, 0x00, 0x20, 0x0d, 0x71, 0x02, 0x00, 0xc3,
    0x06, 0x80, 0xfc, 0xef, 0x5b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0xd1, 0x00, 0x00, 0xd7, 0xdf, 0xdd, 0x03, 0xd1, 0x00, 0x00,
    0x10, 0x0d, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0xd1,
    0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x7c, 0x00, 0x00, 0x20, 0xec, 0x6d, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x50, 0x0b, 0x00, 0x00, 0xd0, 0x03, 0x50, 0x0b, 0x00, 0x00, 0xd0, 0x03, 0x50, 0x0b, 0x00,
    0x00, 0xd0, 0x03, 0x50, 0x0b, 0x00, 0x00, 0xd0, 0x03, 0x50, 0x0b, 0x00, 0x00, 0xd0, 0x03, 0x50, 0x0b, 0x00, 0x00,
    0xd0, 0x03, 0x50, 0x0b, 0x00, 0x00, 0xd0, 0x03, 0x50, 0x0b, 0x00, 0x00, 0xd0, 0x03, 0x30, 0x0b, 0x00, 0x00, 0xf0,
    0x03, 0x10, 0x0e, 0x00, 0x00, 0xf5, 0x03, 0x00, 0x9a, 0x00, 0x50, 0xdd, 0x03, 0x00, 0x90, 0xee, 0x9e, 0xb1, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c,
    0x00, 0x00, 0x00, 0xc3, 0x96, 0x00, 0x00, 0x00, 0x69, 0xe0, 0x00, 0x00, 0x00, 0x0e, 0xa0, 0x04, 0x00, 0x50, 0x0a,
    0x40, 0x0a, 0x00, 0xa0, 0x04, 0x00, 0x0e, 0x00, 0xe1, 0x00, 0x00, 0x68, 0x00, 0x86, 0x00, 0x00, 0xc2, 0x00, 0x2c,
    0x00, 0x00, 0xc0, 0x22, 0x0c, 0x00, 0x00, 0x60, 0x77, 0x06, 0x00, 0x00, 0x00, 0xcc, 0x01, 0x00, 0x00, 0x00, 0xaa,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x88, 0x00, 0x00, 0xf0, 0x03, 0x00, 0x70, 0x48, 0x0c, 0x00, 0x40, 0x7e, 0x00, 0x00,
    0x4b, 0xf0, 0x00, 0x00, 0x79, 0x0c, 0x00, 0xe0, 0x00, 0x4c, 0x00, 0xe0, 0xd0, 0x01, 0x20, 0x0c, 0x70, 0x08, 0x30,
    0x0b, 0x69, 0x00, 0x86, 0x00, 0xc3, 0x00, 0x68, 0x40, 0x0a, 0xa0, 0x04, 0x00, 0x0e, 0xd0, 0x01, 0xe0, 0x00, 0x0e,
    0x00, 0xb0, 0x24, 0x0d, 0x00, 0x4b, 0xc2, 0x00, 0x00, 0x77, 0x76, 0x00, 0x60, 0x58, 0x08, 0x00, 0x30, 0xaa, 0x03,
    0x00, 0xd1, 0x48, 0x00, 0x00, 0xd0, 0x0d, 0x00, 0x00, 0xdc, 0x00, 0x00, 0x00, 0x9a, 0x00, 0x00, 0x70, 0x0c, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x02, 0x00, 0x30, 0x0d, 0x50, 0x0c, 0x00, 0xc0, 0x03, 0x00,
    0x6b, 0x00, 0x96, 0x00, 0x00, 0xd1, 0x10, 0x0d, 0x00, 0x00, 0x60, 0xa9, 0x05, 0x00, 0x00, 0x00, 0xbc, 0x00, 0x00,
    0x00, 0x00, 0xdd, 0x00, 0x00, 0x00, 0x90, 0x76, 0x09, 0x00, 0x00, 0xc3, 0x00, 0x3d, 0x00, 0x00, 0x3d, 0x00, 0xd3,
    0x00, 0x70, 0x09, 0x00, 0x90, 0x07, 0xe2, 0x00, 0x00, 0x10, 0x2e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x3c, 0x00, 0x00, 0x00, 0xc3, 0x96, 0x00, 0x00, 0x00, 0x69, 0xe1, 0x00, 0x00, 0x00, 0x0e,
    0xa0, 0x04, 0x00, 0x40, 0x0a, 0x40, 0x0a, 0x00, 0xa0, 0x04, 0x00, 0x0d, 0x00, 0xd0, 0x00, 0x00, 0x69, 0x00, 0x86,
    0x00, 0x00, 0xb3, 0x00, 0x2c, 0x00, 0x00, 0xd0, 0x11, 0x0b, 0x00, 0x00, 0x70, 0x77, 0x05, 0x00, 0x00, 0x10, 0xbc,
    0x00, 0x00, 0x00, 0x00, 0x9b, 0x00, 0x00, 0x00, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x20, 0x0d, 0x00, 0x00, 0x00, 0x80,
    0x07, 0x00, 0x00, 0x00, 0xe4, 0x00, 0x00, 0x00, 0xfd, 0x3c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x80, 0xdd, 0xdd, 0xed, 0x0f, 0x00, 0x00, 0x00, 0xa0, 0x07, 0x00, 0x00, 0x00, 0xc4, 0x00, 0x00, 0x00, 0x00, 0x2d,
    0x00, 0x00, 0x00, 0x90, 0x07, 0x00, 0x00, 0x00, 0xd4, 0x00, 0x00, 0x00, 0x00, 0x3d, 0x00, 0x00, 0x00, 0x80, 0x08,
    0x00, 0x00, 0x00, 0xd3, 0x00, 0x00, 0x00, 0x00, 0x3d, 0x00, 0x00, 0x00, 0x80, 0x08, 0x00, 0x00, 0x00, 0xf1, 0xdd,
    0xdd, 0xdd, 0x1d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xa1, 0x3e, 0x00, 0xc0, 0x07, 0x00, 0x10, 0x0e, 0x00, 0x00, 0xd3, 0x00, 0x00, 0x30, 0x0d, 0x00, 0x00, 0xd3, 0x00,
    0x00, 0x30, 0x0c, 0x00, 0x00, 0xb4, 0x00, 0x00, 0xb1, 0x05, 0x00, 0xe4, 0x09, 0x00, 0x00, 0x90, 0x08, 0x00, 0x00,
    0xb3, 0x00, 0x00, 0x30, 0x0d, 0x00, 0x00, 0xd3, 0x00, 0x00, 0x30, 0x0d, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x00, 0x6e,
    0x00, 0x00, 0x30, 0xfb, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00,
    0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f,
    0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00,
    0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0xae, 0x01, 0x00, 0x00, 0xc7, 0x00, 0x00, 0x00, 0x1e, 0x00, 0x00, 0xd0,
    0x03, 0x00, 0x00, 0x3d, 0x00, 0x00, 0xd0, 0x03, 0x00, 0x00, 0x3d, 0x00, 0x00, 0xb0, 0x04, 0x00, 0x00, 0xb5, 0x01,
    0x00, 0x00, 0xe9, 0x04, 0x00, 0x98, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0x3d, 0x00, 0x00, 0xd0, 0x03, 0x00, 0x00,
    0x3d, 0x00, 0x00, 0xd0, 0x01, 0x00, 0x60, 0x0e, 0x00, 0xf3, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0xdc, 0x9d, 0x04, 0x10, 0x08, 0x80, 0x01, 0x40, 0xd9, 0xcd,
    0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x3f, 0x11,
    0x11, 0x31, 0x0f, 0x00, 0xf0, 0x01, 0x00, 0x00, 0xf1, 0x00, 0x00, 0x1f, 0x00, 0x00, 0x10, 0x0f, 0x00, 0xf0, 0x01,
    0x00, 0x00, 0xf1, 0x00, 0x00, 0x1f, 0x00, 0x00, 0x10, 0x0f, 0x00, 0xf0, 0x01, 0x00, 0x00, 0xf1, 0x00, 0x00, 0x1f,
    0x00, 0x00, 0x10, 0x0f, 0x00, 0xf0, 0x01, 0x00, 0x00, 0xf1, 0x00, 0x00, 0x1f, 0x00, 0x00, 0x10, 0x0f, 0x00, 0xf0,
    0x01, 0x00, 0x00, 0xf1, 0x00, 0x00, 0x1f, 0x00, 0x00, 0x10, 0x0f, 0x00, 0xf0, 0x01, 0x00, 0x00, 0xf1, 0x00, 0x00,
    0x3f, 0x11, 0x11, 0x31, 0x0f, 0x00, 0xf0, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
]
charactersOPEN_SANS_LIGHT_16_22PX = [
    FontCharacter(5, 55, 0), FontCharacter(5, 55, 55), FontCharacter(7, 77, 110), FontCharacter(14, 154, 187),
    FontCharacter(12, 132, 341), FontCharacter(17, 187, 473), FontCharacter(15, 165, 660), FontCharacter(4, 44, 825),
    FontCharacter(6, 66, 869), FontCharacter(6, 66, 935), FontCharacter(12, 132, 1001), FontCharacter(12, 132, 1133),
    FontCharacter(5, 55, 1265), FontCharacter(7, 77, 1320), FontCharacter(5, 55, 1397), FontCharacter(7, 77, 1452),
    FontCharacter(12, 132, 1529), FontCharacter(12, 132, 1661), FontCharacter(12, 132, 1793),
    FontCharacter(12, 132, 1925), FontCharacter(12, 132, 2057), FontCharacter(12, 132, 2189),
    FontCharacter(12, 132, 2321), FontCharacter(12, 132, 2453), FontCharacter(12, 132, 2585),
    FontCharacter(12, 132, 2717), FontCharacter(5, 55, 2849), FontCharacter(5, 55, 2904), FontCharacter(12, 132, 2959),
    FontCharacter(12, 132, 3091), FontCharacter(12, 132, 3223), FontCharacter(9, 99, 3355),
    FontCharacter(19, 209, 3454), FontCharacter(13, 143, 3663), FontCharacter(13, 143, 3806),
    FontCharacter(13, 143, 3949), FontCharacter(15, 165, 4092), FontCharacter(12, 132, 4257),
    FontCharacter(11, 121, 4389), FontCharacter(15, 165, 4510), FontCharacter(15, 165, 4675),
    FontCharacter(5, 55, 4840), FontCharacter(6, 66, 4895), FontCharacter(12, 132, 4961), FontCharacter(11, 121, 5093),
    FontCharacter(18, 198, 5214), FontCharacter(15, 165, 5412), FontCharacter(16, 176, 5577),
    FontCharacter(12, 132, 5753), FontCharacter(16, 176, 5885), FontCharacter(12, 132, 6061),
    FontCharacter(11, 121, 6193), FontCharacter(11, 121, 6314), FontCharacter(15, 165, 6435),
    FontCharacter(12, 132, 6600), FontCharacter(19, 209, 6732), FontCharacter(11, 121, 6941),
    FontCharacter(11, 121, 7062), FontCharacter(12, 132, 7183), FontCharacter(7, 77, 7315), FontCharacter(7, 77, 7392),
    FontCharacter(7, 77, 7469), FontCharacter(12, 132, 7546), FontCharacter(9, 99, 7678), FontCharacter(12, 132, 7777),
    FontCharacter(11, 121, 7909), FontCharacter(12, 132, 8030), FontCharacter(10, 110, 8162),
    FontCharacter(12, 132, 8272), FontCharacter(12, 132, 8404), FontCharacter(8, 88, 8536),
    FontCharacter(11, 121, 8624), FontCharacter(12, 132, 8745), FontCharacter(5, 55, 8877), FontCharacter(5, 55, 8932),
    FontCharacter(10, 110, 8987), FontCharacter(5, 55, 9097), FontCharacter(19, 209, 9152),
    FontCharacter(12, 132, 9361), FontCharacter(12, 132, 9493), FontCharacter(12, 132, 9625),
    FontCharacter(12, 132, 9757), FontCharacter(8, 88, 9889), FontCharacter(10, 110, 9977),
    FontCharacter(7, 77, 10087), FontCharacter(12, 132, 10164), FontCharacter(10, 110, 10296),
    FontCharacter(15, 165, 10406), FontCharacter(10, 110, 10571), FontCharacter(10, 110, 10681),
    FontCharacter(10, 110, 10791), FontCharacter(7, 77, 10901), FontCharacter(11, 121, 10978),
    FontCharacter(7, 77, 11099), FontCharacter(12, 132, 11176), FontCharacter(13, 143, 11308)
]

bitmapOPEN_SANS_REGULAR_8_11PX = [
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00,
    0x0f, 0xe0, 0x00, 0x0b, 0xb0, 0x00, 0x08, 0x60, 0x10, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x94, 0x49, 0x73, 0x37,
    0x72, 0x27, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x46, 0xa0, 0x00, 0x90, 0x41, 0x06, 0xb4, 0xbe, 0xce, 0x08, 0xb0, 0xa0, 0x00, 0x20, 0x09, 0x0b, 0x80, 0xdd, 0xeb,
    0x4b, 0x70, 0x23, 0x08, 0x00, 0x0a, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x55, 0x00, 0x90, 0xdd, 0x0b, 0xb2, 0x55, 0x00, 0xd1, 0x58, 0x00, 0x30, 0xdc, 0x05, 0x00, 0x75, 0x2c, 0x00,
    0x55, 0x3b, 0xc3, 0xdd, 0x07, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x2b, 0x00, 0x0b, 0x50,
    0x16, 0x09, 0x38, 0x00, 0x35, 0xb0, 0xa1, 0x00, 0x40, 0x16, 0x99, 0xb6, 0x0a, 0xb0, 0x5b, 0x99, 0x61, 0x04, 0x00,
    0x1a, 0x0b, 0x53, 0x00, 0x83, 0x90, 0x61, 0x04, 0xa0, 0x00, 0xb2, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0xbc, 0x0a, 0x00, 0x90, 0x04, 0x1c, 0x00, 0x60, 0x28, 0x0c, 0x00,
    0x00, 0xde, 0x01, 0x00, 0xc0, 0xa5, 0x06, 0x58, 0x85, 0x00, 0x7a, 0x0d, 0xb4, 0x00, 0xf2, 0x09, 0x90, 0xcc, 0x3b,
    0x6a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x85, 0x74, 0x53, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x06, 0x0d, 0xa3, 0x70, 0x06, 0x59, 0x90, 0x05, 0x67, 0x40, 0x0a, 0xd0, 0x00,
    0x66, 0x00, 0x00, 0x66, 0x00, 0x0d, 0xa0, 0x03, 0x76, 0x50, 0x09, 0x95, 0x60, 0x07, 0x4a, 0xd0, 0x50, 0x06, 0x00,
    0x00, 0x00, 0x67, 0x00, 0x22, 0x55, 0x12, 0x93, 0xcd, 0x39, 0x20, 0xbb, 0x01, 0x70, 0x54, 0x07, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x11, 0x00, 0x00, 0x55, 0x00, 0x00, 0x55, 0x00, 0xb7, 0xdd, 0x7b, 0x00, 0x55, 0x00, 0x00, 0x55, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x0f, 0xb4, 0x70, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd6,
    0x6d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x50, 0x10, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa2, 0x00, 0x58, 0x00, 0x0d, 0x30, 0x09, 0x90, 0x03,
    0xd0, 0x00, 0x85, 0x00, 0x2a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0xcc, 0x05, 0xc1, 0x00, 0x1c, 0x85,
    0x00, 0x58, 0x67, 0x00, 0x76, 0x67, 0x00, 0x76, 0x85, 0x00, 0x58, 0xc1, 0x00, 0x1c, 0x50, 0xcc, 0x06, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xba, 0x00, 0xa0, 0xb4, 0x00, 0x00, 0xb1, 0x00, 0x00, 0xb1, 0x00,
    0x00, 0xb1, 0x00, 0x00, 0xb1, 0x00, 0x00, 0xb1, 0x00, 0x00, 0xb1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xa1, 0xcb, 0x06, 0x30, 0x00, 0x0d, 0x00, 0x00, 0x1c, 0x00, 0x20, 0x0b, 0x00, 0xc1, 0x01, 0x00, 0x3b,
    0x00, 0xb0, 0x03, 0x00, 0xf7, 0xdd, 0x6d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb2, 0xcb, 0x07,
    0x10, 0x00, 0x1d, 0x00, 0x30, 0x0c, 0x40, 0xdb, 0x05, 0x00, 0x00, 0x3c, 0x00, 0x00, 0x57, 0x00, 0x00, 0x2c, 0xc5,
    0xcb, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x0b, 0x00, 0xa4, 0x0b, 0x00, 0x2b,
    0x0b, 0xa0, 0x12, 0x0b, 0x65, 0x10, 0x0b, 0xda, 0xdd, 0xaf, 0x00, 0x10, 0x0b, 0x00, 0x10, 0x0b, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xdd, 0x0b, 0xd0, 0x00, 0x00, 0xb0, 0x00, 0x00, 0xc0, 0xdb, 0x07, 0x00,
    0x00, 0x3c, 0x00, 0x00, 0x57, 0x00, 0x00, 0x2c, 0xc3, 0xcb, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x10, 0xba, 0x0a, 0xb0, 0x03, 0x00, 0xb2, 0x00, 0x00, 0xa5, 0xba, 0x0a, 0xb5, 0x00, 0x59, 0x84, 0x00, 0x75,
    0xc0, 0x00, 0x4a, 0x40, 0xcc, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd6, 0xdd, 0x7e, 0x00,
    0x00, 0x2c, 0x00, 0x20, 0x0b, 0x00, 0x90, 0x04, 0x00, 0xd0, 0x00, 0x00, 0x67, 0x00, 0x00, 0x0d, 0x00, 0x40, 0x09,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0xcc, 0x09, 0xa2, 0x00, 0x2a, 0xc0, 0x23, 0x0b,
    0x40, 0xee, 0x03, 0xc1, 0x10, 0x1c, 0x67, 0x00, 0x66, 0x94, 0x00, 0x49, 0x90, 0xbc, 0x09, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xcc, 0x05, 0xa3, 0x00, 0x1c, 0x77, 0x00, 0x57, 0x94, 0x00, 0x5a, 0x90, 0xab,
    0x5a, 0x00, 0x00, 0x2a, 0x00, 0x30, 0x0c, 0xa0, 0xab, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xf1, 0x01, 0x05, 0x00, 0x00, 0x00, 0x50, 0x10, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xe1, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x20, 0x0d, 0x84, 0x80, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x66, 0x00, 0xb3, 0x06, 0xa1, 0x08, 0x00, 0xc4, 0x05, 0x00, 0x00, 0xc7, 0x05, 0x00, 0x00, 0x67, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xb4, 0xbb, 0x4b, 0x00, 0x00, 0x00, 0xb4, 0xbb, 0x4b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x00, 0x00, 0x60, 0x3c, 0x00, 0x00, 0x80, 0x1a, 0x00, 0x50,
    0x4b, 0x50, 0x7c, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xd7, 0xcc, 0x11, 0x00, 0x94, 0x00, 0x40, 0x09, 0x20, 0x1c, 0x10, 0x1c, 0x00, 0x55, 0x00, 0x30, 0x02, 0x00, 0x88,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x92, 0xbb, 0x6a, 0x00, 0x30, 0x1b, 0x00, 0x60, 0x07,
    0xb0, 0x30, 0xab, 0x0a, 0x0a, 0x82, 0xc0, 0x00, 0x0c, 0x46, 0x55, 0xb1, 0x00, 0x0c, 0x55, 0x64, 0xc0, 0x20, 0x0c,
    0x19, 0xa1, 0x70, 0x9b, 0xa7, 0x07, 0x80, 0x06, 0x00, 0x00, 0x00, 0x00, 0xb7, 0xbb, 0x0a, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf1, 0x01, 0x00, 0x60, 0x7c, 0x00, 0x00, 0x2c, 0x0d, 0x00, 0xb3,
    0xb0, 0x03, 0x90, 0x05, 0x95, 0x00, 0xde, 0xdd, 0x0e, 0x96, 0x00, 0x90, 0xc6, 0x01, 0x00, 0xc2, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0xcb, 0x7c, 0x00, 0x0f, 0x00, 0x1d, 0xf0, 0x00, 0xc2, 0x00,
    0xbf, 0xdb, 0x05, 0xf0, 0x00, 0xc0, 0x02, 0x0f, 0x00, 0x59, 0xf0, 0x00, 0xc0, 0x03, 0xbf, 0xdb, 0x07, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc7, 0xdd, 0x05, 0x99, 0x00, 0x00, 0xd1, 0x00, 0x00,
    0x40, 0x0a, 0x00, 0x00, 0xa4, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0xa0, 0x08, 0x00, 0x00, 0x90, 0xdd, 0x4d, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xcb, 0x8d, 0x00, 0xd0, 0x00, 0x80, 0x0a, 0xd0,
    0x00, 0x00, 0x1d, 0xd0, 0x00, 0x00, 0x4a, 0xd0, 0x00, 0x00, 0x4a, 0xd0, 0x00, 0x00, 0x1d, 0xd0, 0x00, 0x90, 0x09,
    0xd0, 0xcb, 0x7c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0xdd, 0x4d,
    0xf0, 0x00, 0x00, 0xf0, 0x00, 0x00, 0xf0, 0xdd, 0x1d, 0xf0, 0x00, 0x00, 0xf0, 0x00, 0x00, 0xf0, 0x00, 0x00, 0xf0,
    0xdd, 0x4d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xdd, 0xad, 0xd0, 0x01, 0x00, 0xd0, 0x01,
    0x00, 0xd0, 0x01, 0x00, 0xd0, 0xdd, 0x6d, 0xd0, 0x01, 0x00, 0xd0, 0x01, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc6, 0xdd, 0x0b, 0x80, 0x09, 0x00, 0x01, 0xd1, 0x00, 0x00, 0x00, 0xa4,
    0x00, 0x00, 0x00, 0xa4, 0x00, 0xd6, 0x3f, 0xd1, 0x00, 0x00, 0x3b, 0xa0, 0x08, 0x00, 0x3b, 0x00, 0xd8, 0xcc, 0x2c,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x0f, 0xf0, 0x00, 0x00,
    0x0f, 0xf0, 0x00, 0x00, 0x0f, 0xf0, 0xdd, 0xdd, 0x0f, 0xf0, 0x00, 0x00, 0x0f, 0xf0, 0x00, 0x00, 0x0f, 0xf0, 0x00,
    0x00, 0x0f, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0x00, 0x0f, 0xf0, 0x00, 0x0f, 0xf0, 0x00, 0x0f, 0xf0, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0xf0,
    0x00, 0x0f, 0xf0, 0x00, 0x0f, 0xf0, 0x00, 0x0f, 0xf0, 0x00, 0xbe, 0x5d, 0x00, 0x00, 0xd0, 0x00, 0xa0, 0x06, 0x0d,
    0xa0, 0x06, 0xd0, 0x80, 0x08, 0x00, 0x8d, 0x0c, 0x00, 0xd0, 0xb7, 0x05, 0x00, 0x0d, 0xd1, 0x02, 0xd0, 0x00, 0xc3,
    0x00, 0x0d, 0x00, 0x97, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x01, 0x00, 0xd0,
    0x01, 0x00, 0xd0, 0x01, 0x00, 0xd0, 0x01, 0x00, 0xd0, 0x01, 0x00, 0xd0, 0x01, 0x00, 0xd0, 0x01, 0x00, 0xd0, 0xdd,
    0xad, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x0a, 0x00, 0x90, 0x0d, 0xb0, 0x0d, 0x00, 0xc0,
    0x0d, 0xb0, 0x67, 0x00, 0x66, 0x0d, 0xd0, 0xc1, 0x00, 0x0b, 0x0d, 0xd0, 0xb0, 0x22, 0x0a, 0x0d, 0xd0, 0x50, 0x88,
    0x04, 0x0d, 0xd0, 0x00, 0xcd, 0x00, 0x0d, 0xd0, 0x00, 0x79, 0x00, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x05, 0x00, 0x0d, 0xe0, 0x0d, 0x00, 0x0d, 0xd0, 0x96, 0x00,
    0x0d, 0xd0, 0xc0, 0x02, 0x0d, 0xd0, 0x30, 0x0c, 0x0d, 0xd0, 0x00, 0x69, 0x0d, 0xd0, 0x00, 0xd0, 0x0e, 0xd0, 0x00,
    0x50, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd8, 0xdd, 0x08, 0x00,
    0x89, 0x00, 0x80, 0x09, 0xd1, 0x00, 0x00, 0xd0, 0x31, 0x0a, 0x00, 0x00, 0x3a, 0xa3, 0x00, 0x00, 0xa0, 0x13, 0x0d,
    0x00, 0x00, 0x1d, 0x90, 0x08, 0x00, 0x98, 0x00, 0x80, 0xcd, 0x8d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xcc, 0x7d, 0x00, 0x1d, 0x00, 0x3c, 0xd0, 0x01, 0x80, 0x05, 0x1d,
    0x30, 0x1d, 0xd0, 0xbc, 0x29, 0x00, 0x1d, 0x00, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x1d, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd8, 0xdd, 0x08, 0x00, 0x89, 0x00, 0x80, 0x09, 0xd1, 0x00,
    0x00, 0xd0, 0x31, 0x0a, 0x00, 0x00, 0x3a, 0xa3, 0x00, 0x00, 0xa0, 0x13, 0x0d, 0x00, 0x00, 0x1d, 0x90, 0x08, 0x00,
    0x98, 0x00, 0x80, 0xcd, 0x8e, 0x00, 0x00, 0x00, 0xb0, 0x07, 0x00, 0x00, 0x00, 0xd0, 0x05, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xd0, 0xcb, 0x6c, 0x00, 0x0d, 0x00, 0x1e, 0xd0, 0x00, 0xb0, 0x03, 0x0d, 0x30, 0x0d, 0xd0, 0xcb, 0x1d, 0x00,
    0x0d, 0xc0, 0x03, 0xd0, 0x00, 0xc2, 0x00, 0x0d, 0x00, 0x78, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x80, 0xdd, 0x1c, 0xb3, 0x00, 0x00, 0xb3, 0x00, 0x00, 0x90, 0x5b, 0x00, 0x00, 0x92, 0x1c, 0x00, 0x00,
    0x68, 0x01, 0x00, 0x5a, 0xd5, 0xcc, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xdb, 0xee, 0xbd,
    0x00, 0x77, 0x00, 0x00, 0x77, 0x00, 0x00, 0x77, 0x00, 0x00, 0x77, 0x00, 0x00, 0x77, 0x00, 0x00, 0x77, 0x00, 0x00,
    0x77, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x00, 0x00, 0x0d, 0xd0, 0x00, 0x00, 0x0d,
    0xd0, 0x00, 0x00, 0x0d, 0xd0, 0x00, 0x00, 0x0d, 0xd0, 0x00, 0x00, 0x0d, 0xd0, 0x00, 0x00, 0x0e, 0xa0, 0x05, 0x50,
    0x0a, 0x10, 0xca, 0xac, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x00,
    0x30, 0x6c, 0x09, 0x00, 0x69, 0xe0, 0x00, 0xe0, 0x00, 0x5a, 0x50, 0x0a, 0x40, 0x0b, 0x4b, 0x00, 0xd0, 0xe3, 0x00,
    0x00, 0xc8, 0x08, 0x00, 0x20, 0x2f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3b,
    0x00, 0x9a, 0x00, 0xb3, 0x77, 0x00, 0xcc, 0x00, 0x77, 0xb3, 0x30, 0xa9, 0x02, 0x3b, 0xe0, 0x70, 0x65, 0x07, 0x0e,
    0xb0, 0xc3, 0x10, 0x3b, 0x0a, 0x60, 0xc7, 0x00, 0x7c, 0x06, 0x20, 0x7d, 0x00, 0xd8, 0x02, 0x00, 0x3e, 0x00, 0xe3,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x67, 0x00, 0x76,
    0xc0, 0x01, 0x0c, 0x40, 0x99, 0x03, 0x00, 0xaa, 0x00, 0x00, 0xcc, 0x00, 0x70, 0x65, 0x07, 0xc1, 0x00, 0x1c, 0x3a,
    0x00, 0xa4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3b, 0x00, 0xb3, 0xb3, 0x00, 0x3b, 0xa0, 0x33,
    0x0a, 0x20, 0xbb, 0x02, 0x00, 0xaa, 0x00, 0x00, 0x77, 0x00, 0x00, 0x77, 0x00, 0x00, 0x77, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd6, 0xdd, 0x7f, 0x00, 0x10, 0x0d, 0x00, 0xa0, 0x05, 0x00, 0xc4, 0x00, 0x00,
    0x2d, 0x00, 0x70, 0x08, 0x00, 0xd1, 0x00, 0x00, 0xe9, 0xdd, 0x8d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xf0, 0x8b, 0xd0, 0x00, 0xd0, 0x00, 0xd0, 0x00, 0xd0, 0x00, 0xd0, 0x00, 0xd0, 0x00, 0xd0, 0x00, 0xd0, 0x00,
    0xf0, 0x8b, 0x00, 0x00, 0x2a, 0x00, 0x84, 0x00, 0xd0, 0x00, 0x90, 0x03, 0x30, 0x09, 0x00, 0x0d, 0x00, 0x57, 0x00,
    0xb2, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb8, 0x0f, 0x00, 0x0d, 0x00, 0x0d, 0x00, 0x0d, 0x00, 0x0d, 0x00, 0x0d,
    0x00, 0x0d, 0x00, 0x0d, 0x00, 0x0d, 0xb8, 0x0f, 0x00, 0x00, 0x00, 0x59, 0x00, 0x10, 0xb9, 0x00, 0x80, 0x52, 0x06,
    0xb0, 0x00, 0x0b, 0x47, 0x00, 0x65, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0xbb, 0xbb, 0x00, 0x00, 0x00, 0x00, 0xa1, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xcb, 0x08, 0x00,
    0x00, 0x1c, 0x80, 0xab, 0x1e, 0x96, 0x00, 0x1b, 0x87, 0x10, 0x1f, 0xc1, 0x9b, 0x1a, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xd0, 0x00, 0x00, 0x00, 0x0d, 0x00, 0x00, 0xe0, 0xb9, 0x5c, 0x00, 0x2f, 0x00, 0x1d, 0xd0,
    0x00, 0x90, 0x05, 0x0e, 0x00, 0x59, 0xf0, 0x02, 0xd0, 0x01, 0x9b, 0xcb, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0xcd, 0x16, 0x0c, 0x00, 0x85, 0x00, 0x50, 0x08,
    0x00, 0xc2, 0x00, 0x00, 0xc6, 0x7c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x00, 0x00,
    0x00, 0x0d, 0x50, 0xbc, 0xe9, 0x10, 0x0d, 0x20, 0x0f, 0x95, 0x00, 0xe0, 0x50, 0x09, 0x00, 0x0d, 0xd1, 0x00, 0xf2,
    0x00, 0xc6, 0x9b, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x60, 0xbb, 0x09, 0xa1, 0x00, 0x49, 0xd5, 0xbb, 0x5b, 0x95, 0x00, 0x00, 0xd1, 0x01, 0x00, 0x50, 0xbd,
    0x2c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0xbc, 0x01, 0x3a, 0x00, 0xe7, 0x8c, 0x00, 0x3b,
    0x00, 0xb0, 0x03, 0x00, 0x3b, 0x00, 0xb0, 0x03, 0x00, 0x3b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0xca, 0x7d, 0x93, 0x00, 0x0e, 0x94, 0x00, 0x0d, 0xb0, 0xaa, 0x05, 0xc0,
    0x00, 0x00, 0xc0, 0xcb, 0x2d, 0x3a, 0x00, 0x94, 0x2b, 0x00, 0x86, 0xb3, 0xbb, 0x09, 0xd0, 0x00, 0x00, 0x00, 0x0d,
    0x00, 0x00, 0xd0, 0xb9, 0x6c, 0x00, 0x2f, 0x00, 0x0e, 0xd0, 0x00, 0xd0, 0x01, 0x0d, 0x00, 0x1d, 0xd0, 0x00, 0xd0,
    0x01, 0x0d, 0x00, 0x1d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x00, 0x00, 0xd0,
    0x00, 0x0d, 0xd0, 0x00, 0x0d, 0xd0, 0x00, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0d, 0x00, 0x00, 0x0d, 0xd0,
    0x00, 0x0d, 0xd0, 0x00, 0x0d, 0xd0, 0x00, 0x0d, 0xd0, 0xc5, 0x07, 0xd0, 0x00, 0x00, 0xd0, 0x00, 0x00, 0xd0, 0x10,
    0x3c, 0xd0, 0xc1, 0x03, 0xe0, 0x7d, 0x00, 0xe0, 0xc3, 0x00, 0xd0, 0x40, 0x0b, 0xd0, 0x00, 0x79, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x00, 0x0d, 0xd0, 0x00, 0x0d, 0xd0, 0x00, 0x0d, 0xd0, 0x00, 0x0d, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb1, 0xb9, 0x4b, 0xcb, 0x07,
    0xf1, 0x01, 0xb7, 0x00, 0x0d, 0xd1, 0x00, 0x75, 0x00, 0x1b, 0xd1, 0x00, 0x75, 0x00, 0x1b, 0xd1, 0x00, 0x75, 0x00,
    0x1b, 0xd1, 0x00, 0x75, 0x00, 0x1b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0xb9, 0x6c, 0x00, 0x2f, 0x00, 0x0e, 0xd0, 0x00, 0xd0,
    0x01, 0x0d, 0x00, 0x1d, 0xd0, 0x00, 0xd0, 0x01, 0x0d, 0x00, 0x1d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0xbc, 0x4c, 0x00, 0x0d, 0x10, 0x0d, 0x94, 0x00,
    0x90, 0x44, 0x09, 0x00, 0x49, 0xd0, 0x01, 0xd1, 0x00, 0xb3, 0xbb, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0xb9, 0x5c, 0x00, 0x2f, 0x00, 0x1d, 0xd0,
    0x00, 0x90, 0x05, 0x0e, 0x00, 0x59, 0xf0, 0x02, 0xd0, 0x01, 0x9d, 0xcb, 0x05, 0xd0, 0x00, 0x00, 0x00, 0x0d, 0x00,
    0x00, 0xd0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0xbc, 0xc9, 0x10, 0x0d, 0x20, 0x0f,
    0x95, 0x00, 0xe0, 0x50, 0x09, 0x00, 0x0d, 0xd1, 0x00, 0xf2, 0x00, 0xc5, 0x9b, 0x0d, 0x00, 0x00, 0xd0, 0x00, 0x00,
    0x00, 0x0d, 0x00, 0x00, 0xd0, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa1, 0xaa, 0xe1, 0x02, 0xb1, 0x00, 0xb1, 0x00, 0xb1,
    0x00, 0xb1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb1, 0xcb, 0x62, 0x06, 0x00,
    0xc1, 0x18, 0x00, 0x50, 0x3c, 0x00, 0x60, 0x57, 0xbb, 0x1b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xb0, 0x00, 0xf7, 0x8b, 0xf0, 0x00, 0xf0, 0x00, 0xf0, 0x00, 0xe0, 0x00, 0x70, 0x8c, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd1, 0x00, 0xd0, 0x10, 0x0d, 0x00, 0x0d, 0xd1, 0x00, 0xd0,
    0x10, 0x0d, 0x00, 0x0d, 0xe0, 0x00, 0xf2, 0x00, 0xd7, 0x9b, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x00, 0xc3, 0x96, 0x00, 0x69, 0xe0, 0x00, 0x0e, 0x80,
    0x66, 0x08, 0x20, 0xbb, 0x02, 0x00, 0xcc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3b, 0x10, 0x2f, 0x30, 0x6b, 0x07, 0xa7, 0x07, 0x67, 0xb2, 0xc0, 0xc2,
    0xb0, 0x02, 0x2d, 0x0b, 0x2b, 0x0d, 0x90, 0x5b, 0x60, 0x9b, 0x00, 0xf4, 0x00, 0xf1, 0x04, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb4, 0x00, 0x4b,
    0x80, 0x66, 0x08, 0x00, 0xcc, 0x00, 0x00, 0xcc, 0x00, 0xa0, 0x45, 0x0a, 0xa5, 0x00, 0x69, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x00, 0xc3, 0x96, 0x00, 0x69, 0xe0, 0x00,
    0x0e, 0xa0, 0x56, 0x09, 0x40, 0xab, 0x03, 0x00, 0xcd, 0x00, 0x00, 0x7b, 0x00, 0x10, 0x1e, 0x00, 0xc9, 0x05, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xb4, 0xdb, 0x07, 0x00, 0x0c, 0x00, 0x4a, 0x00, 0xa4, 0x00, 0xd0, 0x00, 0x80, 0xbd,
    0x7b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7b, 0x50, 0x08, 0x50, 0x07, 0x60, 0x07, 0xb4, 0x02,
    0xb4, 0x02, 0x60, 0x07, 0x50, 0x07, 0x50, 0x08, 0x00, 0x7b, 0x00, 0x00, 0x00, 0x55, 0x00, 0x00, 0x55, 0x00, 0x00,
    0x55, 0x00, 0x00, 0x55, 0x00, 0x00, 0x55, 0x00, 0x00, 0x55, 0x00, 0x00, 0x55, 0x00, 0x00, 0x55, 0x00, 0x00, 0x55,
    0x00, 0x00, 0x55, 0x00, 0x00, 0x55, 0x00, 0xb7, 0x00, 0x80, 0x06, 0x70, 0x07, 0x70, 0x07, 0x20, 0x4b, 0x20, 0x4b,
    0x70, 0x07, 0x70, 0x07, 0x80, 0x06, 0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xc3, 0x1b, 0x40, 0x04, 0xb1, 0x2c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x99, 0xc9, 0x00, 0x09, 0x00, 0x07, 0x90, 0x00, 0x70, 0x00, 0x09, 0x00, 0x07,
    0x90, 0x00, 0x70, 0x00, 0x09, 0x00, 0x07, 0x90, 0x00, 0x70, 0x00, 0x9d, 0x99, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00
]
charactersOPEN_SANS_REGULAR_8_11PX = [
    FontCharacter(3, 17, 0), FontCharacter(3, 17, 17), FontCharacter(4, 22, 34), FontCharacter(7, 39, 56),
    FontCharacter(6, 33, 95), FontCharacter(9, 50, 128), FontCharacter(8, 44, 178), FontCharacter(2, 11, 222),
    FontCharacter(3, 17, 233), FontCharacter(3, 17, 250), FontCharacter(6, 33, 267), FontCharacter(6, 33, 300),
    FontCharacter(3, 17, 333), FontCharacter(4, 22, 350), FontCharacter(3, 17, 372), FontCharacter(4, 22, 389),
    FontCharacter(6, 33, 411), FontCharacter(6, 33, 444), FontCharacter(6, 33, 477), FontCharacter(6, 33, 510),
    FontCharacter(6, 33, 543), FontCharacter(6, 33, 576), FontCharacter(6, 33, 609), FontCharacter(6, 33, 642),
    FontCharacter(6, 33, 675), FontCharacter(6, 33, 708), FontCharacter(3, 17, 741), FontCharacter(3, 17, 758),
    FontCharacter(6, 33, 775), FontCharacter(6, 33, 808), FontCharacter(6, 33, 841), FontCharacter(5, 28, 874),
    FontCharacter(10, 55, 902), FontCharacter(7, 39, 957), FontCharacter(7, 39, 996), FontCharacter(7, 39, 1035),
    FontCharacter(8, 44, 1074), FontCharacter(6, 33, 1118), FontCharacter(6, 33, 1151), FontCharacter(8, 44, 1184),
    FontCharacter(8, 44, 1228), FontCharacter(3, 17, 1272), FontCharacter(3, 17, 1289), FontCharacter(7, 39, 1306),
    FontCharacter(6, 33, 1345), FontCharacter(10, 55, 1378), FontCharacter(8, 44, 1433), FontCharacter(9, 50, 1477),
    FontCharacter(7, 39, 1527), FontCharacter(9, 50, 1566), FontCharacter(7, 39, 1616), FontCharacter(6, 33, 1655),
    FontCharacter(6, 33, 1688), FontCharacter(8, 44, 1721), FontCharacter(7, 39, 1765), FontCharacter(10, 55, 1804),
    FontCharacter(6, 33, 1859), FontCharacter(6, 33, 1892), FontCharacter(6, 33, 1925), FontCharacter(4, 22, 1958),
    FontCharacter(4, 22, 1980), FontCharacter(4, 22, 2002), FontCharacter(6, 33, 2024), FontCharacter(5, 28, 2057),
    FontCharacter(6, 33, 2085), FontCharacter(6, 33, 2118), FontCharacter(7, 39, 2151), FontCharacter(5, 28, 2190),
    FontCharacter(7, 39, 2218), FontCharacter(6, 33, 2257), FontCharacter(5, 28, 2290), FontCharacter(6, 33, 2318),
    FontCharacter(7, 39, 2351), FontCharacter(3, 17, 2390), FontCharacter(3, 17, 2407), FontCharacter(6, 33, 2424),
    FontCharacter(3, 17, 2457), FontCharacter(10, 55, 2474), FontCharacter(7, 39, 2529), FontCharacter(7, 39, 2568),
    FontCharacter(7, 39, 2607), FontCharacter(7, 39, 2646), FontCharacter(4, 22, 2685), FontCharacter(5, 28, 2707),
    FontCharacter(4, 22, 2735), FontCharacter(7, 39, 2757), FontCharacter(6, 33, 2796), FontCharacter(9, 50, 2829),
    FontCharacter(6, 33, 2879), FontCharacter(6, 33, 2912), FontCharacter(5, 28, 2945), FontCharacter(4, 22, 2973),
    FontCharacter(6, 33, 2995), FontCharacter(4, 22, 3028), FontCharacter(6, 33, 3050), FontCharacter(7, 39, 3083)
]

bitmapOPEN_SANS_EXTRABOLD_11PX = [
    0x00, 0x00, 0x00, 0x00, 0x00, 0xB0, 0x6D, 0xC3, 0x06, 0x00, 0x80, 0x2D, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x12, 0xC9, 0x4F, 0xF9, 0x4B, 0x24, 0x12, 0x00, 0x00, 0x00, 0x88, 0xB7, 0x2C, 0x0E, 0x87, 0xA6, 0x1F, 0x02,
    0x00, 0x00, 0x38, 0xB1, 0xC6, 0x0A, 0xFB, 0xF9, 0x8D, 0x35, 0xD6, 0xC8, 0x01, 0x00, 0x00, 0x00, 0x00, 0x78, 0xD8,
    0xB0, 0xC1, 0xC1, 0xDB, 0x3D, 0x7B, 0xBE, 0x01, 0x00, 0x00, 0x00, 0xB0, 0x04, 0x00, 0x00, 0x00, 0x40, 0x66, 0x33,
    0x33, 0x66, 0x04, 0x20, 0x66, 0xCC, 0xCC, 0x66, 0x02, 0x00, 0xD3, 0xFE, 0x9E, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xC0, 0x30, 0x3F, 0xC3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x1A, 0x00, 0x00, 0x00, 0xF0, 0x0F, 0x00, 0x00,
    0x00, 0x00, 0xC0, 0x06, 0x00, 0x00, 0x23, 0xC6, 0x8C, 0x11, 0x03, 0x00, 0x00, 0x00, 0x3C, 0x66, 0x66, 0x66, 0x66,
    0x66, 0x66, 0x3C, 0x00, 0x00, 0x00, 0x00, 0xC6, 0x79, 0x18, 0x86, 0x61, 0x18, 0x00, 0x00, 0x00, 0x8E, 0x0D, 0x06,
    0xC3, 0x70, 0x18, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x0F, 0x0C, 0xC6, 0x81, 0xC1, 0x60, 0x1E, 0x00, 0x00, 0x00, 0x00,
    0x30, 0x38, 0x38, 0x34, 0x34, 0x7E, 0x30, 0x30, 0x00, 0x00, 0x00, 0x80, 0x67, 0x18, 0x1E, 0x86, 0x61, 0x1E, 0x00,
    0x00, 0x00, 0x38, 0x0C, 0x04, 0x3E, 0x66, 0x66, 0x66, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x0C, 0x06, 0xC3, 0x60,
    0x30, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x66, 0x66, 0x3C, 0x66, 0x66, 0x66, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x3C,
    0x66, 0x66, 0x66, 0x7C, 0x60, 0x30, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x6C, 0xC0, 0x06, 0x00, 0x00, 0x6C, 0xC0, 0x1A,
    0x00, 0x00, 0x60, 0x66, 0x86, 0x61, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xF0, 0x03, 0x00, 0x00, 0x00, 0x00,
    0x0C, 0xC3, 0x30, 0x33, 0x03, 0x00, 0x00, 0xC0, 0x83, 0x61, 0x8E, 0x01, 0x18, 0x06, 0x00, 0x00, 0x00, 0xE0, 0xC3,
    0x98, 0xDD, 0x5B, 0x2F, 0xBD, 0xF6, 0x7E, 0x06, 0xE0, 0x07, 0x00, 0x00, 0x00, 0x18, 0x3C, 0x3C, 0x7E, 0x66, 0x7E,
    0xE7, 0xC3, 0x00, 0x00, 0x00, 0x00, 0x9F, 0xCD, 0xE6, 0xB1, 0xD9, 0x6C, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x9E, 0xC1,
    0x60, 0x30, 0x18, 0x0C, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x3E, 0x00, 0x00,
    0x00, 0x80, 0x67, 0x18, 0x9E, 0x61, 0x18, 0x1E, 0x00, 0x00, 0x80, 0x6F, 0x18, 0x9E, 0x61, 0x18, 0x06, 0x00, 0x00,
    0x00, 0x7C, 0x06, 0x06, 0x76, 0x66, 0x66, 0x66, 0x7C, 0x00, 0x00, 0x00, 0x00, 0x66, 0x66, 0x66, 0x7E, 0x66, 0x66,
    0x66, 0x66, 0x00, 0x00, 0x00, 0x60, 0x66, 0x66, 0x66, 0x06, 0x00, 0x80, 0x31, 0xC6, 0x18, 0x63, 0x8C, 0xB1, 0x03,
    0x00, 0xE6, 0x66, 0x36, 0x1E, 0x3E, 0x36, 0x66, 0xE6, 0x00, 0x00, 0x00, 0x80, 0x61, 0x18, 0x86, 0x61, 0x18, 0x3E,
    0x00, 0x00, 0x00, 0x70, 0x9C, 0xE3, 0xBC, 0xE7, 0x3D, 0xEF, 0x59, 0xCD, 0x6E, 0x76, 0x03, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x9C, 0x39, 0xF3, 0xE6, 0xCD, 0x9E, 0x3D, 0x73, 0xE6, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF8, 0x18, 0x33, 0x66,
    0xCC, 0x98, 0x31, 0x63, 0x7C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x9F, 0xCD, 0x66, 0xF3, 0x19, 0x0C, 0x06, 0x00, 0x00,
    0x00, 0x00, 0xF8, 0x18, 0x33, 0x66, 0xCC, 0x98, 0x31, 0x63, 0x7C, 0xC0, 0x00, 0x03, 0x00, 0x00, 0x1E, 0x36, 0x36,
    0x36, 0x1E, 0x36, 0x36, 0x66, 0x00, 0x00, 0x00, 0x00, 0x6F, 0x18, 0x0E, 0x87, 0xE7, 0x1E, 0x00, 0x00, 0xC0, 0xCF,
    0x30, 0x0C, 0xC3, 0x30, 0x0C, 0x00, 0x00, 0x00, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x3C, 0x00, 0x00, 0x00,
    0xC0, 0x3C, 0xCF, 0xB3, 0xE7, 0x79, 0x0C, 0x00, 0x00, 0x00, 0x98, 0xB3, 0xDD, 0xEC, 0x66, 0x35, 0xAB, 0x71, 0x87,
    0x3B, 0xD8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC3, 0x66, 0x3C, 0x3C, 0x3C, 0x3C, 0x66, 0xC3, 0x00, 0x00, 0x00,
    0x80, 0xB1, 0xCD, 0xC6, 0xC1, 0x60, 0x30, 0x18, 0x00, 0x00, 0x00, 0x80, 0x3F, 0x0C, 0x87, 0x61, 0x38, 0x0C, 0x7F,
    0x00, 0x00, 0x00, 0xC0, 0x1B, 0x63, 0x8C, 0x31, 0xC6, 0x78, 0x00, 0x60, 0x08, 0x63, 0x18, 0x43, 0x18, 0x00, 0x00,
    0xE0, 0x31, 0xC6, 0x18, 0x63, 0x8C, 0x3D, 0x00, 0x00, 0x06, 0xC3, 0x23, 0x99, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF0, 0x03, 0x0C, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xC0, 0x03, 0xF3, 0xCD, 0x66, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x83, 0xC1, 0x67, 0xB3, 0xDB, 0x6D,
    0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF0, 0xC6, 0x71, 0x18, 0x3C, 0x00, 0x00, 0x00, 0x18, 0x8C, 0x67, 0xBB, 0xDD,
    0x6C, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x67, 0xFE, 0x1F, 0x0C, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x67, 0x7C,
    0x86, 0x61, 0x18, 0x06, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x6F, 0xB3, 0x79, 0x0C, 0xBE, 0xF1, 0xD8, 0x07, 0x00, 0x83,
    0xC1, 0x67, 0xB3, 0xD9, 0x6C, 0x36, 0x00, 0x00, 0x00, 0x60, 0x60, 0x66, 0x66, 0x06, 0x00, 0x80, 0x01, 0xC6, 0x18,
    0x63, 0x8C, 0x31, 0x03, 0x00, 0x83, 0xC1, 0xE6, 0xF3, 0x78, 0x6C, 0x76, 0x00, 0x00, 0x00, 0x60, 0x66, 0x66, 0x66,
    0x06, 0x00, 0x00, 0x00, 0x00, 0x80, 0x76, 0xB6, 0xD9, 0x66, 0x9B, 0x6D, 0xB6, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x40, 0x67, 0xB3, 0xD9, 0x6C, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x63, 0xBB, 0xDF, 0x6D, 0x1C, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xC0, 0x67, 0xB3, 0xDB, 0x6D, 0x3E, 0x83, 0xC1, 0x00, 0x00, 0x00, 0xC0, 0x67, 0xBB, 0xDD, 0x6C,
    0x3E, 0x18, 0x0C, 0x06, 0x00, 0x00, 0xED, 0x8D, 0x31, 0x06, 0x00, 0x00, 0x00, 0x00, 0x78, 0x86, 0xC7, 0xC3, 0x1E,
    0x00, 0x00, 0x00, 0x98, 0x6F, 0x8C, 0x31, 0x1C, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x66, 0xB3, 0xD9, 0x6C, 0x2E, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x60, 0x6C, 0xB3, 0xD9, 0x38, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0xCC, 0xB6,
    0xF9, 0xE7, 0x1F, 0x33, 0xCC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x6E, 0xE3, 0x70, 0x6C, 0x77, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x60, 0x6C, 0xB3, 0xD1, 0x38, 0x1C, 0x06, 0xC3, 0x00, 0x00, 0x00, 0xFC, 0x18, 0xC3, 0x18, 0x3F,
    0x00, 0x00, 0x80, 0x33, 0xC6, 0xCE, 0x61, 0x8C, 0x71, 0x00, 0x00, 0xC3, 0x30, 0x0C, 0xC3, 0x30, 0x0C, 0xC3, 0x30,
    0xE0, 0x18, 0x63, 0x38, 0x37, 0xC6, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x6F, 0x0F, 0x00, 0x00, 0x00, 0x00, 0x80, 0x27,
    0x49, 0x92, 0x24, 0x49, 0x1E, 0x00, 0x00
]
charactersOPEN_SANS_EXTRABOLD_11PX = [
    FontCharacter(3, 5, 0), FontCharacter(3, 5, 5), FontCharacter(6, 9, 10), FontCharacter(7, 11, 19),
    FontCharacter(6, 9, 30), FontCharacter(10, 15, 39), FontCharacter(9, 14, 54), FontCharacter(3, 5, 68),
    FontCharacter(4, 6, 73), FontCharacter(4, 6, 79), FontCharacter(6, 9, 85), FontCharacter(6, 9, 94),
    FontCharacter(3, 5, 103), FontCharacter(4, 6, 108), FontCharacter(3, 5, 114), FontCharacter(5, 8, 119),
    FontCharacter(8, 12, 127), FontCharacter(6, 9, 139), FontCharacter(7, 11, 148), FontCharacter(7, 11, 159),
    FontCharacter(8, 12, 170), FontCharacter(6, 9, 182), FontCharacter(8, 12, 191), FontCharacter(7, 11, 203),
    FontCharacter(8, 12, 214), FontCharacter(8, 12, 226), FontCharacter(3, 5, 238), FontCharacter(3, 5, 243),
    FontCharacter(5, 8, 248), FontCharacter(6, 9, 256), FontCharacter(5, 8, 265), FontCharacter(6, 9, 273),
    FontCharacter(10, 15, 282), FontCharacter(8, 12, 297), FontCharacter(7, 11, 309), FontCharacter(7, 11, 320),
    FontCharacter(8, 12, 331), FontCharacter(6, 9, 343), FontCharacter(6, 9, 352), FontCharacter(8, 12, 361),
    FontCharacter(8, 12, 373), FontCharacter(4, 6, 385), FontCharacter(5, 8, 391), FontCharacter(8, 12, 399),
    FontCharacter(6, 9, 411), FontCharacter(11, 17, 420), FontCharacter(9, 14, 437), FontCharacter(9, 14, 451),
    FontCharacter(7, 11, 465), FontCharacter(9, 14, 476), FontCharacter(8, 12, 490), FontCharacter(6, 9, 502),
    FontCharacter(6, 9, 511), FontCharacter(8, 12, 520), FontCharacter(6, 9, 532), FontCharacter(11, 17, 541),
    FontCharacter(8, 12, 558), FontCharacter(7, 11, 570), FontCharacter(7, 11, 581), FontCharacter(5, 8, 592),
    FontCharacter(5, 8, 600), FontCharacter(5, 8, 608), FontCharacter(7, 11, 616), FontCharacter(6, 9, 627),
    FontCharacter(7, 11, 636), FontCharacter(7, 11, 647), FontCharacter(7, 11, 658), FontCharacter(6, 9, 669),
    FontCharacter(7, 11, 678), FontCharacter(7, 11, 689), FontCharacter(6, 9, 700), FontCharacter(7, 11, 709),
    FontCharacter(7, 11, 720), FontCharacter(4, 6, 731), FontCharacter(5, 8, 737), FontCharacter(7, 11, 745),
    FontCharacter(4, 6, 756), FontCharacter(10, 15, 762), FontCharacter(7, 11, 777), FontCharacter(7, 11, 788),
    FontCharacter(7, 11, 799), FontCharacter(7, 11, 810), FontCharacter(5, 8, 821), FontCharacter(6, 9, 829),
    FontCharacter(5, 8, 838), FontCharacter(7, 11, 846), FontCharacter(7, 11, 857), FontCharacter(10, 15, 868),
    FontCharacter(7, 11, 883), FontCharacter(7, 11, 894), FontCharacter(6, 9, 905), FontCharacter(5, 8, 914),
    FontCharacter(6, 9, 922), FontCharacter(5, 8, 931), FontCharacter(6, 9, 939), FontCharacter(6, 9, 948)
]

bitmapOPEN_SANS_REGULAR_11PX = [
    0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0x24, 0x09, 0x02, 0x00, 0x60, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0xC9,
    0x4F, 0xA1, 0xFC, 0x24, 0x02, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x29, 0x0A, 0x83, 0x61, 0x1E, 0x00, 0x00, 0x00, 0x8C,
    0xA8, 0x50, 0xA1, 0xCD, 0x16, 0x2A, 0x54, 0xC4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1C, 0x12, 0x12, 0x0C, 0x4A, 0x52,
    0x22, 0x5E, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x90, 0x94, 0x24, 0x92, 0x00, 0x90, 0x44, 0x92, 0x92, 0x00, 0x00,
    0x41, 0xFC, 0x8C, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC8, 0x8F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x52, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x80, 0x44, 0x24, 0x22, 0x01,
    0x00, 0x00, 0x23, 0x49, 0x92, 0x24, 0x49, 0x0C, 0x00, 0x00, 0x00, 0xA3, 0x20, 0x08, 0x82, 0x20, 0x08, 0x00, 0x00,
    0x80, 0x03, 0x41, 0x10, 0x42, 0x08, 0x1E, 0x00, 0x00, 0x80, 0x03, 0x41, 0x0C, 0x04, 0x41, 0x0E, 0x00, 0x00, 0x00,
    0x20, 0x30, 0x28, 0x24, 0x24, 0x7E, 0x20, 0x20, 0x00, 0x00, 0x00, 0x80, 0x27, 0x08, 0x1E, 0x04, 0x41, 0x0E, 0x00,
    0x00, 0x00, 0x27, 0x08, 0x9E, 0x24, 0x49, 0x0C, 0x00, 0x00, 0x80, 0x07, 0x41, 0x08, 0x42, 0x10, 0x04, 0x00, 0x00,
    0x00, 0x23, 0x49, 0x8C, 0x24, 0x49, 0x0C, 0x00, 0x00, 0x00, 0x23, 0x49, 0x92, 0x07, 0x41, 0x0E, 0x00, 0x00, 0x00,
    0x04, 0x00, 0x02, 0x00, 0x00, 0x04, 0x00, 0x52, 0x00, 0x00, 0x00, 0x21, 0x86, 0x81, 0x40, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x1E, 0xE0, 0x01, 0x00, 0x00, 0x00, 0x00, 0x20, 0x10, 0x18, 0x46, 0x08, 0x00, 0x00, 0x00, 0xC0, 0x41,
    0x88, 0x08, 0x01, 0x04, 0x00, 0x00, 0x00, 0xE0, 0x43, 0x90, 0x5C, 0x4A, 0x29, 0xA5, 0x94, 0x7E, 0x02, 0xF0, 0x01,
    0x00, 0x00, 0x00, 0x04, 0x85, 0x42, 0x11, 0xF9, 0x44, 0x41, 0x00, 0x00, 0x00, 0x00, 0x9F, 0x48, 0xE4, 0x11, 0x89,
    0x44, 0x3E, 0x00, 0x00, 0x00, 0x00, 0x9E, 0x41, 0x20, 0x10, 0x08, 0x0C, 0x3C, 0x00, 0x00, 0x00, 0x00, 0x3E, 0x42,
    0x42, 0x42, 0x42, 0x42, 0x42, 0x3E, 0x00, 0x00, 0x00, 0x80, 0x27, 0x08, 0x9E, 0x20, 0x08, 0x1E, 0x00, 0x00, 0x80,
    0x2F, 0x08, 0x82, 0x2F, 0x08, 0x02, 0x00, 0x00, 0x00, 0x7C, 0x02, 0x02, 0x02, 0x62, 0x42, 0x42, 0x7C, 0x00, 0x00,
    0x00, 0x00, 0x42, 0x42, 0x42, 0x7E, 0x42, 0x42, 0x42, 0x42, 0x00, 0x00, 0x00, 0x90, 0x24, 0x49, 0x02, 0x00, 0x40,
    0x44, 0x44, 0x44, 0x44, 0x03, 0x00, 0x91, 0x44, 0x61, 0x50, 0x48, 0x44, 0x42, 0x00, 0x00, 0x00, 0x80, 0x20, 0x08,
    0x82, 0x20, 0x08, 0x3E, 0x00, 0x00, 0x00, 0x18, 0x66, 0x98, 0x61, 0x4A, 0x29, 0x25, 0x93, 0x4C, 0x32, 0x01, 0x00,
    0x00, 0x00, 0x00, 0x42, 0x46, 0x4A, 0x4A, 0x52, 0x52, 0x62, 0x42, 0x00, 0x00, 0x00, 0x00, 0xF8, 0x08, 0x12, 0x24,
    0x48, 0x90, 0x20, 0x41, 0x7C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x8F, 0x48, 0x24, 0xF2, 0x08, 0x04, 0x02, 0x00, 0x00,
    0x00, 0x00, 0xF8, 0x08, 0x12, 0x24, 0x48, 0x90, 0x20, 0x41, 0x7C, 0x40, 0x00, 0x01, 0x00, 0x00, 0x8F, 0x48, 0x24,
    0xF2, 0x48, 0x44, 0x22, 0x00, 0x00, 0x00, 0x80, 0x27, 0x08, 0x06, 0x06, 0x41, 0x1E, 0x00, 0x00, 0x00, 0x1F, 0x02,
    0x81, 0x40, 0x20, 0x10, 0x08, 0x00, 0x00, 0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x3C, 0x00, 0x00,
    0x00, 0x80, 0xA0, 0x48, 0x24, 0xA2, 0x50, 0x28, 0x08, 0x00, 0x00, 0x00, 0x00, 0xC4, 0x28, 0x93, 0x4C, 0x4A, 0x29,
    0xA5, 0x14, 0x21, 0x84, 0x00, 0x00, 0x00, 0x00, 0x40, 0x28, 0x31, 0x0C, 0x23, 0x49, 0x21, 0x00, 0x00, 0x40, 0x28,
    0x49, 0x0C, 0x82, 0x20, 0x08, 0x00, 0x00, 0x80, 0x07, 0x21, 0x08, 0x21, 0x08, 0x1E, 0x00, 0x00, 0xE0, 0x22, 0x22,
    0x22, 0x22, 0x0E, 0x10, 0x22, 0x42, 0x44, 0x08, 0x00, 0x70, 0x44, 0x44, 0x44, 0x44, 0x07, 0x00, 0xC3, 0x48, 0x52,
    0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7C, 0x00, 0x04, 0x02, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x90, 0x27, 0x49, 0x1E, 0x00, 0x00, 0x00, 0x81, 0xC0, 0x23, 0x12, 0x89, 0x44,
    0x1E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2E, 0x84, 0x10, 0x1C, 0x00, 0x00, 0x00, 0x10, 0x88, 0x27, 0x12, 0x89, 0x44,
    0x3C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x92, 0x27, 0x08, 0x1C, 0x00, 0x00, 0x80, 0x89, 0x27, 0x84, 0x10, 0x02,
    0x00, 0x00, 0x00, 0x00, 0xF8, 0x92, 0xE4, 0x08, 0x5E, 0x18, 0x7A, 0x00, 0x81, 0xC0, 0x23, 0x12, 0x89, 0x44, 0x22,
    0x00, 0x00, 0x00, 0x10, 0x24, 0x49, 0x02, 0x00, 0x40, 0x40, 0x44, 0x44, 0x44, 0x74, 0x80, 0x20, 0x48, 0x8A, 0xA1,
    0x48, 0x12, 0x00, 0x00, 0x90, 0x24, 0x49, 0x02, 0x00, 0x00, 0x00, 0x00, 0x80, 0x77, 0x22, 0x89, 0x24, 0x92, 0x48,
    0x22, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x23, 0x12, 0x89, 0x44, 0x22, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80,
    0x23, 0x12, 0x89, 0x44, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x23, 0x12, 0x89, 0x44, 0x1E, 0x81, 0x40, 0x00,
    0x00, 0x00, 0x80, 0x27, 0x12, 0x89, 0x44, 0x3C, 0x10, 0x08, 0x04, 0x00, 0xE0, 0x22, 0x22, 0x02, 0x00, 0x00, 0x00,
    0x27, 0x0C, 0x82, 0x0E, 0x00, 0x00, 0x00, 0xF2, 0x22, 0x22, 0x0E, 0x00, 0x00, 0x00, 0x40, 0x24, 0x12, 0x89, 0x44,
    0x3E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x84, 0x92, 0x24, 0x31, 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x88, 0xA8, 0x4A,
    0x95, 0x2A, 0x22, 0x44, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x48, 0x12, 0xC3, 0x48, 0x12, 0x00, 0x00, 0x00, 0x00,
    0x84, 0x92, 0x24, 0x31, 0x0C, 0x41, 0x0C, 0x00, 0x80, 0x8F, 0x08, 0x11, 0x1F, 0x00, 0x00, 0xC0, 0x44, 0x24, 0x42,
    0x44, 0x0C, 0x00, 0x82, 0x20, 0x08, 0x82, 0x20, 0x08, 0x82, 0x20, 0x30, 0x22, 0x42, 0x24, 0x22, 0x03, 0x00, 0x00,
    0x00, 0x06, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x9F, 0x48, 0x24, 0x12, 0x89, 0x44, 0x3E, 0x00, 0x00, 0x00
]
charactersOPEN_SANS_REGULAR_11PX = [
    FontCharacter(3, 5, 0), FontCharacter(3, 5, 5), FontCharacter(4, 6, 10), FontCharacter(7, 11, 16),
    FontCharacter(6, 9, 27), FontCharacter(9, 14, 36), FontCharacter(8, 12, 50), FontCharacter(2, 3, 62),
    FontCharacter(3, 5, 65),
    FontCharacter(3, 5, 70), FontCharacter(6, 9, 75), FontCharacter(6, 9, 84), FontCharacter(3, 5, 93),
    FontCharacter(4, 6, 98), FontCharacter(3, 5, 104), FontCharacter(4, 6, 109), FontCharacter(6, 9, 115),
    FontCharacter(6, 9, 124), FontCharacter(6, 9, 133), FontCharacter(6, 9, 142), FontCharacter(8, 12, 151),
    FontCharacter(6, 9, 163), FontCharacter(6, 9, 172), FontCharacter(6, 9, 181), FontCharacter(6, 9, 190),
    FontCharacter(6, 9, 199), FontCharacter(3, 5, 208), FontCharacter(3, 5, 213), FontCharacter(6, 9, 218),
    FontCharacter(6, 9, 227), FontCharacter(6, 9, 236), FontCharacter(5, 8, 245), FontCharacter(10, 15, 253),
    FontCharacter(7, 11, 268), FontCharacter(7, 11, 279), FontCharacter(7, 11, 290), FontCharacter(8, 12, 301),
    FontCharacter(6, 9, 313), FontCharacter(6, 9, 322), FontCharacter(8, 12, 331), FontCharacter(8, 12, 343),
    FontCharacter(3, 5, 355), FontCharacter(4, 6, 360), FontCharacter(7, 11, 366), FontCharacter(6, 9, 377),
    FontCharacter(10, 15, 386), FontCharacter(8, 12, 401), FontCharacter(9, 14, 413), FontCharacter(7, 11, 427),
    FontCharacter(9, 14, 438), FontCharacter(7, 11, 452), FontCharacter(6, 9, 463), FontCharacter(7, 11, 472),
    FontCharacter(8, 12, 483), FontCharacter(7, 11, 495), FontCharacter(10, 15, 506), FontCharacter(6, 9, 521),
    FontCharacter(6, 9, 530), FontCharacter(6, 9, 539), FontCharacter(4, 6, 548), FontCharacter(4, 6, 554),
    FontCharacter(4, 6, 560), FontCharacter(6, 9, 566), FontCharacter(5, 8, 575), FontCharacter(6, 9, 583),
    FontCharacter(6, 9, 592), FontCharacter(7, 11, 601), FontCharacter(5, 8, 612), FontCharacter(7, 11, 620),
    FontCharacter(6, 9, 631), FontCharacter(5, 8, 640), FontCharacter(6, 9, 648), FontCharacter(7, 11, 657),
    FontCharacter(3, 5, 668), FontCharacter(4, 6, 673), FontCharacter(6, 9, 679), FontCharacter(3, 5, 688),
    FontCharacter(10, 15, 693), FontCharacter(7, 11, 708), FontCharacter(7, 11, 719), FontCharacter(7, 11, 730),
    FontCharacter(7, 11, 741), FontCharacter(4, 6, 752), FontCharacter(5, 8, 758), FontCharacter(4, 6, 766),
    FontCharacter(7, 11, 772), FontCharacter(6, 9, 783), FontCharacter(9, 14, 792), FontCharacter(6, 9, 806),
    FontCharacter(6, 9, 815), FontCharacter(5, 8, 824), FontCharacter(4, 6, 832), FontCharacter(6, 9, 838),
    FontCharacter(4, 6, 847), FontCharacter(6, 9, 853), FontCharacter(7, 11, 862)
]

bitmapOPEN_SANS_LIGHT_16PX = [
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0x24, 0x49, 0x02, 0x24, 0x00, 0x00, 0x80, 0x24, 0x49,
    0x12, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x02, 0x09, 0x22, 0x88, 0xF8, 0x8F,
    0x04, 0x12, 0xFF, 0x11, 0x41, 0x04, 0x09, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0xE0, 0xA1,
    0x20, 0x41, 0x02, 0x05, 0x1C, 0x70, 0x20, 0x41, 0x92, 0xC2, 0x03, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80,
    0x41, 0x48, 0x04, 0x89, 0x20, 0x09, 0x24, 0x81, 0x94, 0x61, 0x4A, 0x20, 0x09, 0x24, 0x41, 0x24, 0x88, 0x84, 0x60,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x01, 0x11, 0x88, 0x40, 0x04, 0x14, 0x60, 0x80,
    0x44, 0x42, 0x12, 0x94, 0x40, 0x0C, 0xC3, 0x27, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0x24, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x40, 0x24, 0x22, 0x22, 0x22, 0x22, 0x22, 0x44, 0x00, 0x20, 0x42, 0x44, 0x44, 0x44, 0x44, 0x44,
    0x22, 0x00, 0x10, 0x20, 0x40, 0xF0, 0x87, 0x02, 0x05, 0x11, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x01, 0x82, 0x3F, 0x08, 0x10, 0x20, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x24, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0E,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x06, 0x00, 0x00, 0x00, 0x22, 0x84, 0x08,
    0x21, 0x44, 0x08, 0x11, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x10, 0x11, 0x24, 0x48, 0x90, 0x20, 0x41, 0x82, 0x04,
    0x09, 0x22, 0x82, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x60, 0xA0, 0x00, 0x01, 0x02, 0x04, 0x08,
    0x10, 0x20, 0x40, 0x80, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x08, 0x01, 0x02, 0x04, 0x08,
    0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0xE0, 0x0F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x08, 0x01, 0x04,
    0x04, 0x0C, 0x0F, 0x20, 0x80, 0x00, 0x01, 0x02, 0xE2, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04,
    0x30, 0x40, 0x01, 0x09, 0x48, 0x20, 0x82, 0x10, 0x84, 0xF0, 0x1F, 0x20, 0x00, 0x01, 0x08, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xF8, 0x10, 0x20, 0x40, 0x40, 0x80, 0x0F, 0x60, 0x80, 0x00, 0x01, 0x12, 0xC2, 0x03, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x30, 0x20, 0x20, 0x40, 0x80, 0x1E, 0x43, 0x82, 0x04, 0x09, 0x22, 0x84,
    0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x01, 0x02, 0x02, 0x04, 0x08, 0x08, 0x10, 0x10, 0x20, 0x40,
    0x40, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x10, 0x11, 0x24, 0x88, 0x08, 0x0E, 0x22, 0x82,
    0x04, 0x09, 0x12, 0xC4, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x08, 0x11, 0x24, 0x48, 0x90, 0x30,
    0x5E, 0x80, 0x00, 0x01, 0x01, 0xC3, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x00, 0x00, 0x60,
    0x06, 0x00, 0x00, 0x00, 0x00, 0x66, 0x00, 0x00, 0x20, 0x22, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x06, 0x83,
    0x01, 0x0C, 0x60, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xC0, 0x1F, 0x00, 0x00, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x10, 0xC0, 0x00, 0x06, 0x30, 0x18, 0x0C, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x0F, 0x08, 0x04, 0x02, 0x41, 0x10, 0x04, 0x02, 0x80, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF8, 0x80,
    0x41, 0x10, 0x20, 0xC4, 0x93, 0x88, 0x24, 0x21, 0x49, 0x48, 0x12, 0x92, 0xC4, 0x24, 0xEE, 0x08, 0x00, 0x04, 0x00,
    0x02, 0x00, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0x03, 0x0C, 0x48, 0x20, 0x81, 0x04, 0x21,
    0xFC, 0x08, 0x24, 0x90, 0x40, 0x01, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF0, 0x41, 0x08, 0x41, 0x04,
    0x11, 0xC2, 0x07, 0x21, 0x04, 0x11, 0x44, 0x10, 0x21, 0x7C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0,
    0x87, 0x00, 0x01, 0x02, 0x08, 0x20, 0x80, 0x00, 0x02, 0x08, 0x40, 0x00, 0x02, 0xF0, 0x01, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xE0, 0x03, 0x21, 0x08, 0x42, 0x20, 0x02, 0x11, 0x88, 0x40, 0x04, 0x22, 0x10, 0x41, 0x08, 0xC1,
    0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF8, 0x11, 0x20, 0x40, 0x80, 0x00, 0x3F, 0x02, 0x04, 0x08,
    0x10, 0x20, 0xC0, 0x0F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x04, 0x04, 0x04, 0x04, 0x04, 0xFC, 0x04,
    0x04, 0x04, 0x04, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x08, 0x40, 0x00, 0x02, 0x20, 0x00, 0x02,
    0x20, 0x7C, 0x02, 0x24, 0x40, 0x04, 0x84, 0x40, 0xF0, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40,
    0x20, 0x04, 0x42, 0x20, 0x04, 0x42, 0x20, 0xFC, 0x43, 0x20, 0x04, 0x42, 0x20, 0x04, 0x42, 0x20, 0x04, 0x02, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x44, 0x44, 0x44, 0x44, 0x44, 0x04, 0x00, 0x00, 0x00, 0x04, 0x02, 0x81,
    0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x81, 0x40, 0x20, 0x0C, 0x00, 0x00, 0x00, 0x08, 0x12, 0x22, 0x42, 0x82, 0x02,
    0x03, 0x0A, 0x24, 0x88, 0x10, 0x21, 0x44, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x04, 0x04, 0x04,
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0xFC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x42, 0xC0, 0x30,
    0x30, 0x0C, 0x0C, 0x85, 0x42, 0xA1, 0x50, 0x28, 0x24, 0x09, 0x49, 0x42, 0x8C, 0x10, 0x23, 0x04, 0x08, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x20, 0x0C, 0xC2, 0x20, 0x14, 0x42, 0x21, 0x24, 0x42, 0x24,
    0x44, 0x42, 0x28, 0x04, 0x43, 0x30, 0x04, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0F, 0x08,
    0x41, 0x20, 0x02, 0x24, 0x40, 0x02, 0x24, 0x40, 0x02, 0x24, 0x40, 0x04, 0x82, 0x10, 0xF0, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xF8, 0x10, 0x22, 0x44, 0x88, 0x10, 0x21, 0x3E, 0x04, 0x08, 0x10, 0x20, 0x40, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0F, 0x08, 0x41, 0x20, 0x02, 0x24, 0x40, 0x02, 0x24, 0x40, 0x02,
    0x24, 0x40, 0x04, 0x82, 0x10, 0xF0, 0x00, 0x08, 0x00, 0x01, 0x30, 0x00, 0x00, 0x00, 0x00, 0xF0, 0x41, 0x08, 0x41,
    0x04, 0x11, 0x44, 0x08, 0x1F, 0x44, 0x10, 0x41, 0x08, 0x41, 0x04, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xF8, 0x08, 0x12, 0x20, 0x40, 0x00, 0x07, 0x30, 0x80, 0x00, 0x01, 0x02, 0xE4, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x80, 0x3F, 0x02, 0x81, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x81, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40,
    0x20, 0x04, 0x42, 0x20, 0x04, 0x42, 0x20, 0x04, 0x42, 0x20, 0x04, 0x42, 0x20, 0x04, 0x82, 0x10, 0xF0, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x06, 0x14, 0x24, 0x48, 0x10, 0x11, 0x22, 0x44, 0x50, 0xA0, 0x80,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x30, 0x28, 0x0C, 0x09, 0x43, 0x22, 0x91, 0x48, 0x44,
    0x92, 0x90, 0x24, 0x14, 0x0A, 0x85, 0x82, 0x61, 0x60, 0x18, 0x08, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x04, 0x09, 0x22, 0x82, 0x04, 0x05, 0x04, 0x14, 0x28, 0x88, 0x10, 0x11, 0x14, 0x10, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x81, 0x42, 0x42, 0x24, 0x24, 0x18, 0x18, 0x10, 0x10, 0x10, 0x10, 0x10, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xFC, 0x01, 0x02, 0x02, 0x04, 0x04, 0x04, 0x08, 0x08, 0x08, 0x10, 0x10, 0xE0, 0x0F, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x0B, 0x21, 0x84, 0x10, 0x42, 0x08, 0x21, 0x84, 0xF0, 0x00, 0x00, 0x20, 0x08,
    0x21, 0x08, 0x21, 0x04, 0x21, 0x04, 0x01, 0x00, 0x00, 0x00, 0xE0, 0x21, 0x84, 0x10, 0x42, 0x08, 0x21, 0x84, 0x10,
    0x7A, 0x00, 0x00, 0x00, 0x20, 0xA0, 0x40, 0x41, 0x84, 0x88, 0x20, 0x41, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x01,
    0x00, 0x00, 0x08, 0x20, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3C, 0x40, 0x40, 0x40, 0x7C, 0x42, 0x42, 0x62, 0x5C, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x02, 0x08, 0x20, 0x80, 0x00, 0x7A, 0x18, 0x22, 0x90, 0x40, 0x02, 0x09, 0x24, 0x90, 0x21, 0x7A,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x04, 0x02, 0x02, 0x02, 0x02, 0x02, 0x04,
    0x78, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x04, 0x10, 0x40, 0x78, 0x11, 0x26, 0x90, 0x40, 0x02, 0x09, 0x24,
    0x10, 0x61, 0x78, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x83, 0x88, 0x20, 0x41,
    0xFE, 0x04, 0x08, 0x20, 0x84, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x38, 0x41, 0x10, 0x1F, 0x41, 0x10, 0x04,
    0x41, 0x10, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x22, 0x42, 0x42, 0x22, 0x3C, 0x04, 0x02,
    0x7C, 0x42, 0x81, 0x43, 0x3E, 0x00, 0x02, 0x04, 0x08, 0x10, 0xA0, 0xC3, 0x88, 0x20, 0x41, 0x82, 0x04, 0x09, 0x12,
    0x24, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x20, 0x22, 0x22, 0x22, 0x02, 0x00, 0x00, 0x00, 0x10,
    0x00, 0x08, 0x21, 0x84, 0x10, 0x42, 0x08, 0x21, 0x07, 0x00, 0x02, 0x02, 0x02, 0x02, 0x42, 0x22, 0x12, 0x0A, 0x0A,
    0x16, 0x22, 0x42, 0x82, 0x00, 0x00, 0x00, 0x00, 0x00, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x04, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3A, 0x87, 0x31, 0x22, 0x08, 0x09, 0x42, 0x82, 0x90, 0x20, 0x24, 0x08, 0x09,
    0x42, 0x82, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xC3, 0x88,
    0x20, 0x41, 0x82, 0x04, 0x09, 0x12, 0x24, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80,
    0x83, 0x88, 0x20, 0x41, 0x82, 0x04, 0x09, 0x22, 0x82, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x7A, 0x18, 0x22, 0x90, 0x40, 0x02, 0x09, 0x24, 0x90, 0x21, 0x7A, 0x08, 0x20, 0x80, 0x00, 0x02, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x11, 0x26, 0x90, 0x40, 0x02, 0x09, 0x24, 0x10, 0x61, 0x78, 0x01, 0x04,
    0x10, 0x40, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0xBA, 0x21, 0x08, 0x82, 0x20, 0x08, 0x02, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xC0, 0x13, 0x08, 0x0C, 0x18, 0x10, 0x08, 0xE4, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF1,
    0x84, 0x10, 0x42, 0x08, 0xC1, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x48, 0x90, 0x20, 0x41, 0x82,
    0x04, 0x09, 0x22, 0xC6, 0x0B, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x0C, 0x8A, 0x44, 0x22,
    0x0A, 0x85, 0x82, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x61, 0x28, 0x46, 0x62, 0x24,
    0x49, 0x92, 0x44, 0x29, 0x0C, 0x83, 0x10, 0x08, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x42, 0x42, 0x24, 0x18, 0x18, 0x18, 0x24, 0x42, 0x42, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10,
    0x0C, 0x8A, 0x44, 0x22, 0x0A, 0x85, 0x82, 0x40, 0x10, 0x08, 0x03, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x03, 0x41, 0x20,
    0x08, 0x02, 0x41, 0xE0, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46, 0x10, 0x04, 0x41, 0x10, 0x03, 0x41, 0x10, 0x04,
    0x41, 0x60, 0x00, 0x00, 0x10, 0x20, 0x40, 0x80, 0x00, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x00, 0x01,
    0x02, 0x04, 0x08, 0x10, 0x00, 0x00, 0x80, 0x41, 0x20, 0x08, 0x82, 0x20, 0x30, 0x82, 0x20, 0x08, 0x42, 0x18, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x03, 0x78, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x0F, 0x21, 0x84, 0x10, 0x42, 0x08, 0x21, 0x84, 0x10, 0x42, 0x08, 0x21, 0xFC,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
]
charactersOPEN_SANS_LIGHT_16PX = [
    FontCharacter(3, 7, 9), FontCharacter(6, 14, 16), FontCharacter(10, 23, 30), FontCharacter(9, 21, 53),
    FontCharacter(13, 30, 74), FontCharacter(11, 25, 104), FontCharacter(3, 7, 129), FontCharacter(4, 9, 136),
    FontCharacter(4, 9, 145), FontCharacter(9, 21, 154), FontCharacter(9, 21, 175), FontCharacter(3, 7, 196),
    FontCharacter(5, 12, 203), FontCharacter(4, 9, 215), FontCharacter(5, 12, 224), FontCharacter(9, 21, 236),
    FontCharacter(9, 21, 257), FontCharacter(9, 21, 278), FontCharacter(9, 21, 299), FontCharacter(11, 25, 320),
    FontCharacter(9, 21, 345), FontCharacter(9, 21, 366), FontCharacter(9, 21, 387), FontCharacter(9, 21, 408),
    FontCharacter(9, 21, 429), FontCharacter(4, 9, 450), FontCharacter(4, 9, 459), FontCharacter(9, 21, 468),
    FontCharacter(9, 21, 489), FontCharacter(9, 21, 510), FontCharacter(7, 16, 531), FontCharacter(14, 32, 547),
    FontCharacter(10, 23, 579), FontCharacter(10, 23, 602), FontCharacter(10, 23, 625), FontCharacter(11, 25, 648),
    FontCharacter(9, 21, 673), FontCharacter(8, 18, 694), FontCharacter(12, 27, 712), FontCharacter(12, 27, 739),
    FontCharacter(4, 9, 766), FontCharacter(7, 16, 775), FontCharacter(9, 21, 791), FontCharacter(8, 18, 812),
    FontCharacter(14, 32, 830), FontCharacter(12, 27, 862), FontCharacter(12, 27, 889), FontCharacter(9, 21, 916),
    FontCharacter(12, 27, 937), FontCharacter(10, 23, 964), FontCharacter(9, 21, 987), FontCharacter(7, 16, 1008),
    FontCharacter(12, 27, 1024), FontCharacter(9, 21, 1051), FontCharacter(14, 32, 1072), FontCharacter(9, 21, 1104),
    FontCharacter(8, 18, 1125), FontCharacter(9, 21, 1143), FontCharacter(5, 12, 1164), FontCharacter(5, 12, 1176),
    FontCharacter(5, 12, 1188), FontCharacter(9, 21, 1200), FontCharacter(7, 16, 1221), FontCharacter(9, 21, 1237),
    FontCharacter(8, 18, 1258), FontCharacter(10, 23, 1276), FontCharacter(8, 18, 1299), FontCharacter(10, 23, 1317),
    FontCharacter(9, 21, 1340), FontCharacter(6, 14, 1361), FontCharacter(8, 18, 1375), FontCharacter(9, 21, 1393),
    FontCharacter(4, 9, 1414), FontCharacter(5, 12, 1423), FontCharacter(8, 18, 1435), FontCharacter(4, 9, 1453),
    FontCharacter(14, 32, 1462), FontCharacter(9, 21, 1494), FontCharacter(9, 21, 1515), FontCharacter(10, 23, 1536),
    FontCharacter(10, 23, 1559), FontCharacter(6, 14, 1582), FontCharacter(7, 16, 1596), FontCharacter(5, 12, 1612),
    FontCharacter(9, 21, 1624), FontCharacter(7, 16, 1645), FontCharacter(12, 27, 1661), FontCharacter(8, 18, 1688),
    FontCharacter(7, 16, 1706), FontCharacter(7, 16, 1722), FontCharacter(6, 14, 1738), FontCharacter(9, 21, 1752),
    FontCharacter(6, 14, 1773), FontCharacter(9, 21, 1787), FontCharacter(10, 23, 1808)
]

bitmapOPEN_SANS_REGULAR_10_13PX = [
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x3f, 0xf0, 0x01, 0x1e, 0xd0, 0x00, 0x0c, 0xb0, 0x00, 0x00, 0xa0, 0x02, 0x3e, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x0f, 0x1f, 0xd0, 0xd0, 0x00, 0x0b, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc1, 0x60, 0x07, 0x00, 0x85, 0xa0, 0x03, 0xd3, 0xee, 0xfd, 0xad, 0x00, 0x2a,
    0xc0, 0x00, 0x00, 0x0d, 0xa3, 0x00, 0xda, 0xdf, 0xee, 0x3d, 0x30, 0x0a, 0x48, 0x00, 0x50, 0x07, 0x2b, 0x00, 0x80,
    0x05, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xd0, 0x00, 0x00, 0xd4, 0xdf, 0x0a, 0xe0, 0xd2, 0x10, 0x10, 0x0f, 0x0d, 0x00, 0xb0, 0xea, 0x00, 0x00, 0x70,
    0xbf, 0x02, 0x00, 0xd0, 0xe6, 0x00, 0x00, 0x0d, 0x1d, 0x11, 0xd0, 0xe2, 0x20, 0xec, 0xcf, 0x03, 0x00, 0xd0, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc9, 0x0a,
    0x00, 0x59, 0x00, 0xb1, 0x70, 0x05, 0xb3, 0x00, 0x40, 0x08, 0x74, 0xc0, 0x02, 0x00, 0x84, 0x40, 0x57, 0xb9, 0x7c,
    0x10, 0x0b, 0x68, 0x6d, 0x07, 0x1b, 0x80, 0xbc, 0x59, 0x48, 0x80, 0x03, 0x00, 0xc2, 0x80, 0x04, 0x38, 0x00, 0xb0,
    0x03, 0x75, 0xb0, 0x01, 0x50, 0x09, 0x00, 0xcb, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa0, 0xdd,
    0x03, 0x00, 0x60, 0x0a, 0xb5, 0x00, 0x00, 0x96, 0x40, 0x0c, 0x00, 0x10, 0x4e, 0x4d, 0x00, 0x00, 0xb0, 0x6f, 0x00,
    0x00, 0xc0, 0x58, 0x2d, 0xc0, 0x33, 0x0c, 0x30, 0x7d, 0x0c, 0xe2, 0x02, 0x80, 0x6f, 0x00, 0xe7, 0xdf, 0x29, 0x6c,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x10, 0x0f, 0xe0, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x3c, 0x70, 0x09, 0xe0, 0x02, 0xd3, 0x00, 0xb5, 0x00, 0x97, 0x00, 0xb5, 0x00, 0xd3, 0x00,
    0xe0, 0x02, 0x70, 0x09, 0x00, 0x3c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc3, 0x00, 0x90, 0x07, 0x20, 0x0e, 0x00,
    0x3d, 0x00, 0x5b, 0x00, 0x79, 0x00, 0x5b, 0x00, 0x3d, 0x20, 0x0e, 0x90, 0x08, 0xc3, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xf1, 0x00, 0x00, 0x00, 0x0d, 0x00, 0xe5, 0xd9, 0xe9, 0x05, 0x71, 0x7e, 0x01, 0x00, 0x3e, 0x0d, 0x00, 0x94,
    0x90, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xa0, 0x00, 0x00, 0x00, 0x0d, 0x00, 0x00, 0xd0, 0x00, 0x60, 0xdd, 0xdf, 0x8d, 0x00, 0xd0, 0x00, 0x00, 0x00, 0x0d,
    0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x40, 0x0b, 0x57,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf7, 0x7f,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa0, 0x02, 0x3e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xa6, 0x00, 0xd0, 0x03, 0x30, 0x0d, 0x00, 0x6a, 0x00, 0xe0, 0x00, 0x60, 0x0a, 0x00, 0x3d, 0x00, 0xd3, 0x00,
    0xa0, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc2, 0xce,
    0x02, 0xd0, 0x04, 0xc5, 0x20, 0x0d, 0x00, 0x2d, 0xb5, 0x00, 0xb0, 0x55, 0x0b, 0x00, 0x5b, 0xb5, 0x00, 0xb0, 0x25,
    0x0d, 0x00, 0x2d, 0xc0, 0x04, 0xd5, 0x00, 0xc2, 0xce, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x5e, 0x00, 0x30, 0xcd, 0x05, 0x00, 0x39, 0x5a, 0x00,
    0x00, 0xb0, 0x05, 0x00, 0x00, 0x5b, 0x00, 0x00, 0xb0, 0x05, 0x00, 0x00, 0x5b, 0x00, 0x00, 0xb0, 0x05, 0x00, 0x00,
    0x5b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xd7, 0xce, 0x02, 0x80, 0x00, 0xc6, 0x00, 0x00, 0x10, 0x0f, 0x00, 0x00, 0xb4, 0x00, 0x00, 0xd1, 0x02, 0x00,
    0xb0, 0x04, 0x00, 0xb0, 0x06, 0x00, 0xb0, 0x06, 0x00, 0x50, 0xff, 0xff, 0x5f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe9, 0xce, 0x03, 0x61, 0x00, 0xd5, 0x00,
    0x00, 0x10, 0x0f, 0x00, 0x10, 0x99, 0x00, 0xd1, 0xce, 0x02, 0x00, 0x00, 0xe4, 0x01, 0x00, 0x00, 0x3d, 0x12, 0x00,
    0xe4, 0x41, 0xec, 0xce, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x07, 0x00, 0x90, 0x7c, 0x00, 0x40, 0x7a, 0x07, 0x00, 0x0d, 0x77, 0x00, 0x4a,
    0x70, 0x07, 0xa5, 0x00, 0x77, 0xb0, 0xff, 0xff, 0xbf, 0x00, 0x00, 0x77, 0x00, 0x00, 0x70, 0x07, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfb, 0xff, 0x09, 0xc0,
    0x02, 0x00, 0x00, 0x1d, 0x00, 0x00, 0xe0, 0xed, 0x4c, 0x00, 0x00, 0x40, 0x0e, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00,
    0x3d, 0x21, 0x00, 0xd5, 0x10, 0xec, 0xbe, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0xdd, 0x0a, 0x60, 0x1b, 0x00, 0x00, 0x1e, 0x00, 0x00, 0xd2, 0xd8,
    0x6d, 0x30, 0x3f, 0x10, 0x2e, 0xc3, 0x00, 0xa0, 0x25, 0x0e, 0x00, 0x5a, 0xc0, 0x06, 0xe2, 0x01, 0xb1, 0xde, 0x04,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xff,
    0xff, 0x5f, 0x00, 0x00, 0xe0, 0x01, 0x00, 0x60, 0x09, 0x00, 0x00, 0x2d, 0x00, 0x00, 0xb4, 0x00, 0x00, 0xb0, 0x04,
    0x00, 0x20, 0x0d, 0x00, 0x00, 0x69, 0x00, 0x00, 0xe1, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd4, 0xdd, 0x04, 0xe0, 0x02, 0xe2, 0x00, 0x0f, 0x00,
    0x0f, 0x90, 0x19, 0x89, 0x00, 0xd1, 0xcf, 0x00, 0xc0, 0x05, 0xd7, 0x50, 0x0a, 0x00, 0x5b, 0xd3, 0x00, 0xe1, 0x03,
    0xd7, 0xdd, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xd3, 0xbe, 0x02, 0xe0, 0x03, 0xd5, 0x40, 0x0b, 0x00, 0x2d, 0xb5, 0x00, 0xb0, 0x15, 0x1e, 0x30, 0x5e,
    0x60, 0xdd, 0xc9, 0x03, 0x00, 0x00, 0x0e, 0x00, 0x00, 0x7a, 0x00, 0xda, 0x7d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3f, 0xa0, 0x02, 0x00, 0x00,
    0x00, 0x00, 0xa0, 0x02, 0x3e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x3e, 0xa0, 0x01,
    0x00, 0x00, 0x00, 0x00, 0xf2, 0x50, 0x0b, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x81, 0x04, 0x10, 0xb8, 0x04, 0x80, 0x3b, 0x00, 0x20, 0x8c, 0x01, 0x00, 0x00, 0xb4, 0x4a, 0x00,
    0x00, 0x20, 0x49, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xd3, 0xdd, 0xdd, 0x03, 0x00, 0x00, 0x00, 0xd3, 0xdd, 0xdd, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x84, 0x01, 0x00, 0x00, 0xc4, 0x18, 0x00, 0x00, 0x30, 0x8b, 0x00, 0x00, 0x81, 0x2c, 0x40,
    0xba, 0x04, 0x40, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc5, 0xff, 0x1a, 0x13, 0x00, 0x89, 0x00, 0x00,
    0x87, 0x00, 0x60, 0x0b, 0x00, 0x79, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x20, 0x0a, 0x00, 0x30, 0x0e, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x40, 0xcb, 0xdd, 0x19, 0x00, 0x00, 0x9a, 0x01, 0x00, 0xc4, 0x02, 0x60, 0x08, 0xc4, 0xcc, 0x32, 0x0b, 0xd0, 0x10,
    0x0d, 0xb0, 0x03, 0x0c, 0xb2, 0x60, 0x08, 0xb0, 0x03, 0x39, 0xa3, 0x70, 0x07, 0xc0, 0x01, 0x2a, 0xc1, 0x40, 0x0a,
    0xe2, 0x12, 0x0c, 0xc0, 0x02, 0xc9, 0x3b, 0xcc, 0x03, 0x30, 0x4d, 0x00, 0x00, 0x02, 0x00, 0x00, 0x92, 0xdd, 0xcd,
    0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0x0a, 0x00, 0x00, 0xd0, 0x0d, 0x00, 0x00, 0x86, 0x68, 0x00, 0x00, 0x2c,
    0xc1, 0x00, 0x30, 0x0b, 0xb0, 0x03, 0x90, 0xff, 0xff, 0x09, 0xe0, 0x00, 0x00, 0x0e, 0x96, 0x00, 0x00, 0x6a, 0x3c,
    0x00, 0x00, 0xc4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xb0, 0xff, 0xbf, 0x03, 0xb0, 0x03, 0x70, 0x0d, 0xb0, 0x03, 0x10, 0x0f, 0xb0, 0x03, 0x70,
    0x0a, 0xb0, 0xde, 0xde, 0x02, 0xb0, 0x03, 0x30, 0x1e, 0xb0, 0x03, 0x00, 0x3d, 0xb0, 0x03, 0x40, 0x1f, 0xb0, 0xde,
    0xde, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xb3, 0xff, 0x4d, 0x40, 0x5e, 0x00, 0x12, 0xd0, 0x05, 0x00, 0x00, 0xf1, 0x00, 0x00, 0x00,
    0xf3, 0x00, 0x00, 0x00, 0xf2, 0x00, 0x00, 0x00, 0xd0, 0x05, 0x00, 0x00, 0x50, 0x4e, 0x00, 0x01, 0x00, 0xc5, 0xff,
    0x2d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xfb, 0xff, 0x4b, 0x00, 0xb0, 0x03, 0x40, 0x5e, 0x00, 0x3b, 0x00, 0x40, 0x0e, 0xb0, 0x03, 0x00,
    0xe0, 0x02, 0x3b, 0x00, 0x00, 0x3d, 0xb0, 0x03, 0x00, 0xf0, 0x02, 0x3b, 0x00, 0x40, 0x0d, 0xb0, 0x03, 0x50, 0x5e,
    0x00, 0xfb, 0xef, 0x3b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfb, 0xff, 0x3f, 0xb0, 0x05, 0x00, 0x00, 0x5b, 0x00, 0x00, 0xb0,
    0x05, 0x00, 0x00, 0xfb, 0xff, 0x0f, 0xb0, 0x05, 0x00, 0x00, 0x5b, 0x00, 0x00, 0xb0, 0x05, 0x00, 0x00, 0xfb, 0xff,
    0x3f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xf9, 0xff, 0xbf, 0x90, 0x05, 0x00, 0x00, 0x59, 0x00, 0x00, 0x90, 0x05, 0x00, 0x00, 0xf9, 0xff, 0x7f, 0x90, 0x05,
    0x00, 0x00, 0x59, 0x00, 0x00, 0x90, 0x05, 0x00, 0x00, 0x59, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0xeb, 0xdf, 0x08, 0x40, 0x5e, 0x00,
    0x41, 0x00, 0x5d, 0x00, 0x00, 0x00, 0xf2, 0x00, 0x00, 0x00, 0x30, 0x0d, 0x00, 0xfd, 0x1f, 0xf2, 0x00, 0x00, 0xf0,
    0x01, 0x4e, 0x00, 0x00, 0x1f, 0x50, 0x4e, 0x00, 0xf0, 0x01, 0x40, 0xfc, 0xef, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90,
    0x05, 0x00, 0x50, 0x09, 0x90, 0x05, 0x00, 0x50, 0x09, 0x90, 0x05, 0x00, 0x50, 0x09, 0x90, 0x05, 0x00, 0x50, 0x09,
    0x90, 0xff, 0xff, 0xff, 0x09, 0x90, 0x05, 0x00, 0x50, 0x09, 0x90, 0x05, 0x00, 0x50, 0x09, 0x90, 0x05, 0x00, 0x50,
    0x09, 0x90, 0x05, 0x00, 0x50, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0x07, 0x90, 0x07, 0x90, 0x07, 0x90, 0x07, 0x90, 0x07,
    0x90, 0x07, 0x90, 0x07, 0x90, 0x07, 0x90, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x1f, 0x00, 0xf0, 0x01, 0x00, 0x1f, 0x00, 0xf0, 0x01, 0x00, 0x1f, 0x00, 0xf0, 0x01, 0x00, 0x1f, 0x00, 0xf0,
    0x01, 0x00, 0x1f, 0x00, 0xf2, 0x10, 0xef, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x05,
    0x00, 0x5d, 0xb0, 0x05, 0xb0, 0x06, 0xb0, 0x05, 0x6b, 0x00, 0xb0, 0xa5, 0x08, 0x00, 0xb0, 0xde, 0x08, 0x00, 0xb0,
    0x17, 0x5e, 0x00, 0xb0, 0x05, 0xe3, 0x01, 0xb0, 0x05, 0x60, 0x0c, 0xb0, 0x05, 0x00, 0x9a, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x59, 0x00, 0x00,
    0x90, 0x05, 0x00, 0x00, 0x59, 0x00, 0x00, 0x90, 0x05, 0x00, 0x00, 0x59, 0x00, 0x00, 0x90, 0x05, 0x00, 0x00, 0x59,
    0x00, 0x00, 0x90, 0x05, 0x00, 0x00, 0xf9, 0xff, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x1f, 0x00, 0x00, 0xf1, 0x0b, 0xb0, 0x8c, 0x00,
    0x00, 0xc8, 0x0b, 0xb0, 0xe6, 0x00, 0x00, 0x6d, 0x0b, 0xb0, 0xb3, 0x05, 0x50, 0x5a, 0x0b, 0xb0, 0x53, 0x0c, 0xc0,
    0x53, 0x0b, 0xb0, 0x03, 0x2e, 0xc2, 0x50, 0x0b, 0xb0, 0x03, 0x98, 0x69, 0x50, 0x0b, 0xb0, 0x03, 0xe1, 0x0e, 0x50,
    0x0b, 0xb0, 0x03, 0xb0, 0x09, 0x50, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x0c,
    0x00, 0x50, 0x0b, 0xb0, 0x8e, 0x00, 0x50, 0x0b, 0xb0, 0xe5, 0x03, 0x50, 0x0b, 0xb0, 0x53, 0x0d, 0x50, 0x0b, 0xb0,
    0x03, 0x9a, 0x50, 0x0b, 0xb0, 0x03, 0xd0, 0x44, 0x0b, 0xb0, 0x03, 0x30, 0x5e, 0x0b, 0xb0, 0x03, 0x00, 0xd8, 0x0b,
    0xb0, 0x03, 0x00, 0xd0, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc4, 0xff, 0x4c, 0x00, 0x50, 0x4e, 0x00,
    0xe3, 0x05, 0xd0, 0x04, 0x00, 0x40, 0x0d, 0xf2, 0x00, 0x00, 0x00, 0x1f, 0xd3, 0x00, 0x00, 0x00, 0x3d, 0xf1, 0x00,
    0x00, 0x00, 0x1f, 0xd0, 0x04, 0x00, 0x40, 0x0d, 0x50, 0x4e, 0x00, 0xe3, 0x04, 0x00, 0xc4, 0xff, 0x4b, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xb0, 0xff, 0xbf, 0x03, 0xb0, 0x05, 0x60, 0x0e, 0xb0, 0x05, 0x00, 0x3d, 0xb0, 0x05, 0x00,
    0x3d, 0xb0, 0x05, 0x71, 0x0c, 0xb0, 0xde, 0x9d, 0x01, 0xb0, 0x05, 0x00, 0x00, 0xb0, 0x05, 0x00, 0x00, 0xb0, 0x05,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xc4, 0xff, 0x4c, 0x00, 0x50, 0x4e, 0x00, 0xe3, 0x05, 0xd0, 0x04, 0x00, 0x40, 0x0d,
    0xf2, 0x00, 0x00, 0x00, 0x1f, 0xd3, 0x00, 0x00, 0x00, 0x3d, 0xf1, 0x00, 0x00, 0x00, 0x1f, 0xd0, 0x04, 0x00, 0x40,
    0x0d, 0x50, 0x4e, 0x00, 0xe3, 0x05, 0x00, 0xc4, 0xff, 0x4d, 0x00, 0x00, 0x00, 0x30, 0x3e, 0x00, 0x00, 0x00, 0x00,
    0xe4, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0xff, 0xcf,
    0x03, 0xb0, 0x05, 0x50, 0x0e, 0xb0, 0x05, 0x00, 0x1f, 0xb0, 0x05, 0x70, 0x0c, 0xb0, 0xde, 0xaf, 0x00, 0xb0, 0x05,
    0xb6, 0x00, 0xb0, 0x05, 0xd0, 0x05, 0xb0, 0x05, 0x40, 0x0d, 0xb0, 0x05, 0x00, 0x7b, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd4, 0xef, 0x0b, 0xf1,
    0x03, 0x40, 0x20, 0x0e, 0x00, 0x00, 0xc0, 0x19, 0x00, 0x00, 0x80, 0xbe, 0x02, 0x00, 0x00, 0xe6, 0x01, 0x00, 0x00,
    0x5b, 0x22, 0x00, 0xe3, 0x32, 0xfc, 0xcf, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xff, 0xff, 0xdf, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0xf0,
    0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x0f, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x3d, 0x00, 0x30, 0x0d, 0xd0, 0x03, 0x00, 0xd3, 0x00, 0x3d, 0x00, 0x30, 0x0d, 0xd0, 0x03, 0x00, 0xd3, 0x00, 0x3d,
    0x00, 0x30, 0x0d, 0xd0, 0x03, 0x00, 0xd3, 0x00, 0x4c, 0x00, 0x40, 0x0c, 0x60, 0x1c, 0x10, 0x6c, 0x00, 0x70, 0xfe,
    0x7d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x5c, 0x00, 0x00, 0xc5, 0xb6, 0x00, 0x00, 0x6b, 0xf0, 0x01, 0x10, 0x0f, 0xa0, 0x07,
    0x80, 0x0a, 0x40, 0x0d, 0xd0, 0x04, 0x00, 0x3d, 0xd4, 0x00, 0x00, 0x97, 0x79, 0x00, 0x00, 0xe1, 0x1e, 0x00, 0x00,
    0xb0, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x6a, 0x00, 0xb0, 0x0a, 0x00, 0xa6, 0xb6, 0x00, 0xe0, 0x0e, 0x00, 0x6b, 0xe1,
    0x00, 0xa5, 0x4b, 0x00, 0x1e, 0xd0, 0x03, 0x5a, 0x96, 0x30, 0x0d, 0x90, 0x07, 0x0e, 0xe1, 0x70, 0x09, 0x40, 0x4b,
    0x0b, 0xc0, 0xb3, 0x04, 0x00, 0x9e, 0x07, 0x70, 0xe8, 0x00, 0x00, 0xeb, 0x02, 0x20, 0xbe, 0x00, 0x00, 0xd7, 0x00,
    0x00, 0x7d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd5, 0x00, 0x00, 0x5c, 0xa0, 0x08, 0x80,
    0x09, 0x00, 0x3d, 0xd3, 0x00, 0x00, 0xd3, 0x2d, 0x00, 0x00, 0xd0, 0x0c, 0x00, 0x00, 0xa7, 0x7a, 0x00, 0x30, 0x0d,
    0xe1, 0x03, 0xd0, 0x04, 0x50, 0x0d, 0x99, 0x00, 0x00, 0x9a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x05, 0x00, 0xb5, 0xe2, 0x00, 0xd0, 0x02, 0x6a,
    0x60, 0x0a, 0x10, 0x1e, 0x1e, 0x00, 0x90, 0x9d, 0x00, 0x00, 0xf1, 0x02, 0x00, 0x00, 0x1f, 0x00, 0x00, 0xf0, 0x01,
    0x00, 0x00, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x50, 0xff, 0xff, 0x5f, 0x00, 0x00, 0xd4, 0x00, 0x00, 0xd0, 0x04, 0x00, 0x80, 0x0a, 0x00, 0x20, 0x1e,
    0x00, 0x00, 0x5c, 0x00, 0x00, 0xb6, 0x00, 0x00, 0xe1, 0x02, 0x00, 0x70, 0xff, 0xff, 0x7f, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0xad, 0xf0, 0x01, 0xf0, 0x01, 0xf0,
    0x01, 0xf0, 0x01, 0xf0, 0x01, 0xf0, 0x01, 0xf0, 0x01, 0xf0, 0x01, 0xf0, 0x01, 0xf0, 0xad, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xa0, 0x06, 0x00, 0xd3, 0x00, 0x00, 0x3d, 0x00, 0x60, 0x0a, 0x00, 0xe0, 0x00, 0x00, 0x6a, 0x00, 0x30,
    0x0d, 0x00, 0xc0, 0x04, 0x00, 0xa6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xda,
    0x0f, 0x00, 0x0f, 0x00, 0x0f, 0x00, 0x0f, 0x00, 0x0f, 0x00, 0x0f, 0x00, 0x0f, 0x00, 0x0f, 0x00, 0x0f, 0x00, 0x0f,
    0xda, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x0e, 0x00, 0x00, 0x6b, 0x08, 0x00, 0x84, 0xb0,
    0x02, 0xc0, 0x01, 0xb2, 0x60, 0x07, 0x00, 0x58, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xdd, 0xdd, 0xdd, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xe1, 0x05, 0x00, 0x00, 0x20, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd5, 0xed, 0x04, 0x20, 0x00, 0xe4, 0x00,
    0x00, 0x00, 0x0f, 0x60, 0xcc, 0xfc, 0x40, 0x0d, 0x10, 0x0f, 0xc5, 0x00, 0xf7, 0x00, 0xea, 0x7d, 0x0d, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x01, 0x00, 0x00, 0xd0, 0x01, 0x00,
    0x00, 0xd0, 0x01, 0x00, 0x00, 0xd0, 0xd6, 0xce, 0x02, 0xd0, 0x0a, 0x50, 0x0d, 0xd0, 0x04, 0x00, 0x2e, 0xd0, 0x01,
    0x00, 0x3d, 0xd0, 0x04, 0x00, 0x2e, 0xd0, 0x0a, 0x50, 0x0d, 0xd0, 0xc4, 0xce, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x20, 0xfb, 0x5e, 0xd0, 0x06, 0x00, 0xe2, 0x00, 0x00, 0xb3, 0x00, 0x00, 0xe2, 0x00, 0x00, 0xd0, 0x06, 0x10,
    0x20, 0xeb, 0x5e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x0d,
    0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0x10, 0x0d, 0x20, 0xec, 0x6c, 0x0d, 0xd0, 0x06, 0xa0, 0x0d, 0xe2, 0x00, 0x40,
    0x0d, 0xd3, 0x00, 0x10, 0x0d, 0xe2, 0x00, 0x30, 0x0d, 0xd0, 0x05, 0xa0, 0x0d, 0x20, 0xec, 0x5d, 0x0d, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb2, 0xdd, 0x03, 0xd0, 0x05, 0xe2, 0x20, 0x0e, 0x00, 0x4c, 0xf3, 0xdd, 0xdd,
    0x24, 0x0d, 0x00, 0x00, 0xd0, 0x06, 0x20, 0x00, 0xb1, 0xee, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0xdc, 0x0a, 0x88, 0x00, 0xb0, 0x05, 0x80, 0xee, 0x1d, 0xb0, 0x05, 0x00,
    0x5b, 0x00, 0xb0, 0x05, 0x00, 0x5b, 0x00, 0xb0, 0x05, 0x00, 0x5b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc7, 0xfb, 0x7d, 0xe1, 0x00,
    0xc4, 0x20, 0x0e, 0x40, 0x0c, 0x70, 0xbd, 0x3c, 0x00, 0x49, 0x00, 0x00, 0xd0, 0x03, 0x00, 0x00, 0xf9, 0xff, 0x1c,
    0x78, 0x00, 0x80, 0xa8, 0x06, 0x00, 0x7a, 0xb2, 0xdd, 0x7c, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x01, 0x00, 0x00, 0xd0,
    0x01, 0x00, 0x00, 0xd0, 0x01, 0x00, 0x00, 0xd0, 0xc6, 0xcd, 0x03, 0xd0, 0x0a, 0x50, 0x0c, 0xd0, 0x04, 0x10, 0x0f,
    0xd0, 0x01, 0x10, 0x0f, 0xd0, 0x01, 0x10, 0x0f, 0xd0, 0x01, 0x10, 0x0f, 0xd0, 0x01, 0x10, 0x0f, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x1e, 0x00, 0x00, 0x1f,
    0xf0, 0x01, 0x1f, 0xf0, 0x01, 0x1f, 0xf0, 0x01, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x1e,
    0x00, 0x00, 0x00, 0x1f, 0x00, 0x1f, 0x00, 0x1f, 0x00, 0x1f, 0x00, 0x1f, 0x00, 0x1f, 0x00, 0x1f, 0x00, 0x1f, 0x10,
    0x0f, 0xeb, 0x07, 0x00, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x1d, 0x00, 0x00, 0xd0, 0x01, 0x00, 0x00, 0x1d, 0x20, 0x3d,
    0xd0, 0x11, 0x3d, 0x00, 0x2d, 0x3c, 0x00, 0xd0, 0xfc, 0x02, 0x00, 0x6d, 0xd8, 0x00, 0xd0, 0x01, 0xaa, 0x00, 0x1d,
    0x00, 0x7c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x01, 0x1f,
    0xf0, 0x01, 0x1f, 0xf0, 0x01, 0x1f, 0xf0, 0x01, 0x1f, 0xf0, 0x01, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xd6,
    0xbe, 0xc3, 0xdd, 0x03, 0xd0, 0x09, 0xb0, 0x1e, 0x50, 0x0c, 0xd0, 0x03, 0x70, 0x09, 0x10, 0x0f, 0xd0, 0x01, 0x70,
    0x09, 0x10, 0x0f, 0xd0, 0x01, 0x70, 0x09, 0x10, 0x0f, 0xd0, 0x01, 0x70, 0x09, 0x10, 0x0f, 0xd0, 0x01, 0x70, 0x09,
    0x10, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xd0, 0xc5, 0xce, 0x03, 0xd0, 0x0a, 0x60, 0x0c, 0xd0, 0x04, 0x10, 0x0f, 0xd0, 0x01, 0x10, 0x0f, 0xd0, 0x01, 0x10,
    0x0f, 0xd0, 0x01, 0x10, 0x0f, 0xd0, 0x01, 0x10, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10,
    0xea, 0xae, 0x01, 0xc0, 0x07, 0x70, 0x0b, 0xe2, 0x00, 0x00, 0x2e, 0xd3, 0x00, 0x00, 0x3d, 0xe1, 0x00, 0x00, 0x2e,
    0xb0, 0x07, 0x70, 0x0c, 0x10, 0xda, 0xad, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xc5,
    0xce, 0x02, 0xd0, 0x0a, 0x70, 0x0d, 0xd0, 0x03, 0x00, 0x2e, 0xd0, 0x01, 0x00, 0x3d, 0xd0, 0x04, 0x00, 0x2e, 0xd0,
    0x0a, 0x70, 0x0d, 0xd0, 0xc6, 0xce, 0x02, 0xd0, 0x01, 0x00, 0x00, 0xd0, 0x01, 0x00, 0x00, 0xd0, 0x01, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0xec, 0x5c,
    0x0d, 0xd0, 0x06, 0xa0, 0x0d, 0xe2, 0x00, 0x40, 0x0d, 0xd3, 0x00, 0x10, 0x0d, 0xe2, 0x00, 0x30, 0x0d, 0xd0, 0x05,
    0xa0, 0x0d, 0x20, 0xec, 0x6c, 0x0d, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0x10, 0x0d, 0x00, 0x00, 0x10, 0x0d, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3e, 0xbd, 0xf0, 0x0a, 0x00, 0x2f, 0x00, 0xf0,
    0x01, 0x00, 0x1f, 0x00, 0xf0, 0x01, 0x00, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0xed, 0x1c, 0xb4, 0x00, 0x01, 0xe2, 0x04, 0x00, 0x30,
    0xda, 0x06, 0x00, 0x10, 0x4d, 0x00, 0x00, 0x5b, 0xc4, 0xdd, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x56, 0x00, 0xb0, 0x05, 0x90, 0xef, 0x8d, 0xb0, 0x05, 0x00, 0x5b, 0x00,
    0xb0, 0x05, 0x00, 0x5b, 0x00, 0x90, 0x08, 0x00, 0xd2, 0x9d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x01, 0x10, 0x0d, 0xf0, 0x01,
    0x10, 0x0d, 0xf0, 0x01, 0x10, 0x0d, 0xf0, 0x01, 0x10, 0x0d, 0xf0, 0x01, 0x30, 0x0d, 0xc0, 0x05, 0xa0, 0x0d, 0x30,
    0xdc, 0x5c, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x06, 0x00, 0xc6, 0xc6, 0x00, 0xc0, 0x06, 0x2e,
    0x20, 0x0e, 0x80, 0x08, 0x88, 0x00, 0xe2, 0xe0, 0x02, 0x00, 0x9c, 0x0c, 0x00, 0x50, 0x5f, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5b, 0x00, 0xba, 0x00, 0xb5, 0x97, 0x00, 0xdd, 0x00, 0x69, 0xd2, 0x50,
    0xa9, 0x05, 0x2d, 0xe0, 0x91, 0x54, 0x19, 0x0e, 0xa0, 0xe5, 0x00, 0x5e, 0x09, 0x50, 0xac, 0x00, 0xcb, 0x05, 0x10,
    0x5f, 0x00, 0xf6, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x0d, 0x00, 0x3d,
    0x80, 0x0a, 0x7a, 0x00, 0xc0, 0xba, 0x00, 0x00, 0xf4, 0x04, 0x00, 0xd0, 0xd7, 0x00, 0x90, 0x08, 0x98, 0x40, 0x0c,
    0x00, 0x5c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x06, 0x00, 0xc6, 0xc5, 0x00, 0xc0, 0x05, 0x3e, 0x20, 0x0e, 0x80,
    0x0a, 0x88, 0x00, 0xf2, 0xe1, 0x02, 0x00, 0xbc, 0x0b, 0x00, 0x50, 0x5f, 0x00, 0x00, 0xe6, 0x00, 0x00, 0xd0, 0x07,
    0x00, 0xeb, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd3, 0xdd,
    0x5f, 0x00, 0x30, 0x0d, 0x00, 0xd0, 0x03, 0x00, 0x88, 0x00, 0x30, 0x0d, 0x00, 0xd0, 0x03, 0x00, 0xf7, 0xdd, 0x6d,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x6d, 0x00, 0x3e,
    0x00, 0xf0, 0x00, 0x00, 0x0f, 0x00, 0xe3, 0x00, 0xe9, 0x04, 0x00, 0xe3, 0x00, 0x00, 0x0f, 0x00, 0xf0, 0x00, 0x00,
    0x3e, 0x00, 0x40, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0xf0, 0x00,
    0x00, 0x00, 0x0f, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00,
    0xf0, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x60, 0x4d, 0x00, 0x30, 0x0e, 0x00, 0xf1, 0x00, 0x10, 0x0f, 0x00, 0xe0, 0x02, 0x00, 0xe4, 0x09,
    0xe0, 0x03, 0x10, 0x0f, 0x00, 0xf1, 0x00, 0x30, 0x0e, 0x60, 0x4d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0xdc, 0xde, 0x3c,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x99, 0x99, 0x0d, 0x90, 0x00,
    0x00, 0x09, 0x90, 0x00, 0x00, 0x09, 0x90, 0x00, 0x00, 0x09, 0x90, 0x00, 0x00, 0x09, 0x90, 0x00, 0x00, 0x09, 0x90,
    0x00, 0x00, 0x09, 0x90, 0x00, 0x00, 0x09, 0xd0, 0x99, 0x99, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
]
charactersOPEN_SANS_REGULAR_10_13PX = [
    FontCharacter(3, 21, 0), FontCharacter(3, 21, 21), FontCharacter(5, 35, 42), FontCharacter(8, 56, 77),
    FontCharacter(7, 49, 133), FontCharacter(11, 77, 182), FontCharacter(9, 63, 259), FontCharacter(3, 21, 322),
    FontCharacter(4, 28, 343), FontCharacter(4, 28, 371), FontCharacter(7, 49, 399), FontCharacter(7, 49, 448),
    FontCharacter(3, 21, 497), FontCharacter(4, 28, 518), FontCharacter(3, 21, 546), FontCharacter(5, 35, 567),
    FontCharacter(7, 49, 602), FontCharacter(7, 49, 651), FontCharacter(7, 49, 700), FontCharacter(7, 49, 749),
    FontCharacter(7, 49, 798), FontCharacter(7, 49, 847), FontCharacter(7, 49, 896), FontCharacter(7, 49, 945),
    FontCharacter(7, 49, 994), FontCharacter(7, 49, 1043), FontCharacter(3, 21, 1092), FontCharacter(3, 21, 1113),
    FontCharacter(7, 49, 1134), FontCharacter(7, 49, 1183), FontCharacter(7, 49, 1232), FontCharacter(6, 42, 1281),
    FontCharacter(12, 84, 1323), FontCharacter(8, 56, 1407), FontCharacter(8, 56, 1463), FontCharacter(8, 56, 1519),
    FontCharacter(9, 63, 1575), FontCharacter(7, 49, 1638), FontCharacter(7, 49, 1687), FontCharacter(9, 63, 1736),
    FontCharacter(10, 70, 1799), FontCharacter(4, 28, 1869), FontCharacter(5, 35, 1897), FontCharacter(8, 56, 1932),
    FontCharacter(7, 49, 1988), FontCharacter(12, 84, 2037), FontCharacter(10, 70, 2121), FontCharacter(10, 70, 2191),
    FontCharacter(8, 56, 2261), FontCharacter(10, 70, 2317), FontCharacter(8, 56, 2387), FontCharacter(7, 49, 2443),
    FontCharacter(7, 49, 2492), FontCharacter(9, 63, 2541), FontCharacter(8, 56, 2604), FontCharacter(12, 84, 2660),
    FontCharacter(8, 56, 2744), FontCharacter(7, 49, 2800), FontCharacter(7, 49, 2849), FontCharacter(4, 28, 2898),
    FontCharacter(5, 35, 2926), FontCharacter(4, 28, 2961), FontCharacter(7, 49, 2989), FontCharacter(6, 42, 3038),
    FontCharacter(8, 56, 3080), FontCharacter(7, 49, 3136), FontCharacter(8, 56, 3185), FontCharacter(6, 42, 3241),
    FontCharacter(8, 56, 3283), FontCharacter(7, 49, 3339), FontCharacter(5, 35, 3388), FontCharacter(7, 49, 3423),
    FontCharacter(8, 56, 3472), FontCharacter(3, 21, 3528), FontCharacter(4, 28, 3549), FontCharacter(7, 49, 3577),
    FontCharacter(3, 21, 3626), FontCharacter(12, 84, 3647), FontCharacter(8, 56, 3731), FontCharacter(8, 56, 3787),
    FontCharacter(8, 56, 3843), FontCharacter(8, 56, 3899), FontCharacter(5, 35, 3955), FontCharacter(6, 42, 3990),
    FontCharacter(5, 35, 4032), FontCharacter(8, 56, 4067), FontCharacter(7, 49, 4123), FontCharacter(10, 70, 4172),
    FontCharacter(7, 49, 4242), FontCharacter(7, 49, 4291), FontCharacter(6, 42, 4340), FontCharacter(5, 35, 4382),
    FontCharacter(7, 49, 4417), FontCharacter(5, 35, 4466), FontCharacter(7, 49, 4501), FontCharacter(8, 56, 4550)
]

bitmapOPEN_SANS_SEMIBOLD_10_13PX = [
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xe0, 0x0b, 0xd0, 0x0b, 0xd0, 0x09, 0xb0, 0x09, 0xb0, 0x07, 0x90, 0x07, 0x00, 0x00, 0xc0,
    0x09, 0xd0, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x44, 0x0f, 0xf0, 0x33,
    0x0f, 0xd0, 0x11, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xf1, 0x80, 0x08, 0x00, 0xd4, 0xa0, 0x06, 0x00, 0xa6, 0xd0, 0x04, 0xf3, 0xff, 0xff, 0xbf, 0x10, 0x5d, 0xd5,
    0x11, 0xfb, 0xff, 0xff, 0x3f, 0x51, 0x1d, 0x7b, 0x01, 0x60, 0x0a, 0x4d, 0x00, 0x80, 0x08, 0x1f, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x00, 0x00, 0xd5,
    0xef, 0x0b, 0xf2, 0xe9, 0x74, 0x30, 0x5f, 0x0d, 0x00, 0xb0, 0xff, 0x05, 0x00, 0x50, 0xfe, 0x0b, 0x00, 0xd0, 0xf4,
    0x44, 0x37, 0x8e, 0x3f, 0xc3, 0xff, 0x5d, 0x00, 0x00, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfa, 0x0a, 0x00, 0x5d, 0x00, 0xe4, 0xd1,
    0x05, 0xc6, 0x00, 0x70, 0x0b, 0x7b, 0xe0, 0x03, 0x00, 0xb6, 0xb0, 0x87, 0xba, 0x9f, 0x30, 0x1e, 0x7d, 0x7e, 0x1d,
    0x3e, 0x90, 0xaf, 0x8b, 0xb7, 0xb0, 0x06, 0x00, 0xe3, 0x70, 0x0b, 0x6b, 0x00, 0xc0, 0x06, 0xd5, 0xe1, 0x03, 0x50,
    0x0d, 0x00, 0xfa, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe9, 0xbf, 0x01, 0x00, 0x60, 0x5f,
    0xe4, 0x09, 0x00, 0x50, 0x1f, 0xe1, 0x07, 0x00, 0x00, 0xdc, 0xae, 0x00, 0x00, 0x40, 0xfe, 0x3f, 0x10, 0x39, 0xf1,
    0x19, 0xed, 0x73, 0x1f, 0xf5, 0x03, 0xd1, 0xee, 0x08, 0xf2, 0x4b, 0xa4, 0xff, 0x05, 0x40, 0xfc, 0xcf, 0x76, 0x6f,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x10, 0x3f, 0xf0, 0x01, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x4e, 0x90, 0x0b, 0xf0, 0x05, 0xf4, 0x01, 0xe6, 0x00, 0xd7, 0x00, 0xe7, 0x00,
    0xf4, 0x01, 0xf0, 0x05, 0x90, 0x0b, 0x10, 0x4e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe4, 0x01, 0xb0, 0x09, 0x50,
    0x0f, 0x10, 0x4f, 0x00, 0x6e, 0x00, 0x7d, 0x00, 0x7e, 0x10, 0x4f, 0x50, 0x0f, 0xb0, 0x09, 0xe4, 0x01, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xf2, 0x01, 0x00, 0x00, 0x0f, 0x00, 0xf6, 0xfb, 0xfb, 0x06, 0xa3, 0xaf, 0x03, 0x20, 0x6f, 0x2e,
    0x00, 0xa5, 0xa0, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x90, 0x00, 0x00, 0x00, 0x1f, 0x00, 0x00, 0xf0, 0x01, 0x50, 0xff, 0xff, 0x5f, 0x10, 0xf1, 0x13, 0x00,
    0x00, 0x1f, 0x00, 0x00, 0xb0, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20,
    0x5f, 0xf4, 0x80, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xf9, 0x9f, 0x32, 0x23, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x09, 0xd0, 0x0a, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xaa, 0x00, 0xf1, 0x04, 0x60, 0x0e, 0x00, 0x8c, 0x00,
    0xf2, 0x02, 0x90, 0x0c, 0x00, 0x6e, 0x00, 0xf5, 0x00, 0xb0, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc3, 0xcf, 0x03, 0xe0, 0x4b, 0xdb, 0x40, 0x3f, 0x30, 0x3f, 0xf6, 0x00,
    0xf0, 0x76, 0x0f, 0x00, 0x7f, 0xf6, 0x00, 0xf0, 0x36, 0x3f, 0x30, 0x4f, 0xd0, 0x4b, 0xeb, 0x00, 0xc3, 0xcf, 0x03,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30,
    0xbe, 0x00, 0x70, 0xdf, 0x0b, 0x00, 0x3b, 0xbb, 0x00, 0x00, 0xb0, 0x0b, 0x00, 0x00, 0xbb, 0x00, 0x00, 0xb0, 0x0b,
    0x00, 0x00, 0xbb, 0x00, 0x00, 0xb0, 0x0b, 0x00, 0x00, 0xbb, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd6, 0xdf, 0x04, 0xe2, 0x47, 0xec, 0x00, 0x00, 0x50,
    0x1f, 0x00, 0x00, 0xe8, 0x00, 0x00, 0xf3, 0x05, 0x00, 0xe3, 0x08, 0x00, 0xe2, 0x08, 0x00, 0xe2, 0x5d, 0x55, 0x72,
    0xff, 0xff, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x10, 0xe9, 0xdf, 0x04, 0xb1, 0x45, 0xfc, 0x00, 0x00, 0x50, 0x1f, 0x00, 0x10, 0xcb, 0x00, 0xf1, 0xdf, 0x02,
    0x00, 0x43, 0xea, 0x01, 0x00, 0x20, 0x5f, 0x65, 0x43, 0xfa, 0x42, 0xfc, 0xcf, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe1, 0x0b, 0x00, 0xb0, 0xbf,
    0x00, 0x60, 0xbc, 0x0b, 0x10, 0x3e, 0xbb, 0x00, 0x8a, 0xb0, 0x0b, 0xd5, 0x00, 0xbb, 0xb0, 0xff, 0xff, 0xbf, 0x32,
    0x33, 0xcc, 0x02, 0x00, 0xb0, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xfd, 0xff, 0x0b, 0xe0, 0x5a, 0x45, 0x00, 0x5f, 0x00, 0x00, 0xf1, 0xfe, 0x4d, 0x00,
    0x35, 0xc4, 0x1f, 0x00, 0x00, 0xf3, 0x05, 0x00, 0x30, 0x4f, 0x72, 0x44, 0xec, 0x10, 0xfc, 0xbf, 0x02, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0xfd, 0x0d,
    0x80, 0x6e, 0x33, 0x00, 0x5f, 0x00, 0x00, 0xf4, 0xe7, 0x8e, 0x50, 0xaf, 0x72, 0x3f, 0xf5, 0x01, 0xf0, 0x47, 0x2f,
    0x00, 0x7f, 0xd0, 0x3c, 0xf9, 0x02, 0xc2, 0xdf, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0xff, 0xff, 0x7f, 0x53, 0x55, 0xf8, 0x04, 0x00, 0x90, 0x0d, 0x00,
    0x10, 0x6f, 0x00, 0x00, 0xf7, 0x00, 0x00, 0xe0, 0x09, 0x00, 0x50, 0x2f, 0x00, 0x00, 0xcc, 0x00, 0x00, 0xf3, 0x05,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xd4, 0xdf, 0x04, 0xf0, 0x28, 0xf8, 0x20, 0x1f, 0x10, 0x1f, 0xc0, 0x1a, 0xca, 0x00, 0xe1, 0xdf, 0x00, 0xc0, 0x5a,
    0xcb, 0x60, 0x0d, 0x00, 0x6d, 0xf5, 0x15, 0xf5, 0x04, 0xe8, 0xef, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd4, 0xcf, 0x02, 0xf1, 0x39, 0xdb, 0x60, 0x0f,
    0x20, 0x4f, 0xf7, 0x00, 0xf0, 0x37, 0x8f, 0xa3, 0x7f, 0x70, 0xee, 0xf6, 0x04, 0x00, 0x40, 0x1f, 0x30, 0x63, 0x8e,
    0x00, 0xfd, 0x7d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x0a, 0xc0, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x09, 0xd0, 0x0a,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x09, 0xc0, 0x08, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x09, 0xf2, 0x03, 0xc6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x04, 0x00, 0xd5, 0x2c, 0x30, 0xdc, 0x05, 0x40, 0x9f, 0x00, 0x00,
    0x80, 0xbf, 0x03, 0x00, 0x10, 0xf8, 0x2b, 0x00, 0x00, 0x81, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x50, 0xff, 0xff, 0x5f, 0x10, 0x11, 0x11, 0x00, 0x11, 0x11, 0x01, 0xf5, 0xff, 0xff, 0x05, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x74, 0x00, 0x00, 0x20, 0xdc, 0x05, 0x00, 0x00, 0xd5, 0x3c, 0x00,
    0x00, 0x90, 0x4f, 0x00, 0xb3, 0x8f, 0x20, 0xfb, 0x18, 0x00, 0x85, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc6, 0xff, 0x1a, 0x76,
    0x53, 0x8e, 0x00, 0x00, 0x9d, 0x00, 0xb1, 0x1e, 0x00, 0xbc, 0x01, 0x10, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x30, 0x3d,
    0x00, 0x40, 0x4f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x50, 0xeb, 0xdf, 0x19, 0x00, 0x00, 0xca, 0x04, 0x10, 0xe8, 0x02, 0x70, 0x0c, 0xe6, 0xdf,
    0x74, 0x0c, 0xe0, 0x42, 0x2e, 0xb0, 0x05, 0x1f, 0xe3, 0x90, 0x09, 0xd0, 0x05, 0x3d, 0xd3, 0xa0, 0x07, 0xe0, 0x05,
    0x2e, 0xf2, 0x70, 0x0c, 0xf4, 0x36, 0x0e, 0xd0, 0x06, 0xfa, 0x3c, 0xee, 0x03, 0x30, 0x8e, 0x02, 0x20, 0x06, 0x00,
    0x00, 0x92, 0xfd, 0xcf, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf8, 0x08, 0x00, 0x00, 0xe0, 0xed, 0x00, 0x00,
    0x50, 0x2f, 0x5f, 0x00, 0x00, 0xab, 0xa0, 0x0b, 0x00, 0xf2, 0x04, 0xf4, 0x02, 0x80, 0xff, 0xff, 0x8f, 0x00, 0xae,
    0x55, 0xa5, 0x0e, 0xf5, 0x02, 0x00, 0xf2, 0xc5, 0x0c, 0x00, 0x00, 0xcc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfb, 0xff, 0xae,
    0x01, 0xb0, 0x3e, 0x63, 0xce, 0x00, 0xdb, 0x00, 0x90, 0x0f, 0xb0, 0x0d, 0x20, 0xad, 0x00, 0xfb, 0xff, 0xcf, 0x01,
    0xb0, 0x3e, 0x43, 0xec, 0x00, 0xdb, 0x00, 0x50, 0x3f, 0xb0, 0x3e, 0x53, 0xed, 0x01, 0xfb, 0xff, 0xbf, 0x03, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xb3, 0xff, 0x4c, 0x50, 0xbf, 0x45, 0x29, 0xd0, 0x0c, 0x00, 0x00, 0xf2, 0x07, 0x00, 0x00, 0xf3,
    0x05, 0x00, 0x00, 0xf2, 0x06, 0x00, 0x00, 0xe0, 0x0c, 0x00, 0x00, 0x60, 0xbf, 0x45, 0x27, 0x00, 0xc6, 0xff, 0x2c,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xb0, 0xff, 0xef, 0x29, 0x00, 0xb0, 0x3e, 0x63, 0xec, 0x03, 0xb0, 0x0d, 0x00, 0xd0, 0x0d, 0xb0, 0x0d,
    0x00, 0x70, 0x1f, 0xb0, 0x0d, 0x00, 0x50, 0x1f, 0xb0, 0x0d, 0x00, 0x80, 0x0f, 0xb0, 0x0d, 0x00, 0xe1, 0x0c, 0xb0,
    0x3e, 0x74, 0xed, 0x02, 0xb0, 0xff, 0xdf, 0x19, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfd, 0xff, 0x3f, 0xd0, 0x3c,
    0x33, 0x00, 0xbd, 0x00, 0x00, 0xd0, 0x0b, 0x00, 0x00, 0xfd, 0xff, 0x0f, 0xd0, 0x3c, 0x33, 0x00, 0xbd, 0x00, 0x00,
    0xd0, 0x3c, 0x33, 0x00, 0xfd, 0xff, 0x3f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfb, 0xff, 0x7f, 0xb0, 0x3c, 0x33, 0x01, 0xbb, 0x00, 0x00, 0xb0, 0x0b, 0x00,
    0x00, 0xfb, 0xff, 0x3f, 0xb0, 0x3c, 0x33, 0x00, 0xbb, 0x00, 0x00, 0xb0, 0x0b, 0x00, 0x00, 0xbb, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30,
    0xeb, 0xdf, 0x08, 0x40, 0xcf, 0x46, 0x66, 0x00, 0xdd, 0x00, 0x00, 0x00, 0xf2, 0x06, 0x00, 0x00, 0x30, 0x5f, 0x30,
    0xff, 0x0f, 0xf2, 0x06, 0x30, 0xf9, 0x00, 0xbe, 0x00, 0x70, 0x0f, 0x60, 0xbf, 0x44, 0xfa, 0x00, 0x50, 0xfc, 0xdf,
    0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x0b, 0x00, 0xb0, 0x0b, 0xb0, 0x0b, 0x00, 0xb0, 0x0b, 0xb0, 0x0b, 0x00, 0xb0,
    0x0b, 0xb0, 0x0b, 0x00, 0xb0, 0x0b, 0xb0, 0xff, 0xff, 0xff, 0x0b, 0xb0, 0x3c, 0x33, 0xc3, 0x0b, 0xb0, 0x0b, 0x00,
    0xb0, 0x0b, 0xb0, 0x0b, 0x00, 0xb0, 0x0b, 0xb0, 0x0b, 0x00, 0xb0, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x0b, 0xb0, 0x0b,
    0xb0, 0x0b, 0xb0, 0x0b, 0xb0, 0x0b, 0xb0, 0x0b, 0xb0, 0x0b, 0xb0, 0x0b, 0xb0, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xbb, 0x00, 0xbb, 0x00, 0xbb, 0x00, 0xbb, 0x00, 0xbb, 0x00, 0xbb, 0x00, 0xbb,
    0x00, 0xbb, 0x00, 0xbc, 0x64, 0x8f, 0xfe, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x0b, 0x30,
    0x7f, 0xd0, 0x0b, 0xe1, 0x09, 0xd0, 0x0b, 0xbc, 0x00, 0xd0, 0xab, 0x0d, 0x00, 0xd0, 0xff, 0x0d, 0x00, 0xd0, 0x3d,
    0x9f, 0x00, 0xd0, 0x0b, 0xf6, 0x04, 0xd0, 0x0b, 0xb0, 0x0d, 0xd0, 0x0b, 0x10, 0xae, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xbb, 0x00, 0x00, 0xb0,
    0x0b, 0x00, 0x00, 0xbb, 0x00, 0x00, 0xb0, 0x0b, 0x00, 0x00, 0xbb, 0x00, 0x00, 0xb0, 0x0b, 0x00, 0x00, 0xbb, 0x00,
    0x00, 0xb0, 0x3c, 0x33, 0x02, 0xfb, 0xff, 0x9f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x8f, 0x00, 0x00, 0xf8, 0x0b, 0xb0, 0xde, 0x00, 0x00,
    0xee, 0x0b, 0xb0, 0xfa, 0x03, 0x40, 0xae, 0x0b, 0xb0, 0xb9, 0x09, 0xa0, 0x99, 0x0b, 0xb0, 0x59, 0x0e, 0xf0, 0xa3,
    0x0b, 0xb0, 0x09, 0x5f, 0xd6, 0xb0, 0x0b, 0xb0, 0x09, 0xaa, 0x7c, 0xb0, 0x0b, 0xb0, 0x09, 0xf4, 0x1f, 0xb0, 0x0b,
    0xb0, 0x09, 0xe0, 0x0b, 0xb0, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x5f, 0x00,
    0x90, 0x0b, 0xb0, 0xef, 0x00, 0x90, 0x0b, 0xb0, 0xe9, 0x09, 0x90, 0x0b, 0xb0, 0x69, 0x3f, 0x90, 0x0b, 0xb0, 0x09,
    0xcc, 0x90, 0x0b, 0xb0, 0x09, 0xf3, 0x96, 0x0b, 0xb0, 0x09, 0x90, 0x9e, 0x0b, 0xb0, 0x09, 0x00, 0xfe, 0x0b, 0xb0,
    0x09, 0x00, 0xf5, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc5, 0xff, 0x5c, 0x00, 0x50, 0xbf, 0x44, 0xfa,
    0x05, 0xe0, 0x0c, 0x00, 0xc0, 0x0e, 0xf2, 0x06, 0x00, 0x60, 0x2f, 0xf3, 0x05, 0x00, 0x50, 0x3f, 0xf2, 0x06, 0x00,
    0x60, 0x2f, 0xe0, 0x0c, 0x00, 0xc0, 0x0e, 0x50, 0xbf, 0x44, 0xfb, 0x05, 0x00, 0xc5, 0xff, 0x4c, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xb0, 0xff, 0xcf, 0x04, 0xb0, 0x3c, 0xb4, 0x2f, 0xb0, 0x0b, 0x30, 0x5f, 0xb0, 0x0b, 0x90, 0x2f,
    0xb0, 0xff, 0xff, 0x07, 0xb0, 0x3c, 0x03, 0x00, 0xb0, 0x0b, 0x00, 0x00, 0xb0, 0x0b, 0x00, 0x00, 0xb0, 0x0b, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xc5, 0xff, 0x5c, 0x00, 0x50, 0xbf, 0x44, 0xfa, 0x05, 0xe0, 0x0c, 0x00, 0xc0, 0x0e, 0xf2,
    0x06, 0x00, 0x60, 0x2f, 0xf3, 0x05, 0x00, 0x50, 0x3f, 0xf2, 0x06, 0x00, 0x60, 0x2f, 0xe0, 0x0c, 0x00, 0xc0, 0x0e,
    0x50, 0xbf, 0x44, 0xfb, 0x05, 0x00, 0xc5, 0xff, 0x4f, 0x00, 0x00, 0x00, 0x50, 0x8f, 0x00, 0x00, 0x00, 0x00, 0xf7,
    0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xff, 0xbf, 0x02,
    0xd0, 0x3c, 0xd5, 0x0d, 0xd0, 0x0b, 0x70, 0x1f, 0xd0, 0x0b, 0xc1, 0x0d, 0xd0, 0xff, 0xdf, 0x02, 0xd0, 0x3c, 0xcc,
    0x00, 0xd0, 0x0b, 0xf3, 0x05, 0xd0, 0x0b, 0xa0, 0x0e, 0xd0, 0x0b, 0x10, 0x9f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd4, 0xef, 0x1b, 0xf1, 0x4a,
    0x96, 0x30, 0x4f, 0x00, 0x00, 0xe0, 0x4d, 0x00, 0x00, 0xb1, 0xdf, 0x04, 0x00, 0x20, 0xfb, 0x02, 0x00, 0x10, 0x5f,
    0x84, 0x45, 0xf9, 0x33, 0xfc, 0xcf, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xff, 0xff, 0xdf, 0x33, 0xf6, 0x36, 0x03, 0x30, 0x3f, 0x00, 0x00, 0xf3, 0x03,
    0x00, 0x30, 0x3f, 0x00, 0x00, 0xf3, 0x03, 0x00, 0x30, 0x3f, 0x00, 0x00, 0xf3, 0x03, 0x00, 0x30, 0x3f, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0,
    0x0b, 0x00, 0xb0, 0x0d, 0xd0, 0x0b, 0x00, 0xb0, 0x0d, 0xd0, 0x0b, 0x00, 0xb0, 0x0d, 0xd0, 0x0b, 0x00, 0xb0, 0x0d,
    0xd0, 0x0b, 0x00, 0xb0, 0x0d, 0xd0, 0x0b, 0x00, 0xb0, 0x0d, 0xb0, 0x0d, 0x00, 0xd0, 0x0b, 0x40, 0xaf, 0x44, 0xfa,
    0x04, 0x00, 0xc5, 0xff, 0x4c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xbc, 0x00, 0x00, 0xcb, 0xf7, 0x00, 0x10, 0x7f,
    0xf1, 0x06, 0x60, 0x1f, 0xb0, 0x0b, 0xb0, 0x0b, 0x50, 0x1f, 0xf1, 0x05, 0x00, 0x6f, 0xf7, 0x00, 0x00, 0xba, 0xab,
    0x00, 0x00, 0xf5, 0x4f, 0x00, 0x00, 0xe0, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xbc, 0x00, 0xe0, 0x0d, 0x00, 0xcb, 0xf8,
    0x00, 0xf2, 0x2f, 0x00, 0x7f, 0xf3, 0x03, 0xc7, 0x6d, 0x30, 0x3f, 0xf0, 0x07, 0x9b, 0xb9, 0x70, 0x0f, 0xb0, 0x0b,
    0x4f, 0xf5, 0xb0, 0x0b, 0x70, 0x4e, 0x0f, 0xf0, 0xe4, 0x07, 0x30, 0xaf, 0x0b, 0xc0, 0xfa, 0x03, 0x00, 0xee, 0x07,
    0x70, 0xee, 0x00, 0x00, 0xfb, 0x02, 0x30, 0xaf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf6,
    0x03, 0x30, 0x6f, 0xc0, 0x0c, 0xc0, 0x0b, 0x20, 0x6f, 0xf6, 0x02, 0x00, 0xe6, 0x6e, 0x00, 0x00, 0xf1, 0x1f, 0x00,
    0x00, 0xca, 0xad, 0x00, 0x40, 0x3f, 0xf4, 0x04, 0xe0, 0x09, 0xa0, 0x0d, 0xe9, 0x00, 0x10, 0x9f, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xeb, 0x00,
    0x00, 0xbd, 0xf2, 0x07, 0x70, 0x1f, 0x80, 0x1f, 0xf1, 0x07, 0x00, 0x9e, 0xda, 0x00, 0x00, 0xf6, 0x5f, 0x00, 0x00,
    0xd0, 0x0c, 0x00, 0x00, 0xb0, 0x0b, 0x00, 0x00, 0xb0, 0x0b, 0x00, 0x00, 0xb0, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xff, 0xff, 0x7f,
    0x31, 0x33, 0xfa, 0x03, 0x00, 0xf2, 0x08, 0x00, 0xb0, 0x0d, 0x00, 0x60, 0x3f, 0x00, 0x10, 0x9e, 0x00, 0x00, 0xea,
    0x00, 0x00, 0xf4, 0x38, 0x33, 0x92, 0xff, 0xff, 0x9f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf1, 0xbf, 0xf1, 0x15, 0xf1, 0x03, 0xf1, 0x03, 0xf1, 0x03, 0xf1, 0x03, 0xf1,
    0x03, 0xf1, 0x03, 0xf1, 0x03, 0xf1, 0x15, 0xf1, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x0a, 0x00, 0xf5,
    0x00, 0x00, 0x6e, 0x00, 0x90, 0x0c, 0x00, 0xf2, 0x02, 0x00, 0x8c, 0x00, 0x60, 0x0e, 0x00, 0xf1, 0x04, 0x00, 0xaa,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfb, 0x1f, 0x51, 0x1f, 0x30, 0x1f, 0x30,
    0x1f, 0x30, 0x1f, 0x30, 0x1f, 0x30, 0x1f, 0x30, 0x1f, 0x30, 0x1f, 0x51, 0x1f, 0xfb, 0x1f, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x40, 0x0e, 0x00, 0x00, 0xeb, 0x07, 0x00, 0xe2, 0xe3, 0x00, 0xa0, 0x07, 0x7a, 0x10, 0x1e,
    0x20, 0x1f, 0x98, 0x00, 0xa0, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xdd, 0xdd, 0xdd, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe3, 0x07, 0x00,
    0x00, 0x20, 0x4d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0xfc, 0xcf, 0x02, 0x20, 0x26, 0xd2, 0x0c, 0x00, 0x00, 0x90, 0x0d,
    0x60, 0xec, 0xff, 0x0d, 0xf4, 0x06, 0x90, 0x0d, 0xf4, 0x16, 0xe5, 0x0d, 0xa0, 0xff, 0x5a, 0x0d, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x07, 0x00, 0x00, 0xf0, 0x07,
    0x00, 0x00, 0xf0, 0x07, 0x00, 0x00, 0xf0, 0xb9, 0xdf, 0x03, 0xf0, 0x5e, 0xc4, 0x0e, 0xf0, 0x0a, 0x40, 0x3f, 0xf0,
    0x07, 0x30, 0x5f, 0xf0, 0x0a, 0x40, 0x3f, 0xf0, 0x5f, 0xc4, 0x0e, 0xf0, 0xc7, 0xdf, 0x03, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x30, 0xfc, 0x5e, 0xe0, 0x4c, 0x25, 0xf4, 0x04, 0x00, 0xf5, 0x01, 0x00, 0xf4, 0x03, 0x00, 0xe0, 0x4c,
    0x45, 0x30, 0xfc, 0x5e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70,
    0x0f, 0x00, 0x00, 0x70, 0x0f, 0x00, 0x00, 0x70, 0x0f, 0x30, 0xfd, 0xac, 0x0f, 0xe0, 0x4d, 0xe5, 0x0f, 0xf3, 0x04,
    0x80, 0x0f, 0xf5, 0x03, 0x70, 0x0f, 0xf4, 0x04, 0x80, 0x0f, 0xe0, 0x3c, 0xe5, 0x0f, 0x30, 0xfd, 0x6b, 0x0f, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc3, 0xdf, 0x04, 0xd0, 0x2a, 0xe9, 0x41, 0x3f, 0x10, 0x5f, 0xf5, 0xff,
    0xff, 0x45, 0x4f, 0x11, 0x01, 0xd0, 0x3b, 0x63, 0x01, 0xb2, 0xff, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfa, 0x2e, 0x60, 0x5f, 0x04, 0x70, 0x0f, 0x00, 0xf8, 0xff, 0x0d,
    0x81, 0x1f, 0x01, 0x70, 0x0f, 0x00, 0x70, 0x0f, 0x00, 0x70, 0x0f, 0x00, 0x70, 0x0f, 0x00, 0x70, 0x0f, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xe6, 0xff, 0xaf, 0xf2, 0x05, 0xca, 0x50, 0x1f, 0x70, 0x0f, 0xf2, 0x05, 0xca, 0x00, 0xf7, 0xcf,
    0x02, 0xe0, 0x05, 0x00, 0x00, 0xfb, 0xff, 0x3d, 0xc8, 0x34, 0xd4, 0xca, 0x0a, 0x30, 0x7d, 0xc3, 0xff, 0x8d, 0x00,
    0x00, 0x00, 0x00, 0xf0, 0x07, 0x00, 0x00, 0xf0, 0x07, 0x00, 0x00, 0xf0, 0x07, 0x00, 0x00, 0xf0, 0xb9, 0xdf, 0x03,
    0xf0, 0x5f, 0xd4, 0x0d, 0xf0, 0x0a, 0x70, 0x0f, 0xf0, 0x07, 0x70, 0x0f, 0xf0, 0x07, 0x70, 0x0f, 0xf0, 0x07, 0x70,
    0x0f, 0xf0, 0x07, 0x70, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xb0, 0x09, 0xb0, 0x09, 0x00, 0x00, 0xd0, 0x09, 0xd0, 0x09, 0xd0, 0x09, 0xd0, 0x09, 0xd0, 0x09, 0xd0,
    0x09, 0xd0, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x9b, 0x00, 0x9b, 0x00, 0x00, 0x00, 0x9d,
    0x00, 0x9d, 0x00, 0x9d, 0x00, 0x9d, 0x00, 0x9d, 0x00, 0x9d, 0x00, 0x9d, 0x00, 0x9d, 0x42, 0x8e, 0xf8, 0x1c, 0x00,
    0x00, 0xf0, 0x07, 0x00, 0x00, 0x7f, 0x00, 0x00, 0xf0, 0x07, 0x00, 0x00, 0x7f, 0x50, 0x4f, 0xf0, 0x37, 0x6f, 0x00,
    0x8f, 0x8e, 0x00, 0xf0, 0xfe, 0x06, 0x00, 0xaf, 0xf6, 0x02, 0xf0, 0x07, 0xdc, 0x00, 0x7f, 0x20, 0x8f, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x09, 0xd0, 0x09, 0xd0, 0x09, 0xd0,
    0x09, 0xd0, 0x09, 0xd0, 0x09, 0xd0, 0x09, 0xd0, 0x09, 0xd0, 0x09, 0xd0, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xf0, 0xc7, 0xcf, 0xb3, 0xef, 0x04, 0xf0, 0x5e, 0xf4, 0x7f, 0xc3, 0x0d, 0xf0, 0x09, 0xb0, 0x0e, 0x70, 0x0f,
    0xf0, 0x07, 0xb0, 0x0b, 0x70, 0x0f, 0xf0, 0x07, 0xb0, 0x0b, 0x70, 0x0f, 0xf0, 0x07, 0xb0, 0x0b, 0x70, 0x0f, 0xf0,
    0x07, 0xb0, 0x0b, 0x70, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xf0, 0xc7, 0xdf, 0x04, 0xf0, 0x5f, 0xd4, 0x0d, 0xf0, 0x0a, 0x70, 0x0f, 0xf0, 0x07, 0x70, 0x0f,
    0xf0, 0x07, 0x70, 0x0f, 0xf0, 0x07, 0x70, 0x0f, 0xf0, 0x07, 0x70, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x10, 0xfb, 0xbf, 0x01, 0xd0, 0x4d, 0xd4, 0x0c, 0xf3, 0x04, 0x40, 0x3f, 0xf5, 0x03, 0x30, 0x5f, 0xf3,
    0x04, 0x40, 0x3f, 0xc0, 0x4d, 0xd4, 0x0d, 0x10, 0xfa, 0xbf, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xf0, 0xb6, 0xdf, 0x03, 0xf0, 0x5e, 0xc4, 0x0e, 0xf0, 0x09, 0x40, 0x3f, 0xf0, 0x07, 0x30, 0x5f, 0xf0, 0x0a,
    0x40, 0x3f, 0xf0, 0x5f, 0xd4, 0x0e, 0xf0, 0xca, 0xdf, 0x03, 0xf0, 0x07, 0x00, 0x00, 0xf0, 0x07, 0x00, 0x00, 0xf0,
    0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x30, 0xfd, 0x8b, 0x0f, 0xe0, 0x4d, 0xe5, 0x0f, 0xf3, 0x04, 0x80, 0x0f, 0xf5, 0x03, 0x70, 0x0f, 0xf4, 0x04, 0x80,
    0x0f, 0xe0, 0x3c, 0xe4, 0x0f, 0x30, 0xfd, 0x9b, 0x0f, 0x00, 0x00, 0x70, 0x0f, 0x00, 0x00, 0x70, 0x0f, 0x00, 0x00,
    0x70, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x86, 0xae, 0xd0,
    0xbe, 0x36, 0xd0, 0x0d, 0x00, 0xd0, 0x09, 0x00, 0xd0, 0x09, 0x00, 0xd0, 0x09, 0x00, 0xd0, 0x09, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x90, 0xfe, 0x2c, 0xf5, 0x25, 0x06, 0xf3, 0x1a, 0x00, 0x50, 0xfd, 0x0a, 0x00, 0x60, 0x6f, 0x53, 0x41, 0x5f, 0xd3,
    0xef, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb5, 0x00,
    0x90, 0x0b, 0x80, 0xff, 0x9f, 0xd1, 0x1c, 0x00, 0xbd, 0x00, 0xd0, 0x0b, 0x00, 0xbd, 0x00, 0xb0, 0x3d, 0x02, 0xd3,
    0x8f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xf0, 0x07, 0x70, 0x0f, 0xf0, 0x07, 0x70, 0x0f, 0xf0, 0x07, 0x70, 0x0f, 0xf0, 0x07, 0x70,
    0x0f, 0xf0, 0x07, 0xa0, 0x0f, 0xd0, 0x3d, 0xf5, 0x0f, 0x40, 0xfd, 0x7c, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xc0, 0x0b, 0x00, 0xcb, 0xf6, 0x01, 0xf1, 0x06, 0x7f, 0x70, 0x0f, 0xa0, 0x0c, 0xac, 0x00, 0xf4, 0xf4, 0x03,
    0x00, 0xdd, 0x0d, 0x00, 0x70, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0,
    0x0c, 0x70, 0x7f, 0x00, 0xbc, 0xf6, 0x00, 0xdb, 0x0b, 0xf0, 0x16, 0x5f, 0xf0, 0xf5, 0x50, 0x1f, 0xd0, 0x59, 0x0e,
    0x5e, 0xc9, 0x00, 0xd8, 0x9a, 0x90, 0xd9, 0x07, 0x30, 0xef, 0x04, 0xe5, 0x3f, 0x00, 0xe0, 0x0f, 0x00, 0xef, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x4f, 0x40, 0x5f, 0xa0, 0x0d,
    0xad, 0x00, 0xe1, 0xed, 0x01, 0x00, 0xf9, 0x08, 0x00, 0xf2, 0xfb, 0x02, 0xc0, 0x0c, 0xcc, 0x70, 0x2f, 0x20, 0x7f,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x0c, 0x00, 0xcb, 0xf6, 0x02, 0xf1, 0x06, 0x8e, 0x70, 0x0f, 0x80, 0x0d, 0xac,
    0x00, 0xf2, 0xf5, 0x04, 0x00, 0xec, 0x0d, 0x00, 0x50, 0x7f, 0x00, 0x00, 0xf5, 0x01, 0x20, 0xe4, 0x0a, 0x00, 0xfb,
    0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf5, 0xff, 0x7f, 0x10,
    0x81, 0x2f, 0x00, 0xf2, 0x06, 0x00, 0xcc, 0x00, 0x70, 0x1e, 0x00, 0xf2, 0x18, 0x01, 0xf9, 0xff, 0x9f, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0xbd, 0x00, 0xaf, 0x01, 0xf0,
    0x05, 0x00, 0x5f, 0x00, 0xf4, 0x04, 0xfb, 0x08, 0x20, 0xf8, 0x03, 0x00, 0x5f, 0x00, 0xf0, 0x05, 0x00, 0xaf, 0x01,
    0x50, 0xbd, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf1, 0x01, 0x00, 0x10, 0x1f, 0x00, 0x00, 0xf1, 0x01, 0x00, 0x10,
    0x1f, 0x00, 0x00, 0xf1, 0x01, 0x00, 0x10, 0x1f, 0x00, 0x00, 0xf1, 0x01, 0x00, 0x10, 0x1f, 0x00, 0x00, 0xf1, 0x01,
    0x00, 0x10, 0x1f, 0x00, 0x00, 0xf1, 0x01, 0x00, 0x10, 0x1f, 0x00, 0x00, 0xf1, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xb0, 0x5d, 0x00, 0xa1, 0x0f, 0x00, 0xf5, 0x00, 0x50, 0x0f, 0x00, 0xf3, 0x04, 0x00, 0xf8, 0x0b, 0xf2, 0x28,
    0x50, 0x0f, 0x00, 0xf5, 0x00, 0x91, 0x0f, 0xb0, 0x6d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd2, 0x9f, 0x43, 0x44, 0x23, 0xe9, 0x2d, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa0, 0x99, 0x99, 0x0a, 0x90, 0x00, 0x00, 0x09,
    0x90, 0x00, 0x00, 0x09, 0x90, 0x00, 0x00, 0x09, 0x90, 0x00, 0x00, 0x09, 0x90, 0x00, 0x00, 0x09, 0x90, 0x00, 0x00,
    0x09, 0x90, 0x00, 0x00, 0x09, 0xa0, 0x99, 0x99, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00
]
charactersOPEN_SANS_SEMIBOLD_10_13PX = [
    FontCharacter(3, 21, 0), FontCharacter(4, 28, 21), FontCharacter(6, 42, 49), FontCharacter(8, 56, 91),
    FontCharacter(7, 49, 147), FontCharacter(11, 77, 196), FontCharacter(10, 70, 273), FontCharacter(3, 21, 343),
    FontCharacter(4, 28, 364), FontCharacter(4, 28, 392), FontCharacter(7, 49, 420), FontCharacter(7, 49, 469),
    FontCharacter(3, 21, 518), FontCharacter(4, 28, 539), FontCharacter(4, 28, 567), FontCharacter(5, 35, 595),
    FontCharacter(7, 49, 630), FontCharacter(7, 49, 679), FontCharacter(7, 49, 728), FontCharacter(7, 49, 777),
    FontCharacter(7, 49, 826), FontCharacter(7, 49, 875), FontCharacter(7, 49, 924), FontCharacter(7, 49, 973),
    FontCharacter(7, 49, 1022), FontCharacter(7, 49, 1071), FontCharacter(4, 28, 1120), FontCharacter(4, 28, 1148),
    FontCharacter(7, 49, 1176), FontCharacter(7, 49, 1225), FontCharacter(7, 49, 1274), FontCharacter(6, 42, 1323),
    FontCharacter(12, 84, 1365), FontCharacter(9, 63, 1449), FontCharacter(9, 63, 1512), FontCharacter(8, 56, 1575),
    FontCharacter(10, 70, 1631), FontCharacter(7, 49, 1701), FontCharacter(7, 49, 1750), FontCharacter(9, 63, 1799),
    FontCharacter(10, 70, 1862), FontCharacter(4, 28, 1932), FontCharacter(4, 28, 1960), FontCharacter(8, 56, 1988),
    FontCharacter(7, 49, 2044), FontCharacter(12, 84, 2093), FontCharacter(10, 70, 2177), FontCharacter(10, 70, 2247),
    FontCharacter(8, 56, 2317), FontCharacter(10, 70, 2373), FontCharacter(8, 56, 2443), FontCharacter(7, 49, 2499),
    FontCharacter(7, 49, 2548), FontCharacter(10, 70, 2597), FontCharacter(8, 56, 2667), FontCharacter(12, 84, 2723),
    FontCharacter(8, 56, 2807), FontCharacter(8, 56, 2863), FontCharacter(7, 49, 2919), FontCharacter(4, 28, 2968),
    FontCharacter(5, 35, 2996), FontCharacter(4, 28, 3031), FontCharacter(7, 49, 3059), FontCharacter(6, 42, 3108),
    FontCharacter(8, 56, 3150), FontCharacter(8, 56, 3206), FontCharacter(8, 56, 3262), FontCharacter(6, 42, 3318),
    FontCharacter(8, 56, 3360), FontCharacter(7, 49, 3416), FontCharacter(6, 42, 3465), FontCharacter(7, 49, 3507),
    FontCharacter(8, 56, 3556), FontCharacter(4, 28, 3612), FontCharacter(4, 28, 3640), FontCharacter(7, 49, 3668),
    FontCharacter(4, 28, 3717), FontCharacter(12, 84, 3745), FontCharacter(8, 56, 3829), FontCharacter(8, 56, 3885),
    FontCharacter(8, 56, 3941), FontCharacter(8, 56, 3997), FontCharacter(6, 42, 4053), FontCharacter(6, 42, 4095),
    FontCharacter(5, 35, 4137), FontCharacter(8, 56, 4172), FontCharacter(7, 49, 4228), FontCharacter(11, 77, 4277),
    FontCharacter(7, 49, 4354), FontCharacter(7, 49, 4403), FontCharacter(6, 42, 4452), FontCharacter(5, 35, 4494),
    FontCharacter(7, 49, 4529), FontCharacter(5, 35, 4578), FontCharacter(7, 49, 4613), FontCharacter(8, 56, 4662)
]

bitmapOPEN_SANS_SEMIBOLD_8_11PX = [
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf3, 0x13,
    0x1f, 0xf1, 0x01, 0x0f, 0xf0, 0x00, 0x00, 0x91, 0x21, 0x2f, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe3, 0xe0, 0x13, 0x0d,
    0x1d, 0xc0, 0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x77, 0xb2, 0x00, 0xa0, 0x63, 0x07, 0xd4, 0xdf, 0xef, 0x0a, 0xe0, 0xc0, 0x02,
    0x20, 0x0b, 0x0e, 0xa0, 0xee, 0xfd, 0x4d, 0x80, 0x46, 0x0a, 0x00, 0x2b, 0x67, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x55, 0x00, 0x90, 0xfe, 0x1c, 0xe5, 0x67, 0x04, 0xe2, 0x8d, 0x00, 0x10,
    0xfa, 0x2d, 0x23, 0x65, 0x6e, 0xd5, 0xef, 0x0a, 0x00, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xd1, 0x2d, 0x30, 0x0c, 0x70, 0x68, 0x09, 0x4b, 0x00, 0x79, 0xb5, 0xc3, 0x00, 0x70, 0x68, 0xb9, 0xd7, 0x1d,
    0xd1, 0x7d, 0x9b, 0x86, 0x07, 0x00, 0x3c, 0x5b, 0x97, 0x00, 0xb4, 0x90, 0x86, 0x07, 0xc0, 0x03, 0xd2, 0x1d, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0xfd, 0x0a, 0x00, 0xb0, 0x07,
    0x3e, 0x00, 0x90, 0x39, 0x1f, 0x00, 0x20, 0xef, 0x04, 0x01, 0xe1, 0xea, 0x06, 0x6d, 0xe7, 0x20, 0xae, 0x0e, 0xe5,
    0x13, 0xf7, 0x09, 0x90, 0xfe, 0x6b, 0x6e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xf2, 0x10, 0x0e, 0xd0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0x07,
    0x1f, 0xc5, 0x80, 0x0a, 0x89, 0x90, 0x08, 0x98, 0x50, 0x0c, 0xf1, 0x00, 0x6a, 0x00, 0x00, 0x97, 0x10, 0x0f, 0xc0,
    0x05, 0x8a, 0x80, 0x09, 0x98, 0x90, 0x08, 0x5c, 0xf0, 0x61, 0x0a, 0x00, 0x00, 0x00, 0x88, 0x00, 0x43, 0x77, 0x34,
    0xb5, 0xee, 0x4b, 0x30, 0xdc, 0x03, 0x80, 0x55, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x77, 0x00, 0x00, 0x77, 0x00, 0xf7, 0xff,
    0x7f, 0x00, 0x77, 0x00, 0x00, 0x77, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x1f, 0xc4, 0x80, 0x07, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf9, 0x9f, 0x10, 0x01, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x91, 0x21, 0x2f, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xb6, 0x00, 0x6b, 0x10, 0x1f, 0x60, 0x0b, 0xb0, 0x06, 0xf1, 0x01, 0xb6, 0x00, 0x6b, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0xee, 0x06, 0xf2, 0x44, 0x1f, 0xc6, 0x00, 0x6c, 0xb7, 0x00, 0x7b, 0xb7, 0x00,
    0x7b, 0xc6, 0x00, 0x6c, 0xf1, 0x33, 0x2f, 0x60, 0xee, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xf8, 0x01, 0xb0, 0xfc, 0x01, 0x60, 0xf3, 0x01, 0x00, 0xf3, 0x01, 0x00, 0xf3, 0x01, 0x00, 0xf3, 0x01, 0x00,
    0xf3, 0x01, 0x00, 0xf3, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa1, 0xef, 0x07, 0x82, 0x42,
    0x2f, 0x00, 0x00, 0x3f, 0x00, 0x60, 0x0e, 0x00, 0xe3, 0x04, 0x20, 0x4d, 0x00, 0xe1, 0x18, 0x01, 0xf7, 0xff, 0x7f,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb2, 0xef, 0x09, 0x61, 0x31, 0x3f, 0x00, 0x40, 0x1e, 0x50,
    0xff, 0x06, 0x00, 0x40, 0x3f, 0x00, 0x00, 0x7d, 0x23, 0x40, 0x4f, 0xe6, 0xef, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xa0, 0x0d, 0x00, 0xe5, 0x0d, 0x10, 0x7d, 0x0d, 0xb0, 0x55, 0x0d, 0xa6, 0x50, 0x0d,
    0xfb, 0xff, 0xdf, 0x00, 0x50, 0x0d, 0x00, 0x50, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0,
    0xff, 0x0f, 0xf1, 0x13, 0x01, 0xf1, 0x00, 0x00, 0xf3, 0xfe, 0x09, 0x10, 0x40, 0x4f, 0x00, 0x00, 0x7d, 0x22, 0x40,
    0x3f, 0xe3, 0xef, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0xfa, 0x0f, 0xc0, 0x19, 0x00,
    0xe3, 0x00, 0x00, 0xc6, 0xfb, 0x0b, 0xe7, 0x02, 0x6d, 0xc6, 0x00, 0x9a, 0xf2, 0x13, 0x5e, 0x60, 0xfe, 0x09, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf9, 0xff, 0x9f, 0x10, 0x21, 0x4e, 0x00, 0x50, 0x0e, 0x00, 0xc0,
    0x07, 0x00, 0xf2, 0x01, 0x00, 0xa9, 0x00, 0x00, 0x4f, 0x00, 0x70, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x90, 0xff, 0x09, 0xd3, 0x00, 0x3e, 0xe1, 0x33, 0x1e, 0x60, 0xff, 0x04, 0xe2, 0x64, 0x2e, 0x87,
    0x00, 0x78, 0xc6, 0x00, 0x6c, 0xa0, 0xff, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0xef,
    0x06, 0xe5, 0x31, 0x2f, 0xa7, 0x00, 0x6c, 0xd6, 0x20, 0x7e, 0xa0, 0xcf, 0x7c, 0x00, 0x00, 0x4e, 0x00, 0x90, 0x0d,
    0xf0, 0xbf, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf2, 0x12, 0x19, 0x00,
    0x00, 0x00, 0x91, 0x21, 0x2f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf3, 0x12, 0x09, 0x00, 0x00, 0x00,
    0x00, 0x20, 0x1f, 0xc5, 0x80, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x00, 0xd4, 0x1a, 0xb2, 0x2b,
    0x00, 0xe4, 0x18, 0x00, 0x00, 0xe7, 0x19, 0x00, 0x00, 0x67, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf7, 0xff, 0x7f, 0x00, 0x00, 0x00, 0xf7, 0xff, 0x7f, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x66, 0x00, 0x00, 0xa1, 0x4d, 0x00, 0x00, 0xb2, 0x2b, 0x00, 0x81, 0x4e, 0x91, 0x7e, 0x00, 0x76, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe7, 0xcf, 0x43, 0x12, 0xaa, 0x00, 0xc0,
    0x07, 0xd1, 0x08, 0x70, 0x0a, 0x00, 0x00, 0x00, 0x50, 0x06, 0x00, 0xc9, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xa2, 0xdd, 0x6c, 0x00, 0x30, 0x3d, 0x00, 0xa0, 0x08, 0xd0, 0x42, 0xdd, 0x0c, 0x1d, 0xb3, 0xe0,
    0x01, 0x0f, 0x59, 0x95, 0xc3, 0x00, 0x0f, 0x58, 0x95, 0xd2, 0x40, 0x0e, 0x2c, 0xd1, 0x80, 0xbd, 0xd8, 0x08, 0x90,
    0x0a, 0x00, 0x10, 0x00, 0x00, 0xc6, 0xdd, 0x3c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xf5, 0x05, 0x00, 0xb0, 0xbc, 0x00, 0x00, 0x4f, 0x0f, 0x00, 0xd6, 0xd0, 0x06, 0xb0, 0x08, 0xb8, 0x10, 0xff,
    0xff, 0x1f, 0xd7, 0x11, 0xe1, 0xc7, 0x08, 0x00, 0xc8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xf0, 0xff, 0x7d, 0x00, 0x5f, 0x61, 0x2f, 0xf0, 0x03, 0xf4, 0x01, 0xff, 0xff, 0x07, 0xf0, 0x03, 0xf4, 0x02,
    0x3f, 0x00, 0x5f, 0xf0, 0x15, 0xf5, 0x03, 0xff, 0xef, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xe8, 0xdf, 0x05, 0xd9, 0x13, 0x24, 0xf1, 0x04, 0x00, 0x40, 0x0f, 0x00, 0x00, 0xf4, 0x00, 0x00,
    0x20, 0x3f, 0x00, 0x00, 0xb0, 0x3d, 0x31, 0x02, 0x90, 0xfe, 0x3d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xf0, 0xff, 0x8d, 0x00, 0xf0, 0x16, 0xd3, 0x0a, 0xf0, 0x05, 0x30, 0x2f, 0xf0, 0x05, 0x00, 0x5f,
    0xf0, 0x05, 0x00, 0x5f, 0xf0, 0x05, 0x40, 0x1f, 0xf0, 0x16, 0xe4, 0x09, 0xf0, 0xff, 0x7d, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0xff, 0x5f, 0xf0, 0x16, 0x01, 0xf0, 0x05, 0x00, 0xf0,
    0xff, 0x1f, 0xf0, 0x16, 0x01, 0xf0, 0x05, 0x00, 0xf0, 0x16, 0x01, 0xf0, 0xff, 0x5f, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xf0, 0xff, 0x9f, 0xf0, 0x16, 0x01, 0xf0, 0x05, 0x00, 0xf0, 0xff, 0x5f, 0xf0, 0x16, 0x01,
    0xf0, 0x05, 0x00, 0xf0, 0x05, 0x00, 0xf0, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xd7, 0xef, 0x0a, 0x90, 0x5e, 0x21, 0x04, 0xf1, 0x04, 0x00, 0x00, 0xf4, 0x00, 0x00, 0x00, 0xf4, 0x00, 0xfb, 0x1f,
    0xf1, 0x03, 0x31, 0x1f, 0xa0, 0x4d, 0x31, 0x1f, 0x00, 0xe9, 0xef, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x03, 0x30, 0x0f, 0xf0, 0x03, 0x30, 0x0f, 0xf0, 0x03, 0x30, 0x0f, 0xf0, 0xff,
    0xff, 0x0f, 0xf0, 0x15, 0x51, 0x0f, 0xf0, 0x03, 0x30, 0x0f, 0xf0, 0x03, 0x30, 0x0f, 0xf0, 0x03, 0x30, 0x0f, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf1, 0x13, 0x3f, 0xf1, 0x13, 0x3f, 0xf1, 0x13,
    0x3f, 0xf1, 0x13, 0x3f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x3f, 0x10, 0x3f, 0x10, 0x3f, 0x10, 0x3f, 0x10, 0x3f,
    0x10, 0x3f, 0x10, 0x3f, 0x10, 0x2f, 0x61, 0x0f, 0xee, 0x06, 0x00, 0x00, 0xf0, 0x05, 0xd1, 0x07, 0x5f, 0xb0, 0x0a,
    0xf0, 0x95, 0x0c, 0x00, 0xcf, 0x2f, 0x00, 0xf0, 0xcc, 0x0a, 0x00, 0x5f, 0xf2, 0x04, 0xf0, 0x05, 0xe7, 0x00, 0x5f,
    0x00, 0xac, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x05, 0x00, 0xf0, 0x05, 0x00,
    0xf0, 0x05, 0x00, 0xf0, 0x05, 0x00, 0xf0, 0x05, 0x00, 0xf0, 0x05, 0x00, 0xf0, 0x16, 0x11, 0xf0, 0xff, 0xbf, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x0e, 0x00, 0xe0, 0x0f, 0xf0, 0x4e, 0x00, 0xe5, 0x0f, 0xf0,
    0x99, 0x00, 0x9a, 0x0f, 0xf0, 0xe3, 0x00, 0x4e, 0x0f, 0xf0, 0xc3, 0x54, 0x3a, 0x0f, 0xf0, 0x73, 0xb9, 0x35, 0x0f,
    0xf0, 0x13, 0xee, 0x30, 0x0f, 0xf0, 0x03, 0x9c, 0x30, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x0d, 0x00, 0xd3, 0x00, 0xed, 0x09, 0x30, 0x0d, 0xd0, 0xf7, 0x04, 0xd3,
    0x00, 0x3d, 0xd8, 0x30, 0x0d, 0xd0, 0x03, 0x8d, 0xd3, 0x00, 0x3d, 0x40, 0x7f, 0x0d, 0xd0, 0x03, 0x90, 0xde, 0x00,
    0x3d, 0x00, 0xe0, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xe8, 0xef, 0x08, 0x00, 0xda, 0x14, 0xd4, 0x0a, 0xf1, 0x04, 0x00, 0xf4, 0x41, 0x0f, 0x00, 0x00, 0x4f, 0xf4, 0x00,
    0x00, 0xf0, 0x14, 0x4f, 0x00, 0x40, 0x1f, 0xa0, 0x4d, 0x41, 0xad, 0x00, 0x80, 0xfe, 0x8e, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0xff, 0x7d, 0x00, 0x6d, 0x51, 0x4f, 0xd0,
    0x05, 0xd0, 0x06, 0x5d, 0x40, 0x3f, 0xd0, 0xff, 0x7e, 0x00, 0x6d, 0x00, 0x00, 0xd0, 0x05, 0x00, 0x00, 0x5d, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe8, 0xef, 0x08, 0x00, 0xda, 0x14,
    0xd4, 0x0a, 0xf1, 0x04, 0x00, 0xf4, 0x41, 0x0f, 0x00, 0x00, 0x4f, 0xf4, 0x00, 0x00, 0xf0, 0x14, 0x4f, 0x00, 0x40,
    0x1f, 0xa0, 0x4d, 0x41, 0x9d, 0x00, 0x80, 0xfe, 0x8f, 0x00, 0x00, 0x00, 0xc0, 0x0a, 0x00, 0x00, 0x00, 0xe1, 0x09,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0xff, 0x4d, 0x00, 0x6f, 0x71, 0x0f, 0xf0, 0x05, 0xf1, 0x02, 0x5f, 0x70, 0x0e,
    0xf0, 0xff, 0x3e, 0x00, 0x6f, 0xf3, 0x03, 0xf0, 0x05, 0xd7, 0x00, 0x5f, 0x00, 0x8d, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xfe, 0x2c, 0xf4, 0x13, 0x05, 0xe4, 0x01, 0x00, 0xb0, 0x7e, 0x00, 0x00,
    0xc5, 0x1e, 0x00, 0x00, 0x7d, 0x33, 0x21, 0x5e, 0xd5, 0xef, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xfd, 0xff, 0xdf, 0x11, 0xaa, 0x11, 0x00, 0x99, 0x00, 0x00, 0x99, 0x00, 0x00, 0x99, 0x00, 0x00, 0x99, 0x00,
    0x00, 0x99, 0x00, 0x00, 0x99, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x03, 0x30, 0x0f,
    0xf0, 0x03, 0x30, 0x0f, 0xf0, 0x03, 0x30, 0x0f, 0xf0, 0x03, 0x30, 0x0f, 0xf0, 0x03, 0x30, 0x0f, 0xf0, 0x04, 0x40,
    0x0f, 0xb0, 0x2b, 0xb2, 0x0b, 0x10, 0xfb, 0xaf, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x7c, 0x00, 0x70, 0x7c, 0x0d, 0x00, 0x7d, 0xf1, 0x02, 0xf2, 0x01, 0x7b, 0x70, 0x0b, 0x60, 0x0d, 0x6d,
    0x00, 0xf0, 0xf5, 0x00, 0x00, 0xeb, 0x0a, 0x00, 0x50, 0x5f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x7c, 0x00, 0xbc, 0x00, 0xc7, 0xa8, 0x00, 0xff, 0x00, 0x8a, 0xe5, 0x40, 0xcc, 0x04, 0x4e, 0xf1,
    0x82, 0x98, 0x28, 0x0f, 0xd0, 0xc5, 0x54, 0x5c, 0x0d, 0x90, 0xf9, 0x00, 0x9f, 0x09, 0x50, 0xce, 0x00, 0xec, 0x05,
    0x10, 0x8f, 0x00, 0xf8, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xd7, 0x00, 0xd0, 0x06, 0x8c, 0x80, 0x0c, 0x30, 0x5f, 0x2f, 0x00, 0x80, 0x8f, 0x00, 0x00, 0xeb, 0x0a, 0x00,
    0xe5, 0xe2, 0x04, 0xe0, 0x04, 0xe6, 0xa0, 0x0a, 0x00, 0xac, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xab, 0x00, 0xa0, 0x2b, 0x3f, 0x40, 0x1f, 0x90, 0x0c, 0x7d, 0x00, 0xe0, 0xdb, 0x00, 0x00, 0xf6, 0x04,
    0x00, 0x30, 0x1f, 0x00, 0x00, 0xf3, 0x01, 0x00, 0x30, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xf9, 0xff, 0x9f, 0x10, 0x51, 0x2f, 0x00, 0xc0, 0x08, 0x00, 0xe6, 0x00, 0x10, 0x5e, 0x00, 0xa0,
    0x0b, 0x00, 0xf4, 0x14, 0x01, 0xf9, 0xff, 0x9f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf1, 0xbf,
    0xf1, 0x01, 0xf1, 0x01, 0xf1, 0x01, 0xf1, 0x01, 0xf1, 0x01, 0xf1, 0x01, 0xf1, 0x01, 0xf1, 0x01, 0xf1, 0xbf, 0x00,
    0x00, 0x6b, 0x00, 0xb6, 0x00, 0xf1, 0x01, 0xb0, 0x06, 0x60, 0x0b, 0x10, 0x1f, 0x00, 0x6b, 0x00, 0xb6, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xfb, 0x1f, 0x10, 0x1f, 0x10, 0x1f, 0x10, 0x1f, 0x10, 0x1f, 0x10, 0x1f, 0x10, 0x1f, 0x10,
    0x1f, 0x10, 0x1f, 0xfb, 0x1f, 0x00, 0x00, 0x00, 0x6a, 0x00, 0x20, 0xdc, 0x00, 0xa0, 0x74, 0x07, 0xd1, 0x00, 0x1d,
    0x69, 0x00, 0x86, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0xbb, 0xbb, 0x00, 0x00, 0x00, 0x00, 0x80, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90,
    0xfe, 0x08, 0x20, 0x20, 0x1f, 0xa0, 0xdd, 0x3f, 0xd6, 0x10, 0x3f, 0xd7, 0x60, 0x3f, 0xd1, 0x8f, 0x3d, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf1, 0x03, 0x00, 0x10, 0x3f, 0x00, 0x00, 0xf1, 0xe8, 0x6e, 0x10, 0x8f,
    0x50, 0x2f, 0xf1, 0x03, 0xe0, 0x15, 0x3f, 0x00, 0x5e, 0xf1, 0x09, 0xf5, 0x12, 0x7f, 0xee, 0x06, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xfe, 0x36, 0x3f, 0x11, 0xc7,
    0x00, 0x70, 0x0c, 0x00, 0xf3, 0x03, 0x02, 0xe7, 0x6f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xf3, 0x01, 0x00, 0x30, 0x1f, 0x60, 0xee, 0xf9, 0x21, 0x5f, 0x80, 0x1f, 0xe5, 0x00, 0xf2, 0x51, 0x0d, 0x10, 0x1f,
    0xf2, 0x04, 0xf8, 0x01, 0xe7, 0x7e, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0xfe, 0x09, 0xe2, 0x01, 0x5d, 0xf6, 0xdd, 0x6d, 0xe7, 0x00, 0x00, 0xf2, 0x05,
    0x12, 0x60, 0xfe, 0x2d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0xfe, 0x04, 0x8c, 0x00, 0xfa,
    0xdf, 0x00, 0x7d, 0x00, 0xd0, 0x07, 0x00, 0x7d, 0x00, 0xd0, 0x07, 0x00, 0x7d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa0, 0xed, 0xaf, 0xd5, 0x20, 0x0f, 0xd5, 0x20, 0x0f, 0xc0,
    0xde, 0x06, 0xe0, 0x00, 0x00, 0xe0, 0xff, 0x4e, 0x7a, 0x11, 0xb9, 0x5d, 0x00, 0x9a, 0xd4, 0xdd, 0x09, 0xf1, 0x01,
    0x00, 0x10, 0x1f, 0x00, 0x00, 0xf1, 0xe8, 0x7e, 0x10, 0x9f, 0x60, 0x0f, 0xf1, 0x02, 0xf1, 0x11, 0x1f, 0x10, 0x1f,
    0xf1, 0x01, 0xf1, 0x11, 0x1f, 0x10, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe1,
    0x01, 0x00, 0xf1, 0x11, 0x1f, 0xf1, 0x11, 0x1f, 0xf1, 0x11, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x1e, 0x00,
    0x00, 0x10, 0x1f, 0x10, 0x1f, 0x10, 0x1f, 0x10, 0x1f, 0x10, 0x1f, 0x10, 0x1f, 0x10, 0x1f, 0x30, 0x1f, 0xfa, 0x09,
    0xf1, 0x01, 0x00, 0xf1, 0x01, 0x00, 0xf1, 0x21, 0x5e, 0xf1, 0xd2, 0x07, 0xf1, 0xbb, 0x00, 0xf1, 0xfa, 0x02, 0xf1,
    0x81, 0x0d, 0xf1, 0x01, 0x9d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf1, 0x11, 0x1f, 0xf1, 0x11,
    0x1f, 0xf1, 0x11, 0x1f, 0xf1, 0x11, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xf1, 0xe7, 0x8f, 0xe8, 0x7e, 0x10, 0x9f, 0x60, 0x8f, 0x60, 0x0f, 0xf1, 0x03, 0xf1, 0x01,
    0xf1, 0x11, 0x3f, 0x10, 0x1f, 0x10, 0x1f, 0xf1, 0x03, 0xf1, 0x01, 0xf1, 0x11, 0x3f, 0x10, 0x1f, 0x10, 0x1f, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xf1, 0xe7, 0x7e, 0x10, 0x9f, 0x60, 0x0f, 0xf1, 0x02, 0xf1, 0x11, 0x1f, 0x10, 0x1f, 0xf1,
    0x01, 0xf1, 0x11, 0x1f, 0x10, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0xfd, 0x4d, 0x10, 0x5f, 0x50, 0x1f, 0xe5, 0x00, 0xe0, 0x55, 0x0e, 0x00, 0x5e,
    0xf1, 0x05, 0xf5, 0x01, 0xd4, 0xdf, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf1, 0xe7, 0x6e, 0x10, 0x8f, 0x50, 0x2f, 0xf1, 0x03, 0xe0, 0x15, 0x3f, 0x00,
    0x5e, 0xf1, 0x09, 0xf5, 0x12, 0x9f, 0xee, 0x06, 0xf1, 0x03, 0x00, 0x10, 0x3f, 0x00, 0x00, 0xf1, 0x03, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0xee, 0xf7, 0x21, 0x5f, 0x80, 0x1f, 0xe5, 0x00, 0xf2, 0x51, 0x0d,
    0x10, 0x1f, 0xf2, 0x04, 0xf8, 0x01, 0xe7, 0x8e, 0x1f, 0x00, 0x00, 0xf3, 0x01, 0x00, 0x30, 0x1f, 0x00, 0x00, 0xf3,
    0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0xd4, 0x0b, 0xcf, 0x13, 0xf0, 0x04, 0x00, 0x3f, 0x00, 0xf0, 0x03, 0x00,
    0x3f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc1, 0xef, 0x73, 0x0c,
    0x02, 0xe3, 0x3b, 0x00, 0x81, 0x4f, 0x02, 0xb0, 0x57, 0xfe, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xc0, 0x03, 0xfb, 0xbf, 0xf1, 0x03, 0xf1, 0x03, 0xf1, 0x03, 0xf0, 0x05, 0x80, 0xaf, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf1, 0x01, 0xf1, 0x11, 0x1f, 0x10, 0x1f, 0xf1, 0x01,
    0xf1, 0x11, 0x1f, 0x20, 0x1f, 0xf0, 0x05, 0xf9, 0x01, 0xe7, 0x7e, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7c, 0x00, 0xc7, 0xd6, 0x00, 0x6d, 0xf0, 0x33, 0x0f,
    0xa0, 0x98, 0x09, 0x40, 0xdd, 0x03, 0x00, 0xdd, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x8b, 0x40, 0x4f, 0x80, 0x7b, 0x0c, 0xc9, 0x09, 0x7c, 0xf2, 0xd0,
    0xd4, 0xf0, 0x02, 0x6e, 0x0d, 0x6e, 0x0e, 0x90, 0x9d, 0x90, 0x9d, 0x00, 0xf5, 0x04, 0xf5, 0x05, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe6, 0x00,
    0x6e, 0xb0, 0x99, 0x0b, 0x10, 0xee, 0x01, 0x20, 0xff, 0x02, 0xc0, 0x87, 0x0c, 0xd8, 0x00, 0x8d, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x8c, 0x00, 0xc8, 0xe6, 0x00, 0x6d, 0xe0,
    0x34, 0x1f, 0x80, 0x99, 0x0b, 0x20, 0xde, 0x05, 0x00, 0xec, 0x00, 0x00, 0x9b, 0x00, 0x30, 0x2f, 0x00, 0xeb, 0x06,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf7, 0xff, 0x07, 0x30, 0x2e, 0x00, 0x7d, 0x00, 0xc8, 0x00, 0xf2, 0x02, 0x90,
    0xff, 0x9f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0xbc, 0x50, 0x0d, 0x50, 0x0b, 0x80, 0x0b, 0xeb,
    0x02, 0x90, 0x0a, 0x50, 0x0b, 0x50, 0x0b, 0x50, 0x0d, 0x00, 0xbb, 0x00, 0x00, 0x00, 0x77, 0x00, 0x00, 0x77, 0x00,
    0x00, 0x77, 0x00, 0x00, 0x77, 0x00, 0x00, 0x77, 0x00, 0x00, 0x77, 0x00, 0x00, 0x77, 0x00, 0x00, 0x77, 0x00, 0x00,
    0x77, 0x00, 0x00, 0x77, 0x00, 0x00, 0x77, 0x00, 0xcb, 0x01, 0xc0, 0x06, 0xb0, 0x07, 0xa0, 0x09, 0x10, 0xbe, 0x90,
    0x0a, 0xb0, 0x07, 0xb0, 0x07, 0xd0, 0x05, 0xbb, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xe4, 0x3c, 0x40, 0x04, 0xc3, 0x4e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x99, 0xb9, 0x00, 0x07, 0x00, 0x07, 0x70, 0x00, 0x70, 0x00, 0x07, 0x00,
    0x07, 0x70, 0x00, 0x70, 0x00, 0x07, 0x00, 0x07, 0x70, 0x00, 0x70, 0x00, 0x9b, 0x99, 0x0b, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
]
charactersOPEN_SANS_SEMIBOLD_8_11PX = [
    FontCharacter(3, 17, 0), FontCharacter(3, 17, 17), FontCharacter(5, 28, 34), FontCharacter(7, 39, 62),
    FontCharacter(6, 33, 101), FontCharacter(9, 50, 134), FontCharacter(8, 44, 184), FontCharacter(3, 17, 228),
    FontCharacter(3, 17, 245), FontCharacter(3, 17, 262), FontCharacter(6, 33, 279), FontCharacter(6, 33, 312),
    FontCharacter(3, 17, 345), FontCharacter(4, 22, 362), FontCharacter(3, 17, 384), FontCharacter(4, 22, 401),
    FontCharacter(6, 33, 423), FontCharacter(6, 33, 456), FontCharacter(6, 33, 489), FontCharacter(6, 33, 522),
    FontCharacter(6, 33, 555), FontCharacter(6, 33, 588), FontCharacter(6, 33, 621), FontCharacter(6, 33, 654),
    FontCharacter(6, 33, 687), FontCharacter(6, 33, 720), FontCharacter(3, 17, 753), FontCharacter(3, 17, 770),
    FontCharacter(6, 33, 787), FontCharacter(6, 33, 820), FontCharacter(6, 33, 853), FontCharacter(5, 28, 886),
    FontCharacter(10, 55, 914), FontCharacter(7, 39, 969), FontCharacter(7, 39, 1008), FontCharacter(7, 39, 1047),
    FontCharacter(8, 44, 1086), FontCharacter(6, 33, 1130), FontCharacter(6, 33, 1163), FontCharacter(8, 44, 1196),
    FontCharacter(8, 44, 1240), FontCharacter(3, 17, 1284), FontCharacter(4, 22, 1301), FontCharacter(7, 39, 1323),
    FontCharacter(6, 33, 1362), FontCharacter(10, 55, 1395), FontCharacter(9, 50, 1450), FontCharacter(9, 50, 1500),
    FontCharacter(7, 39, 1550), FontCharacter(9, 50, 1589), FontCharacter(7, 39, 1639), FontCharacter(6, 33, 1678),
    FontCharacter(6, 33, 1711), FontCharacter(8, 44, 1744), FontCharacter(7, 39, 1788), FontCharacter(10, 55, 1827),
    FontCharacter(7, 39, 1882), FontCharacter(7, 39, 1921), FontCharacter(6, 33, 1960), FontCharacter(4, 22, 1993),
    FontCharacter(4, 22, 2015), FontCharacter(4, 22, 2037), FontCharacter(6, 33, 2059), FontCharacter(5, 28, 2092),
    FontCharacter(7, 39, 2120), FontCharacter(6, 33, 2159), FontCharacter(7, 39, 2192), FontCharacter(5, 28, 2231),
    FontCharacter(7, 39, 2259), FontCharacter(6, 33, 2298), FontCharacter(5, 28, 2331), FontCharacter(6, 33, 2359),
    FontCharacter(7, 39, 2392), FontCharacter(3, 17, 2431), FontCharacter(4, 22, 2448), FontCharacter(6, 33, 2470),
    FontCharacter(3, 17, 2503), FontCharacter(11, 61, 2520), FontCharacter(7, 39, 2581), FontCharacter(7, 39, 2620),
    FontCharacter(7, 39, 2659), FontCharacter(7, 39, 2698), FontCharacter(5, 28, 2737), FontCharacter(5, 28, 2765),
    FontCharacter(4, 22, 2793), FontCharacter(7, 39, 2815), FontCharacter(6, 33, 2854), FontCharacter(9, 50, 2887),
    FontCharacter(6, 33, 2937), FontCharacter(6, 33, 2970), FontCharacter(5, 28, 3003), FontCharacter(4, 22, 3031),
    FontCharacter(6, 33, 3053), FontCharacter(4, 22, 3086), FontCharacter(6, 33, 3108), FontCharacter(7, 39, 3141)
]

bitmapOPEN_SANS_REGULAR_11_14PX = [
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x0b, 0xa0, 0x0a,
    0x90, 0x09, 0x90, 0x09, 0x70, 0x08, 0x70, 0x07, 0x60, 0x07, 0x50, 0x05, 0x00, 0x00, 0xb0, 0x0a, 0xb0, 0x0b, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x44, 0x0f, 0xe0, 0x33, 0x0e, 0xd0, 0x11, 0x0d,
    0xb0, 0x11, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x20, 0x0c, 0xd0, 0x01, 0x00, 0x60, 0x08, 0xe0, 0x00, 0x00, 0x90, 0x05, 0xa4, 0x00, 0xf0,
    0xff, 0xff, 0xff, 0x7f, 0x00, 0xe0, 0x00, 0x4a, 0x00, 0x00, 0xc2, 0x00, 0x1d, 0x00, 0x00, 0xa4, 0x00, 0x0f, 0x00,
    0xf9, 0xff, 0xff, 0xff, 0x0f, 0x00, 0x4b, 0x60, 0x08, 0x00, 0x00, 0x0e, 0x90, 0x05, 0x00, 0x10, 0x0d, 0xc0, 0x02,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0xe9, 0xff, 0x5c, 0x00, 0xba, 0xf1, 0x30,
    0x02, 0xc0, 0x06, 0x0f, 0x00, 0x00, 0xe7, 0xf7, 0x00, 0x00, 0x00, 0xb5, 0xbf, 0x05, 0x00, 0x00, 0xf0, 0xd6, 0x09,
    0x00, 0x00, 0x0f, 0xf4, 0x00, 0x26, 0xf0, 0xb2, 0x0a, 0xa0, 0xfe, 0xdf, 0x08, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x60, 0xdd, 0x02, 0x00, 0x2d, 0x00, 0xe0, 0x50, 0x0a, 0x60, 0x09, 0x00, 0xc3, 0x00, 0x0e,
    0xd0, 0x01, 0x00, 0xb3, 0x00, 0x0f, 0x87, 0x00, 0x00, 0xc2, 0x00, 0x0e, 0x4e, 0xdd, 0x04, 0xe0, 0x51, 0x7a, 0xb8,
    0x14, 0x0e, 0x50, 0xdd, 0xd4, 0xe0, 0x00, 0x2c, 0x00, 0x00, 0x78, 0xf0, 0x00, 0x3b, 0x00, 0x10, 0x0d, 0xe0, 0x00,
    0x2c, 0x00, 0x90, 0x06, 0xa0, 0x14, 0x0e, 0x00, 0xd1, 0x00, 0x20, 0xdd, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0xfc, 0x4d, 0x00, 0x00, 0x00, 0x6e, 0x60, 0x0e, 0x00, 0x00, 0xf1, 0x00, 0xf1,
    0x01, 0x00, 0x00, 0x4e, 0x60, 0x0e, 0x00, 0x00, 0x60, 0x8e, 0x3e, 0x00, 0x00, 0x00, 0xf4, 0x4f, 0x00, 0x00, 0x00,
    0xe6, 0xa5, 0x2e, 0x10, 0x1f, 0xf0, 0x04, 0x80, 0x3e, 0xb7, 0x10, 0x1f, 0x00, 0x70, 0xfe, 0x02, 0xd0, 0x2a, 0x31,
    0xe9, 0x4f, 0x00, 0xb2, 0xff, 0x8d, 0x41, 0x6e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x3f, 0xf0, 0x01, 0x0e, 0xd0, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x4c, 0x50, 0x0c, 0xc0, 0x06, 0xf1, 0x02, 0xf4, 0x00, 0xd5, 0x00, 0xd7, 0x00, 0xd6, 0x00, 0xf4, 0x00, 0xf1, 0x02,
    0xc0, 0x06, 0x50, 0x0c, 0x00, 0x4c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc4, 0x00, 0xc0, 0x05, 0x60, 0x0c, 0x20,
    0x1f, 0x00, 0x4f, 0x00, 0x5d, 0x00, 0x7d, 0x00, 0x6d, 0x00, 0x4f, 0x20, 0x1f, 0x60, 0x0c, 0xc0, 0x06, 0xc4, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xa0, 0x09, 0x00, 0x00, 0x80, 0x07, 0x00, 0x92, 0x84, 0x56, 0x29, 0x93, 0xeb, 0xbe,
    0x29, 0x00, 0xc3, 0x2d, 0x00, 0x00, 0x6d, 0xc7, 0x00, 0x10, 0x0c, 0xb0, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00,
    0xf0, 0xff, 0xff, 0xff, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x0c, 0xe0, 0x07, 0xf1, 0x01, 0xb5, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50,
    0xff, 0x5f, 0x10, 0x11, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xb0, 0x0a, 0xb0, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x9a, 0x00, 0x10, 0x3f, 0x00, 0x70, 0x0d, 0x00, 0xd0, 0x06, 0x00, 0xf4, 0x00, 0x00, 0xaa, 0x00, 0x10,
    0x3f, 0x00, 0x60, 0x0d, 0x00, 0xd0, 0x07, 0x00, 0xf3, 0x01, 0x00, 0xaa, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0xfd, 0x5d, 0x00, 0x50, 0x3e, 0x40,
    0x4e, 0x00, 0x6c, 0x00, 0x60, 0x0c, 0xf0, 0x02, 0x00, 0xf2, 0x20, 0x0f, 0x00, 0x00, 0x2f, 0xf3, 0x00, 0x00, 0xf0,
    0x23, 0x0f, 0x00, 0x00, 0x2f, 0xf0, 0x02, 0x00, 0xf2, 0x00, 0x6c, 0x00, 0x60, 0x0c, 0x40, 0x3e, 0x40, 0x5e, 0x00,
    0x50, 0xfd, 0x6d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe4, 0x07, 0x00, 0x00, 0xd9, 0x7d, 0x00, 0x00, 0xa3, 0xb0,
    0x07, 0x00, 0x00, 0x00, 0x7b, 0x00, 0x00, 0x00, 0xb0, 0x07, 0x00, 0x00, 0x00, 0x7b, 0x00, 0x00, 0x00, 0xb0, 0x07,
    0x00, 0x00, 0x00, 0x7b, 0x00, 0x00, 0x00, 0xb0, 0x07, 0x00, 0x00, 0x00, 0x7b, 0x00, 0x00, 0x00, 0xb0, 0x07, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xa2, 0xfe, 0x5d, 0x00, 0xc0, 0x27, 0x40, 0x4e, 0x00, 0x00, 0x00, 0xa0, 0x09, 0x00, 0x00,
    0x00, 0x99, 0x00, 0x00, 0x00, 0xe0, 0x04, 0x00, 0x00, 0xa0, 0x09, 0x00, 0x00, 0xa0, 0x0b, 0x00, 0x00, 0xa0, 0x0b,
    0x00, 0x00, 0xa0, 0x0a, 0x00, 0x00, 0xb0, 0x1b, 0x11, 0x11, 0x30, 0xff, 0xff, 0xff, 0x1f, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xb4, 0xfe, 0x7d, 0x00, 0xb0, 0x16, 0x40, 0x6e, 0x00, 0x00, 0x00, 0x80, 0x0b, 0x00, 0x00, 0x00, 0x9a, 0x00, 0x00,
    0x10, 0xe7, 0x02, 0x00, 0xf9, 0xdf, 0x04, 0x00, 0x00, 0x10, 0xd4, 0x09, 0x00, 0x00, 0x00, 0xf4, 0x00, 0x00, 0x00,
    0x40, 0x0f, 0x62, 0x02, 0x40, 0x9d, 0x10, 0xeb, 0xff, 0x7c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfb, 0x00,
    0x00, 0x00, 0xc7, 0x0f, 0x00, 0x00, 0xd3, 0xf3, 0x00, 0x00, 0xd0, 0x33, 0x0f, 0x00, 0xb0, 0x07, 0xf3, 0x00, 0x70,
    0x0a, 0x30, 0x0f, 0x30, 0x0d, 0x00, 0xf3, 0x00, 0xf9, 0xff, 0xff, 0xff, 0x0b, 0x11, 0x11, 0xf5, 0x11, 0x00, 0x00,
    0x30, 0x0f, 0x00, 0x00, 0x00, 0xf3, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf4, 0xff, 0xff, 0x03, 0x60, 0x1b, 0x11, 0x01,
    0x00, 0x97, 0x00, 0x00, 0x00, 0x90, 0x07, 0x00, 0x00, 0x00, 0xe9, 0xff, 0x7d, 0x00, 0x00, 0x02, 0x40, 0x9e, 0x00,
    0x00, 0x00, 0x40, 0x0f, 0x00, 0x00, 0x00, 0xf1, 0x01, 0x00, 0x00, 0x50, 0x0e, 0x70, 0x03, 0x50, 0x6e, 0x00, 0xe9,
    0xff, 0x5c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc7, 0xff, 0x04, 0x00, 0xbb, 0x03, 0x00, 0x00, 0xd5, 0x00, 0x00,
    0x00, 0xb0, 0x06, 0x00, 0x00, 0x00, 0x5f, 0xfb, 0xaf, 0x01, 0xf0, 0x3c, 0x00, 0xca, 0x10, 0x4f, 0x00, 0x00, 0x2f,
    0xf0, 0x02, 0x00, 0xf0, 0x03, 0x7b, 0x00, 0x20, 0x0f, 0x30, 0x5e, 0x20, 0xab, 0x00, 0x40, 0xfc, 0x9e, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x30, 0xff, 0xff, 0xff, 0x3f, 0x10, 0x11, 0x11, 0xe5, 0x00, 0x00, 0x00, 0xb0, 0x07, 0x00, 0x00, 0x20,
    0x1f, 0x00, 0x00, 0x00, 0x9a, 0x00, 0x00, 0x00, 0xf2, 0x01, 0x00, 0x00, 0xa0, 0x0a, 0x00, 0x00, 0x10, 0x3f, 0x00,
    0x00, 0x00, 0xb9, 0x00, 0x00, 0x00, 0xf1, 0x04, 0x00, 0x00, 0x80, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80,
    0xfe, 0x8e, 0x00, 0x80, 0x2d, 0x20, 0x8d, 0x00, 0x6c, 0x00, 0x60, 0x0c, 0xa0, 0x08, 0x00, 0xa8, 0x00, 0xe2, 0x18,
    0xd7, 0x01, 0x00, 0xf4, 0xef, 0x02, 0x00, 0xd6, 0x25, 0xe8, 0x05, 0xf0, 0x02, 0x00, 0xf4, 0x20, 0x0f, 0x00, 0x00,
    0x1f, 0xd0, 0x19, 0x10, 0xc9, 0x00, 0xa1, 0xfe, 0x9e, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xfe, 0x4c, 0x00, 0x90,
    0x2c, 0x40, 0x4e, 0x00, 0x3f, 0x00, 0x50, 0x0c, 0xf1, 0x00, 0x00, 0xf1, 0x10, 0x1f, 0x00, 0x20, 0x1f, 0xb0, 0x0a,
    0x20, 0xfc, 0x01, 0xa1, 0xfe, 0x4b, 0x0f, 0x00, 0x00, 0x00, 0xc5, 0x00, 0x00, 0x00, 0xc0, 0x06, 0x00, 0x00, 0xb2,
    0x0b, 0x00, 0xf4, 0xcf, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x0b, 0xb0, 0x0a, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x0a, 0xb0, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x0a, 0xb0, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xc0, 0x08, 0xf0, 0x04, 0xe2, 0x00, 0x86, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x3a, 0x00, 0x00, 0xc4, 0x5c, 0x00, 0x60, 0x9c, 0x02,
    0x00, 0xe2, 0x1b, 0x00, 0x00, 0x00, 0xb4, 0x7d, 0x01, 0x00, 0x00, 0x10, 0xd8, 0x4a, 0x00, 0x00, 0x00, 0x40, 0x3b,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0xff, 0xff, 0xff, 0x1f, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf1, 0xff, 0xff, 0xff, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x3a,
    0x00, 0x00, 0x00, 0x50, 0xbc, 0x04, 0x00, 0x00, 0x00, 0xa3, 0x6d, 0x00, 0x00, 0x00, 0x10, 0xeb, 0x02, 0x00, 0x71,
    0xbd, 0x04, 0x40, 0xda, 0x18, 0x00, 0x30, 0x4b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xc5, 0xef, 0x09, 0x45, 0x31, 0x6d, 0x00, 0x00, 0x98, 0x00, 0x00, 0x7b, 0x00, 0x60, 0x1e, 0x00,
    0xe5, 0x02, 0x00, 0x3d, 0x00, 0x00, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x30, 0x3f, 0x00, 0x30, 0x3f, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x81,
    0xfc, 0xcf, 0x06, 0x00, 0x00, 0xd3, 0x17, 0x00, 0xa2, 0x0b, 0x00, 0xd1, 0x03, 0x00, 0x00, 0xa0, 0x07, 0x80, 0x07,
    0xb1, 0xee, 0x0c, 0xd2, 0x00, 0x1e, 0xc0, 0x07, 0xe1, 0x00, 0x1e, 0xe1, 0x10, 0x0e, 0x30, 0x0d, 0xd0, 0x11, 0x0d,
    0xd3, 0x00, 0xd4, 0x00, 0x0e, 0xe0, 0x00, 0x2f, 0x90, 0x0d, 0xa5, 0x00, 0x2d, 0x50, 0xde, 0x76, 0xce, 0x01, 0x70,
    0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x3b, 0x00, 0x40, 0x02, 0x00, 0x00, 0x60, 0xfc, 0xef, 0x2a, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xcb, 0x00, 0x00, 0x00, 0x20, 0xee, 0x02, 0x00, 0x00, 0x80, 0x89, 0x08,
    0x00, 0x00, 0xe0, 0x22, 0x0e, 0x00, 0x00, 0xc5, 0x00, 0x5b, 0x00, 0x00, 0x5c, 0x00, 0xc5, 0x00, 0x20, 0xff, 0xff,
    0xff, 0x02, 0x80, 0x18, 0x11, 0x91, 0x09, 0xe0, 0x02, 0x00, 0x30, 0x0e, 0xc6, 0x00, 0x00, 0x00, 0x6d, 0x6c, 0x00,
    0x00, 0x00, 0xc7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xff, 0xff, 0x7c, 0x00, 0x70, 0x1c, 0x11, 0xe5, 0x07,
    0x70, 0x0b, 0x00, 0x80, 0x0b, 0x70, 0x0b, 0x00, 0x80, 0x0a, 0x70, 0x0b, 0x00, 0xe3, 0x03, 0x70, 0xff, 0xff, 0x6e,
    0x00, 0x70, 0x0b, 0x00, 0xc3, 0x09, 0x70, 0x0b, 0x00, 0x30, 0x1f, 0x70, 0x0b, 0x00, 0x30, 0x1f, 0x70, 0x1c, 0x11,
    0xc3, 0x0c, 0x70, 0xff, 0xff, 0x9d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd7, 0xff, 0x3c, 0x00, 0xdb,
    0x15, 0x62, 0x02, 0xe7, 0x01, 0x00, 0x00, 0xd0, 0x07, 0x00, 0x00, 0x00, 0x4f, 0x00, 0x00, 0x00, 0xf1, 0x03, 0x00,
    0x00, 0x00, 0x3f, 0x00, 0x00, 0x00, 0xe0, 0x07, 0x00, 0x00, 0x00, 0xe8, 0x00, 0x00, 0x00, 0x00, 0xcd, 0x14, 0x52,
    0x00, 0x00, 0xe9, 0xef, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf7, 0xff, 0xcf, 0x06, 0x00, 0x70, 0x1c, 0x21, 0xd6,
    0x0b, 0x00, 0xb7, 0x00, 0x00, 0xe1, 0x06, 0x70, 0x0b, 0x00, 0x00, 0xd8, 0x00, 0xb7, 0x00, 0x00, 0x40, 0x0f, 0x70,
    0x0b, 0x00, 0x00, 0xf3, 0x01, 0xb7, 0x00, 0x00, 0x40, 0x0f, 0x70, 0x0b, 0x00, 0x00, 0xc8, 0x00, 0xb7, 0x00, 0x00,
    0xf2, 0x06, 0x70, 0x1c, 0x21, 0xe7, 0x0a, 0x00, 0xf7, 0xff, 0xbe, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x90, 0xff, 0xff, 0x1f, 0x90, 0x1a, 0x11, 0x01, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09,
    0x00, 0x00, 0x90, 0xff, 0xff, 0x0d, 0x90, 0x1a, 0x11, 0x01, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90,
    0x1a, 0x11, 0x01, 0x90, 0xff, 0xff, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xff, 0xff, 0xbf, 0x70, 0x1c, 0x11, 0x11, 0x70, 0x0b, 0x00,
    0x00, 0x70, 0x0b, 0x00, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x70, 0xff, 0xff, 0x5f, 0x70, 0x1c, 0x11, 0x01, 0x70, 0x0b,
    0x00, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb4,
    0xfe, 0xce, 0x05, 0x00, 0xe8, 0x27, 0x21, 0x46, 0x00, 0xf5, 0x02, 0x00, 0x00, 0x00, 0xb0, 0x08, 0x00, 0x00, 0x00,
    0x00, 0x4f, 0x00, 0x00, 0x00, 0x00, 0xf1, 0x03, 0x00, 0xfb, 0xdf, 0x00, 0x4f, 0x00, 0x10, 0x61, 0x0d, 0xc0, 0x08,
    0x00, 0x00, 0xd5, 0x00, 0xe6, 0x02, 0x00, 0x50, 0x0d, 0x00, 0xeb, 0x26, 0x21, 0xd8, 0x00, 0x00, 0xc6, 0xff, 0xce,
    0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb7, 0x00, 0x00, 0xb0, 0x07, 0x70, 0x0b, 0x00, 0x00,
    0x7b, 0x00, 0xb7, 0x00, 0x00, 0xb0, 0x07, 0x70, 0x0b, 0x00, 0x00, 0x7b, 0x00, 0xb7, 0x00, 0x00, 0xb0, 0x07, 0x70,
    0xff, 0xff, 0xff, 0x7f, 0x00, 0xc7, 0x11, 0x11, 0xc1, 0x07, 0x70, 0x0b, 0x00, 0x00, 0x7b, 0x00, 0xb7, 0x00, 0x00,
    0xb0, 0x07, 0x70, 0x0b, 0x00, 0x00, 0x7b, 0x00, 0xb7, 0x00, 0x00, 0xb0, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90,
    0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09,
    0x90, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x99, 0x00, 0x90, 0x09, 0x00,
    0x99, 0x00, 0x90, 0x09, 0x00, 0x99, 0x00, 0x90, 0x09, 0x00, 0x99, 0x00, 0x90, 0x09, 0x00, 0x99, 0x00, 0x90, 0x09,
    0x00, 0x99, 0x00, 0x90, 0x09, 0x31, 0x5e, 0xf1, 0x8e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb9, 0x00,
    0x10, 0x6e, 0x90, 0x0b, 0x00, 0x7d, 0x00, 0xb9, 0x00, 0x9b, 0x00, 0x90, 0x0b, 0xb9, 0x00, 0x00, 0xb9, 0xd7, 0x00,
    0x00, 0x90, 0xee, 0x2f, 0x00, 0x00, 0xd9, 0xa1, 0x0c, 0x00, 0x90, 0x0b, 0xd0, 0x08, 0x00, 0xb9, 0x00, 0xf3, 0x03,
    0x90, 0x0b, 0x00, 0xd7, 0x00, 0xb9, 0x00, 0x00, 0xac, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x70, 0x0b, 0x00,
    0x00, 0x70, 0x0b, 0x00, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x70, 0x0b,
    0x00, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x70, 0x1c, 0x11, 0x01, 0x70, 0xff, 0xff, 0x9f, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x70, 0x9f, 0x00, 0x00, 0x00, 0xf8, 0x07, 0x70, 0xed, 0x00, 0x00, 0x00, 0xde, 0x07, 0x70, 0xd9,
    0x05, 0x00, 0x50, 0xbc, 0x07, 0x70, 0x79, 0x0c, 0x00, 0xc0, 0xb6, 0x07, 0x70, 0x19, 0x2f, 0x00, 0xf2, 0xb0, 0x07,
    0x70, 0x09, 0x8b, 0x00, 0x98, 0xb0, 0x07, 0x70, 0x09, 0xe4, 0x00, 0x3e, 0xb0, 0x07, 0x70, 0x09, 0xe0, 0x55, 0x0d,
    0xb0, 0x07, 0x70, 0x09, 0x80, 0xbb, 0x06, 0xb0, 0x07, 0x70, 0x09, 0x20, 0xff, 0x00, 0xb0, 0x07, 0x70, 0x09, 0x00,
    0xac, 0x00, 0xb0, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xf9, 0x02, 0x00, 0x90, 0x09, 0x90, 0xbf, 0x00, 0x00, 0x99, 0x00, 0x89, 0x5e, 0x00, 0x90, 0x09, 0x90, 0x68, 0x0e,
    0x00, 0x99, 0x00, 0x99, 0xc0, 0x09, 0x90, 0x09, 0x90, 0x09, 0xf3, 0x02, 0x99, 0x00, 0x99, 0x00, 0xc9, 0x90, 0x09,
    0x90, 0x09, 0x00, 0x6e, 0x99, 0x00, 0x99, 0x00, 0x50, 0x8e, 0x09, 0x90, 0x09, 0x00, 0xb0, 0x9f, 0x00, 0x99, 0x00,
    0x00, 0xf2, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xfc, 0xcf, 0x06, 0x00, 0x00,
    0xdb, 0x15, 0x51, 0xbd, 0x00, 0x60, 0x1e, 0x00, 0x00, 0xe1, 0x06, 0xc0, 0x08, 0x00, 0x00, 0x70, 0x0c, 0xf0, 0x04,
    0x00, 0x00, 0x40, 0x0f, 0xf0, 0x03, 0x00, 0x00, 0x30, 0x0f, 0xf0, 0x04, 0x00, 0x00, 0x40, 0x0f, 0xc0, 0x07, 0x00,
    0x00, 0x70, 0x0c, 0x60, 0x1e, 0x00, 0x00, 0xe1, 0x06, 0x00, 0xdb, 0x15, 0x51, 0xbd, 0x00, 0x00, 0x70, 0xfc, 0xcf,
    0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf7, 0xff, 0x9d, 0x00, 0x70, 0x1c, 0x41,
    0xcd, 0x00, 0xb7, 0x00, 0x30, 0x1f, 0x70, 0x0b, 0x00, 0xf1, 0x03, 0xb7, 0x00, 0x30, 0x1f, 0x70, 0x0b, 0x30, 0x9d,
    0x00, 0xf7, 0xff, 0x7e, 0x00, 0x70, 0x1c, 0x00, 0x00, 0x00, 0xb7, 0x00, 0x00, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x00,
    0xb7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xfc, 0xcf, 0x06, 0x00, 0x00, 0xdb, 0x15, 0x51,
    0xbd, 0x00, 0x60, 0x1e, 0x00, 0x00, 0xe1, 0x06, 0xc0, 0x08, 0x00, 0x00, 0x70, 0x0c, 0xf0, 0x04, 0x00, 0x00, 0x40,
    0x0f, 0xf0, 0x03, 0x00, 0x00, 0x30, 0x0f, 0xf0, 0x04, 0x00, 0x00, 0x40, 0x0f, 0xc0, 0x07, 0x00, 0x00, 0x70, 0x0c,
    0x60, 0x1e, 0x00, 0x00, 0xe1, 0x06, 0x00, 0xdb, 0x15, 0x51, 0xbd, 0x00, 0x00, 0x70, 0xfc, 0xff, 0x07, 0x00, 0x00,
    0x00, 0x00, 0xe2, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x10, 0xbd, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf9, 0xff, 0x9e, 0x00, 0x90, 0x1a, 0x31, 0xad, 0x00, 0x99,
    0x00, 0x50, 0x0f, 0x90, 0x09, 0x00, 0xe5, 0x00, 0x99, 0x00, 0xc2, 0x08, 0x90, 0xff, 0xff, 0x06, 0x00, 0xa9, 0x21,
    0x5e, 0x00, 0x90, 0x09, 0x70, 0x0d, 0x00, 0x99, 0x00, 0xe0, 0x06, 0x90, 0x09, 0x00, 0xe7, 0x00, 0x99, 0x00, 0x00,
    0x7e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x10, 0xea, 0xdf, 0x09, 0xc0, 0x2b, 0x41, 0x06, 0xf1, 0x02, 0x00, 0x00, 0xf0, 0x04, 0x00,
    0x00, 0x80, 0x6e, 0x00, 0x00, 0x00, 0xd5, 0x9f, 0x00, 0x00, 0x00, 0xc3, 0x0d, 0x00, 0x00, 0x10, 0x3f, 0x00, 0x00,
    0x00, 0x3f, 0x62, 0x12, 0xa2, 0x0d, 0xc1, 0xfe, 0xae, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfd, 0xff, 0xff, 0xdf, 0x11, 0xa1, 0x1a, 0x11,
    0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09,
    0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x99, 0x00, 0x00, 0x90, 0x09, 0x90, 0x09, 0x00, 0x00, 0x99, 0x00, 0x99, 0x00, 0x00, 0x90, 0x09, 0x90, 0x09,
    0x00, 0x00, 0x99, 0x00, 0x99, 0x00, 0x00, 0x90, 0x09, 0x90, 0x09, 0x00, 0x00, 0x99, 0x00, 0x99, 0x00, 0x00, 0x90,
    0x09, 0x90, 0x09, 0x00, 0x00, 0x99, 0x00, 0xd5, 0x00, 0x00, 0xd0, 0x05, 0x00, 0xad, 0x13, 0xa3, 0x0d, 0x00, 0x10,
    0xe9, 0xef, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x07, 0x00, 0x00, 0xc7, 0xd7, 0x00, 0x00,
    0xd0, 0x17, 0x2f, 0x00, 0x30, 0x1f, 0xb0, 0x08, 0x00, 0xb8, 0x00, 0xd6, 0x00, 0xd0, 0x06, 0x00, 0x3f, 0x30, 0x0f,
    0x00, 0xb0, 0x09, 0xa9, 0x00, 0x00, 0xe5, 0xe0, 0x05, 0x00, 0x00, 0x7f, 0x0e, 0x00, 0x00, 0x90, 0x9e, 0x00, 0x00,
    0x00, 0xf4, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xaa, 0x00, 0x00, 0xbd, 0x00, 0x00, 0xaa, 0xe6, 0x00,
    0x20, 0xfe, 0x00, 0x00, 0x6e, 0xf1, 0x02, 0x60, 0xcb, 0x05, 0x20, 0x1f, 0xd0, 0x06, 0xb0, 0x87, 0x0a, 0x60, 0x0d,
    0x90, 0x0a, 0xf0, 0x32, 0x0e, 0xa0, 0x09, 0x50, 0x0e, 0xd4, 0x00, 0x3e, 0xe0, 0x05, 0x10, 0x2f, 0x99, 0x00, 0x8a,
    0xf2, 0x01, 0x00, 0x6d, 0x4d, 0x00, 0xd5, 0xc6, 0x00, 0x00, 0xa8, 0x0f, 0x00, 0xf0, 0x8a, 0x00, 0x00, 0xf4, 0x0b,
    0x00, 0xb0, 0x4f, 0x00, 0x00, 0xf0, 0x07, 0x00, 0x70, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x1e, 0x00, 0x10, 0x4e, 0xa0, 0x0a, 0x00, 0xaa, 0x00, 0xe1, 0x04, 0xe4, 0x00,
    0x00, 0xd5, 0xd1, 0x04, 0x00, 0x00, 0xeb, 0x0a, 0x00, 0x00, 0x60, 0x6f, 0x00, 0x00, 0x10, 0x8e, 0x1e, 0x00, 0x00,
    0x9a, 0xa0, 0x0a, 0x00, 0xe4, 0x00, 0xe1, 0x04, 0xe0, 0x05, 0x00, 0xe6, 0x90, 0x0b, 0x00, 0x00, 0x9c, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x8b, 0x00, 0x00, 0xb7, 0xf3, 0x01, 0x00, 0x3e, 0xb0, 0x07, 0x70, 0x0b, 0x30, 0x0e, 0xe0, 0x03, 0x00, 0x7b,
    0xb7, 0x00, 0x00, 0xe3, 0x3e, 0x00, 0x00, 0xb0, 0x0b, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00,
    0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0xff, 0xff, 0xff, 0x3f, 0x10, 0x11, 0x11, 0xda, 0x00, 0x00,
    0x00, 0xf3, 0x02, 0x00, 0x00, 0xd0, 0x07, 0x00, 0x00, 0x90, 0x0c, 0x00, 0x00, 0x40, 0x2f, 0x00, 0x00, 0x00, 0x6e,
    0x00, 0x00, 0x00, 0xba, 0x00, 0x00, 0x00, 0xe5, 0x01, 0x00, 0x00, 0xe1, 0x17, 0x11, 0x11, 0x50, 0xff, 0xff, 0xff,
    0x5f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xfb, 0x9f, 0xb0, 0x07, 0x00, 0x7b, 0x00, 0xb0, 0x07, 0x00, 0x7b, 0x00, 0xb0, 0x07, 0x00, 0x7b,
    0x00, 0xb0, 0x07, 0x00, 0x7b, 0x00, 0xb0, 0x07, 0x00, 0x7b, 0x00, 0xb0, 0x07, 0x00, 0xfb, 0x9f, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xa9, 0x00, 0x00, 0xf3, 0x01, 0x00, 0xc0, 0x07, 0x00, 0x60, 0x0d, 0x00, 0x00, 0x4f,
    0x00, 0x00, 0xaa, 0x00, 0x00, 0xf3, 0x00, 0x00, 0xd0, 0x06, 0x00, 0x70, 0x0d, 0x00, 0x10, 0x3f, 0x00, 0x00, 0xaa,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0xff, 0x0b, 0x00, 0xb7,
    0x00, 0x70, 0x0b, 0x00, 0xb7, 0x00, 0x70, 0x0b, 0x00, 0xb7, 0x00, 0x70, 0x0b, 0x00, 0xb7, 0x00, 0x70, 0x0b, 0x00,
    0xb7, 0x00, 0x70, 0x0b, 0x00, 0xb7, 0x90, 0xff, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xb0, 0x06, 0x00, 0x00, 0xd2, 0x0d, 0x00, 0x00, 0x59, 0x69, 0x00, 0x10, 0x0d, 0xd1, 0x00, 0x80, 0x07, 0x90, 0x05,
    0xe0, 0x01, 0x20, 0x0d, 0xa6, 0x00, 0x00, 0x5a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xda, 0x00, 0x00, 0x00, 0x00, 0xa7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0xeb, 0xbf, 0x01, 0x10, 0x04,
    0xa0, 0x0a, 0x00, 0x00, 0x50, 0x0d, 0x20, 0xda, 0xed, 0x0d, 0xe1, 0x07, 0x50, 0x0d, 0xf5, 0x00, 0x70, 0x0d, 0xf2,
    0x04, 0xe4, 0x0d, 0x70, 0xfe, 0x4b, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xb0, 0x07, 0x00, 0x00, 0x00, 0x7b, 0x00, 0x00, 0x00, 0xb0, 0x07, 0x00, 0x00, 0x00, 0x7b,
    0x00, 0x00, 0x00, 0xb0, 0xa8, 0xef, 0x09, 0x00, 0xeb, 0x04, 0xc2, 0x09, 0xb0, 0x09, 0x00, 0xf3, 0x00, 0x7b, 0x00,
    0x10, 0x1f, 0xb0, 0x07, 0x00, 0xf1, 0x01, 0xab, 0x00, 0x40, 0x0f, 0xb0, 0x4f, 0x20, 0x9c, 0x00, 0x5b, 0xfa, 0x9e,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe7, 0xdf, 0x04, 0xd8,
    0x13, 0x13, 0xe0, 0x05, 0x00, 0x10, 0x1f, 0x00, 0x00, 0xf1, 0x01, 0x00, 0x00, 0x5f, 0x00, 0x00, 0x80, 0x3d, 0x21,
    0x02, 0x80, 0xfe, 0x3d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xb7, 0x00, 0x00, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x00, 0xb7, 0x00, 0x00, 0x00, 0x70, 0x0b, 0x00, 0xe9,
    0xaf, 0xb8, 0x00, 0xd9, 0x02, 0xf4, 0x0b, 0xf0, 0x04, 0x00, 0xba, 0x10, 0x1f, 0x00, 0x70, 0x0b, 0xf1, 0x01, 0x00,
    0xb7, 0x00, 0x4f, 0x00, 0x90, 0x0b, 0x90, 0x2c, 0x40, 0xbe, 0x00, 0x90, 0xfe, 0x6a, 0x0b, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe8, 0xbf, 0x01, 0x80, 0x1b, 0x90, 0x0c,
    0xf0, 0x02, 0x10, 0x2f, 0xf2, 0xff, 0xff, 0x3f, 0xf2, 0x01, 0x00, 0x00, 0xf0, 0x05, 0x00, 0x00, 0x80, 0x3e, 0x21,
    0x05, 0x00, 0xe8, 0xef, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xe5, 0x7f, 0x00, 0x3f, 0x00, 0x40, 0x0e, 0x00, 0x50, 0x0d, 0x00, 0xe7, 0xff, 0x0d, 0x50, 0x0d,
    0x00, 0x50, 0x0d, 0x00, 0x50, 0x0d, 0x00, 0x50, 0x0d, 0x00, 0x50, 0x0d, 0x00, 0x50, 0x0d, 0x00, 0x50, 0x0d, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0xec, 0xfe, 0x7e, 0xd0, 0x06, 0xb0, 0x07, 0xf1, 0x01,
    0x70, 0x0b, 0xe0, 0x05, 0xb0, 0x07, 0x30, 0xdf, 0x9d, 0x00, 0x60, 0x09, 0x00, 0x00, 0x90, 0x07, 0x00, 0x00, 0x50,
    0xff, 0xff, 0x0a, 0xd4, 0x12, 0x21, 0x6d, 0x7b, 0x00, 0x00, 0x7a, 0xb8, 0x00, 0x40, 0x3e, 0x90, 0xfe, 0xbe, 0x03,
    0xb0, 0x07, 0x00, 0x00, 0x00, 0x7b, 0x00, 0x00, 0x00, 0xb0, 0x07, 0x00, 0x00, 0x00, 0x7b, 0x00, 0x00, 0x00, 0xb0,
    0xa8, 0xff, 0x1a, 0x00, 0xeb, 0x04, 0xc1, 0x09, 0xb0, 0x09, 0x00, 0xb6, 0x00, 0x7b, 0x00, 0x50, 0x0d, 0xb0, 0x07,
    0x00, 0xd5, 0x00, 0x7b, 0x00, 0x50, 0x0d, 0xb0, 0x07, 0x00, 0xd5, 0x00, 0x7b, 0x00, 0x50, 0x0d, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x04,
    0xa0, 0x08, 0x00, 0x00, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90,
    0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x45, 0x00, 0x8a, 0x00, 0x00, 0x00, 0x99,
    0x00, 0x99, 0x00, 0x99, 0x00, 0x99, 0x00, 0x99, 0x00, 0x99, 0x00, 0x99, 0x00, 0x99, 0x00, 0x99, 0x00, 0x89, 0x00,
    0x6d, 0xfa, 0x0b, 0xb0, 0x07, 0x00, 0x00, 0xb0, 0x07, 0x00, 0x00, 0xb0, 0x07, 0x00, 0x00, 0xb0, 0x07, 0x00, 0x00,
    0xb0, 0x07, 0x50, 0x2e, 0xb0, 0x07, 0xe6, 0x03, 0xb0, 0x67, 0x3e, 0x00, 0xb0, 0xfc, 0x07, 0x00, 0xb0, 0x4c, 0x2e,
    0x00, 0xb0, 0x07, 0xd7, 0x00, 0xb0, 0x07, 0xb0, 0x0a, 0xb0, 0x07, 0x10, 0x7e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90,
    0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x90, 0x09, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0xb7, 0xff, 0x2a, 0xfa, 0xaf,
    0x00, 0xb0, 0x4f, 0x20, 0xfe, 0x06, 0xc1, 0x08, 0xb0, 0x0a, 0x00, 0xc9, 0x00, 0x70, 0x0b, 0xb0, 0x07, 0x00, 0x99,
    0x00, 0x70, 0x0b, 0xb0, 0x07, 0x00, 0x99, 0x00, 0x70, 0x0b, 0xb0, 0x07, 0x00, 0x99, 0x00, 0x70, 0x0b, 0xb0, 0x07,
    0x00, 0x99, 0x00, 0x70, 0x0b, 0xb0, 0x07, 0x00, 0x99, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xb0, 0xa5, 0xff, 0x1a, 0x00, 0xeb, 0x04, 0xc1, 0x09, 0xb0, 0x09, 0x00, 0xb6, 0x00, 0x7b, 0x00, 0x50, 0x0d,
    0xb0, 0x07, 0x00, 0xd5, 0x00, 0x7b, 0x00, 0x50, 0x0d, 0xb0, 0x07, 0x00, 0xd5, 0x00, 0x7b, 0x00, 0x50, 0x0d, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd7, 0xdf,
    0x07, 0x00, 0xd7, 0x03, 0xd3, 0x07, 0xe0, 0x05, 0x00, 0xe5, 0x10, 0x1f, 0x00, 0x10, 0x1f, 0xf1, 0x01, 0x00, 0xf1,
    0x01, 0x5e, 0x00, 0x50, 0x0e, 0x70, 0x3d, 0x30, 0x7d, 0x00, 0x60, 0xfd, 0x7d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0xa6, 0xef, 0x09, 0x00, 0xeb, 0x04,
    0xd2, 0x09, 0xb0, 0x09, 0x00, 0xf4, 0x00, 0x7b, 0x00, 0x10, 0x1f, 0xb0, 0x07, 0x00, 0xf1, 0x01, 0xab, 0x00, 0x40,
    0x0f, 0xb0, 0x4f, 0x20, 0x9d, 0x00, 0x8b, 0xfa, 0x9e, 0x00, 0xb0, 0x07, 0x00, 0x00, 0x00, 0x7b, 0x00, 0x00, 0x00,
    0xb0, 0x07, 0x00, 0x00, 0x00, 0x7b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe9, 0xaf, 0xb6, 0x00, 0xd9, 0x02, 0xe5, 0x0b, 0xf0, 0x04,
    0x00, 0xba, 0x10, 0x1f, 0x00, 0x70, 0x0b, 0xf1, 0x01, 0x00, 0xb7, 0x00, 0x4f, 0x00, 0xa0, 0x0b, 0x90, 0x2c, 0x40,
    0xbe, 0x00, 0x90, 0xfe, 0x8a, 0x0b, 0x00, 0x00, 0x00, 0xb7, 0x00, 0x00, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x00, 0xb7,
    0x00, 0x00, 0x00, 0x70, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x84,
    0xaf, 0xb0, 0x9c, 0x12, 0xb0, 0x0b, 0x00, 0xb0, 0x07, 0x00, 0xb0, 0x07, 0x00, 0xb0, 0x07, 0x00, 0xb0, 0x07, 0x00,
    0xb0, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0xfd, 0xae, 0x10, 0x3f, 0x10, 0x04, 0xf2, 0x02,
    0x00, 0x00, 0xf7, 0x4a, 0x00, 0x00, 0x60, 0xbd, 0x00, 0x00, 0x00, 0x4e, 0x00, 0x00, 0xf3, 0x22, 0xfd, 0xdf, 0x05,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x40, 0x07, 0x00, 0x79, 0x00, 0xfa, 0xff, 0x09, 0x7b, 0x00, 0xb0, 0x07, 0x00, 0x7b, 0x00, 0xb0, 0x07, 0x00, 0x7b,
    0x00, 0x80, 0x0c, 0x00, 0xc1, 0xaf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x05, 0x00, 0xb7,
    0x00, 0x5d, 0x00, 0x70, 0x0b, 0xd0, 0x05, 0x00, 0xb7, 0x00, 0x5d, 0x00, 0x70, 0x0b, 0xd0, 0x05, 0x00, 0xb7, 0x00,
    0x6c, 0x00, 0xa0, 0x0b, 0x90, 0x1c, 0x40, 0xbe, 0x00, 0xa1, 0xff, 0x5a, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x8c, 0x00, 0x00, 0xc8, 0xe6, 0x00, 0x00, 0x6e, 0xe0, 0x05,
    0x50, 0x0e, 0x80, 0x0b, 0xb0, 0x08, 0x20, 0x1f, 0xf1, 0x02, 0x00, 0x7c, 0xc7, 0x00, 0x00, 0xd5, 0x5d, 0x00, 0x00,
    0xe0, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x9a, 0x00, 0xc0, 0x0d, 0x00, 0xa9, 0xd6, 0x00, 0xe1, 0x2e, 0x00, 0x5d, 0xf1, 0x01,
    0xa7, 0x7a, 0x10, 0x1f, 0xd0, 0x06, 0x5c, 0xc5, 0x60, 0x0c, 0x80, 0x1a, 0x0f, 0xf0, 0xa1, 0x08, 0x40, 0x7e, 0x0a,
    0xb0, 0xe6, 0x03, 0x00, 0xdf, 0x05, 0x60, 0xed, 0x00, 0x00, 0xfb, 0x00, 0x10, 0xaf, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf2, 0x03,
    0x30, 0x2f, 0x70, 0x0d, 0xd0, 0x06, 0x00, 0x9b, 0xb9, 0x00, 0x00, 0xe1, 0x1e, 0x00, 0x00, 0xe2, 0x2e, 0x00, 0x00,
    0x7c, 0xc7, 0x00, 0x80, 0x0b, 0xb0, 0x09, 0xe4, 0x01, 0x10, 0x4e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x9c, 0x00, 0x00, 0xc8, 0xe6, 0x00, 0x00, 0x6e, 0xf0, 0x05, 0x40, 0x0f, 0x90, 0x0c,
    0xa0, 0x09, 0x30, 0x2f, 0xf0, 0x03, 0x00, 0x8d, 0xd6, 0x00, 0x00, 0xd7, 0x7b, 0x00, 0x00, 0xf1, 0x1f, 0x00, 0x00,
    0xd0, 0x0a, 0x00, 0x00, 0xf2, 0x04, 0x00, 0x10, 0xcc, 0x00, 0x00, 0xfc, 0x1b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf1, 0xff, 0xff, 0x03, 0x00, 0x60, 0x0d, 0x00, 0x20,
    0x3e, 0x00, 0x00, 0x7c, 0x00, 0x00, 0xc8, 0x00, 0x00, 0xe3, 0x01, 0x00, 0xd0, 0x06, 0x00, 0x50, 0xff, 0xff, 0x5f,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80,
    0x7e, 0x00, 0xd7, 0x02, 0x00, 0x99, 0x00, 0x00, 0x99, 0x00, 0x00, 0x99, 0x00, 0x20, 0x5d, 0x00, 0xf7, 0x07, 0x00,
    0x20, 0x5d, 0x00, 0x00, 0x99, 0x00, 0x00, 0x99, 0x00, 0x00, 0x99, 0x00, 0x00, 0xd7, 0x02, 0x00, 0x80, 0x7e, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x07, 0x00, 0x00, 0x70, 0x07, 0x00, 0x00, 0x70, 0x07, 0x00, 0x00, 0x70,
    0x07, 0x00, 0x00, 0x70, 0x07, 0x00, 0x00, 0x70, 0x07, 0x00, 0x00, 0x70, 0x07, 0x00, 0x00, 0x70, 0x07, 0x00, 0x00,
    0x70, 0x07, 0x00, 0x00, 0x70, 0x07, 0x00, 0x00, 0x70, 0x07, 0x00, 0x00, 0x70, 0x07, 0x00, 0x00, 0x70, 0x07, 0x00,
    0x00, 0x70, 0x07, 0x00, 0x00, 0x70, 0x07, 0x00, 0x00, 0x70, 0x07, 0x00, 0x00, 0x00, 0x00, 0xe7, 0x08, 0x00, 0x30,
    0x5e, 0x00, 0x00, 0x7b, 0x00, 0x00, 0x7b, 0x00, 0x00, 0x7a, 0x00, 0x00, 0xc6, 0x02, 0x00, 0x80, 0x7f, 0x00, 0xc6,
    0x02, 0x00, 0x7a, 0x00, 0x00, 0x7b, 0x00, 0x00, 0x7b, 0x00, 0x20, 0x5e, 0x00, 0xe7, 0x08, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xa0, 0xef, 0x28, 0x60, 0x33, 0x06, 0x92, 0xfe,
    0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xbe, 0xbb, 0xbb, 0x0e, 0xb0, 0x00, 0x00, 0xb0, 0x00, 0x0b, 0x00, 0x00, 0x0b, 0xb0, 0x00,
    0x00, 0xb0, 0x00, 0x0b, 0x00, 0x00, 0x0b, 0xb0, 0x00, 0x00, 0xb0, 0x00, 0x0b, 0x00, 0x00, 0x0b, 0xb0, 0x00, 0x00,
    0xb0, 0x00, 0x0b, 0x00, 0x00, 0x0b, 0xb0, 0x00, 0x00, 0xb0, 0x00, 0xbe, 0xbb, 0xbb, 0x0e, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
]
charactersOPEN_SANS_REGULAR_11_14PX = [
    FontCharacter(4, 32, 0), FontCharacter(4, 32, 32), FontCharacter(6, 48, 64), FontCharacter(10, 80, 112),
    FontCharacter(9, 72, 192), FontCharacter(12, 96, 264), FontCharacter(11, 88, 360), FontCharacter(3, 24, 448),
    FontCharacter(4, 32, 472), FontCharacter(4, 32, 504), FontCharacter(8, 64, 536), FontCharacter(9, 72, 600),
    FontCharacter(4, 32, 672), FontCharacter(5, 40, 704), FontCharacter(4, 32, 744), FontCharacter(6, 48, 776),
    FontCharacter(9, 72, 824), FontCharacter(9, 72, 896), FontCharacter(9, 72, 968), FontCharacter(9, 72, 1040),
    FontCharacter(9, 72, 1112), FontCharacter(9, 72, 1184), FontCharacter(9, 72, 1256), FontCharacter(9, 72, 1328),
    FontCharacter(9, 72, 1400), FontCharacter(9, 72, 1472), FontCharacter(4, 32, 1544), FontCharacter(4, 32, 1576),
    FontCharacter(9, 72, 1608), FontCharacter(9, 72, 1680), FontCharacter(9, 72, 1752), FontCharacter(6, 48, 1824),
    FontCharacter(13, 104, 1872), FontCharacter(10, 80, 1976), FontCharacter(10, 80, 2056), FontCharacter(9, 72, 2136),
    FontCharacter(11, 88, 2208), FontCharacter(8, 64, 2296), FontCharacter(8, 64, 2360), FontCharacter(11, 88, 2424),
    FontCharacter(11, 88, 2512), FontCharacter(4, 32, 2600), FontCharacter(5, 40, 2632), FontCharacter(9, 72, 2672),
    FontCharacter(8, 64, 2744), FontCharacter(14, 112, 2808), FontCharacter(11, 88, 2920), FontCharacter(12, 96, 3008),
    FontCharacter(9, 72, 3104), FontCharacter(12, 96, 3176), FontCharacter(9, 72, 3272), FontCharacter(8, 64, 3344),
    FontCharacter(8, 64, 3408), FontCharacter(11, 88, 3472), FontCharacter(9, 72, 3560), FontCharacter(14, 112, 3632),
    FontCharacter(9, 72, 3744), FontCharacter(8, 64, 3816), FontCharacter(9, 72, 3880), FontCharacter(5, 40, 3952),
    FontCharacter(6, 48, 3992), FontCharacter(5, 40, 4040), FontCharacter(8, 64, 4080), FontCharacter(7, 56, 4144),
    FontCharacter(9, 72, 4200), FontCharacter(8, 64, 4272), FontCharacter(9, 72, 4336), FontCharacter(7, 56, 4408),
    FontCharacter(9, 72, 4464), FontCharacter(8, 64, 4536), FontCharacter(6, 48, 4600), FontCharacter(8, 64, 4648),
    FontCharacter(9, 72, 4712), FontCharacter(4, 32, 4784), FontCharacter(4, 32, 4816), FontCharacter(8, 64, 4848),
    FontCharacter(4, 32, 4912), FontCharacter(14, 112, 4944), FontCharacter(9, 72, 5056), FontCharacter(9, 72, 5128),
    FontCharacter(9, 72, 5200), FontCharacter(9, 72, 5272), FontCharacter(6, 48, 5344), FontCharacter(7, 56, 5392),
    FontCharacter(5, 40, 5448), FontCharacter(9, 72, 5488), FontCharacter(8, 64, 5560), FontCharacter(12, 96, 5624),
    FontCharacter(8, 64, 5720), FontCharacter(8, 64, 5784), FontCharacter(7, 56, 5848), FontCharacter(6, 48, 5904),
    FontCharacter(8, 64, 5952), FontCharacter(6, 48, 6016), FontCharacter(9, 72, 6064), FontCharacter(9, 72, 6136)
]

bitmapSYMBOLS_0 = [
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x51, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xff, 0x4c, 0x00, 0x10, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xcf, 0x00, 0x71, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0xf6, 0xff, 0xff, 0x8d, 0xff, 0xbf,
    0xfa, 0xff, 0xff, 0x50, 0xff, 0xff, 0xff, 0x14, 0xf7, 0x2b, 0xe2, 0xff, 0xff, 0xf5, 0xff, 0xff, 0xff, 0x3c, 0x51,
    0x12, 0xf9, 0xff, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xcf, 0x03, 0x91, 0xff, 0xff, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xcf,
    0x03, 0x91, 0xff, 0xff, 0xff, 0xf5, 0xff, 0xff, 0xff, 0x3c, 0x51, 0x12, 0xf9, 0xff, 0xff, 0x50, 0xff, 0xff, 0xff,
    0x14, 0xf7, 0x2b, 0xe2, 0xff, 0xff, 0x00, 0xf6, 0xff, 0xff, 0x8d, 0xff, 0xbf, 0xfa, 0xff, 0xff, 0x00, 0x71, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x10, 0xf7, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xcf, 0x00, 0x00,
    0x51, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xff, 0x4c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x84, 0xcc, 0x48, 0x00, 0x40, 0xcc, 0xcc, 0xcc, 0x04,
    0xc4, 0xcc, 0xcc, 0xcc, 0x4c, 0xc8, 0xcc, 0xcc, 0xcc, 0x8c, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc,
    0xcc, 0xc8, 0xcc, 0xcc, 0xcc, 0x8c, 0xc4, 0xcc, 0xcc, 0xcc, 0x4c, 0x40, 0xcc, 0xcc, 0xcc, 0x04, 0x00, 0x84, 0xcc,
    0x48, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00,
    0x70, 0x4e, 0x00, 0x00, 0x70, 0xff, 0x0a, 0x00, 0x70, 0xff, 0x1d, 0x00, 0x70, 0xff, 0x1d, 0x00, 0x70, 0xff, 0x1d,
    0x00, 0x70, 0xff, 0x1d, 0x00, 0x60, 0xff, 0x1d, 0x00, 0x00, 0xfb, 0x9f, 0x00, 0x00, 0x10, 0xfc, 0x8f, 0x00, 0x00,
    0x10, 0xfc, 0x8f, 0x00, 0x00, 0x10, 0xfc, 0x8f, 0x00, 0x00, 0x10, 0xfc, 0x8f, 0x00, 0x00, 0x10, 0xfc, 0x6f, 0x00,
    0x00, 0x10, 0xec, 0x05, 0x00, 0x00, 0x10, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x24, 0x00, 0x00, 0xb3, 0x00, 0x00, 0xe2,
    0x07, 0x00, 0xd2, 0x5f, 0x00, 0xc1, 0xff, 0xbd, 0x66, 0x98, 0xff, 0x19, 0x00, 0xf5, 0x1a, 0x00, 0x80, 0x1c, 0x00,
    0x00, 0x2b, 0x00, 0x00, 0x33, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe6, 0x07, 0x00, 0x90, 0x7f, 0x00, 0x00,
    0xf8, 0x07, 0x00, 0xa0, 0x5f, 0x00, 0xc1, 0x2d, 0x10, 0xdc, 0x03, 0xc1, 0x3d, 0x00, 0xb4, 0x03, 0x00, 0x00, 0x85,
    0xcb, 0xff, 0xff, 0xbc, 0x58, 0x00, 0x70, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xef, 0x07, 0xe5, 0x9f, 0x46, 0x01, 0x10,
    0x64, 0xf9, 0x5e, 0xf8, 0x29, 0x00, 0x00, 0x00, 0x00, 0x92, 0x8f, 0xfa, 0x06, 0x00, 0x00, 0x00, 0x00, 0x60, 0xbf,
    0xfd, 0x04, 0x00, 0x00, 0x00, 0x00, 0x40, 0xdf, 0xff, 0x01, 0x00, 0x00, 0x00, 0x00, 0x10, 0xff, 0xff, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x01, 0x00, 0x00, 0x00, 0x00,
    0x10, 0xff, 0xfd, 0x04, 0x00, 0x00, 0x00, 0x00, 0x40, 0xdf, 0xfa, 0x06, 0x00, 0x00, 0x00, 0x00, 0x60, 0xbf, 0xf8,
    0x29, 0x00, 0x00, 0x00, 0x00, 0x92, 0x8f, 0xe5, 0x9f, 0x36, 0x01, 0x10, 0x63, 0xf9, 0x5e, 0x70, 0xfe, 0xff, 0xff,
    0xff, 0xff, 0xef, 0x07, 0x00, 0x85, 0xdb, 0xff, 0xff, 0xbd, 0x58, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0xf0, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0x0f, 0xf0, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0xf0, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0xf0, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f,
    0xf0, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x0f, 0xf0, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
]
charactersSYMBOLS_0 = [
    FontCharacter(20, 160, 0), FontCharacter(10, 80, 160), FontCharacter(9, 72, 240), FontCharacter(7, 56, 312),
    FontCharacter(6, 48, 368), FontCharacter(16, 128, 416), FontCharacter(16, 128, 544)
]

bitmapOPEN_SANS_SEMIBOLD_11_16PX = [
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x0f, 0xd0, 0x0f,
    0xd0, 0x0e, 0xc0, 0x0d, 0xb0, 0x0d, 0xb0, 0x0c, 0x90, 0x0b, 0x90, 0x0b, 0x10, 0x01, 0xe0, 0x0f, 0xc0, 0x0d, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xbe, 0xa0, 0x0e, 0xd0, 0x09, 0xd9, 0x00, 0x8b,
    0x80, 0x0b, 0xa0, 0x07, 0xa7, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x0f, 0xf0, 0x03, 0x00, 0x70, 0x0c,
    0xf3, 0x00, 0x00, 0xb0, 0x08, 0xc6, 0x00, 0xf0, 0xff, 0xff, 0xff, 0x9f, 0x30, 0xf4, 0x35, 0x8e, 0x23, 0x00, 0xf3,
    0x00, 0x4f, 0x00, 0x00, 0xd6, 0x20, 0x1f, 0x00, 0xf9, 0xff, 0xff, 0xff, 0x1f, 0x32, 0x9d, 0xa3, 0x3b, 0x03, 0x00,
    0x4f, 0xc0, 0x07, 0x00, 0x30, 0x0f, 0xf0, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0xf0, 0x00, 0x00,
    0x10, 0xe9, 0xff, 0x7c, 0x00, 0xed, 0xf8, 0xa7, 0x08, 0xf0, 0x0a, 0x0f, 0x00, 0x00, 0xfc, 0xfa, 0x00, 0x00, 0x00,
    0xf9, 0xef, 0x08, 0x00, 0x00, 0xf0, 0xfb, 0x0d, 0x00, 0x00, 0x0f, 0xf8, 0x11, 0x8d, 0xf5, 0xe8, 0x0d, 0xa0, 0xfd,
    0xdf, 0x19, 0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe6, 0x5e, 0x00, 0x70, 0x0d, 0x00,
    0xf1, 0x88, 0x0f, 0x10, 0x5e, 0x00, 0x40, 0x1f, 0xf1, 0x04, 0xc9, 0x00, 0x00, 0xf5, 0x01, 0x5f, 0xf1, 0x04, 0x00,
    0x40, 0x1f, 0xf1, 0xa4, 0x6b, 0xee, 0x05, 0xf0, 0x88, 0x4f, 0x4f, 0x8f, 0xf8, 0x00, 0xe5, 0x5e, 0xab, 0xf4, 0x11,
    0x4f, 0x00, 0x00, 0xf4, 0x51, 0x0f, 0xf0, 0x05, 0x00, 0xd0, 0x08, 0xf4, 0x11, 0x4f, 0x00, 0x50, 0x1e, 0x00, 0x8f,
    0xf8, 0x00, 0x00, 0x7e, 0x00, 0x50, 0xee, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x50, 0xfd, 0x5d, 0x00, 0x00, 0x20, 0xcf, 0xc5, 0x1f, 0x00, 0x00, 0xf5, 0x04, 0xf5, 0x03, 0x00, 0x10,
    0x9f, 0xc0, 0x0e, 0x00, 0x00, 0x80, 0xef, 0x4e, 0x00, 0x00, 0x10, 0xfb, 0x6f, 0x00, 0x93, 0x03, 0xfc, 0xa5, 0x6f,
    0xa0, 0x1f, 0xf3, 0x09, 0xa0, 0x8f, 0xaf, 0x30, 0x9f, 0x00, 0xa0, 0xef, 0x01, 0xd0, 0xaf, 0x97, 0xfe, 0x6f, 0x00,
    0xa1, 0xfe, 0x8d, 0xa1, 0x6f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x0b, 0xc0, 0x09, 0xb0, 0x09, 0xa0, 0x07, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x2f, 0x10, 0x7e, 0x00, 0xf8, 0x00, 0xe0, 0x0a, 0x20, 0x6f, 0x00, 0xf4, 0x04,
    0x50, 0x3f, 0x00, 0xf5, 0x03, 0x20, 0x6f, 0x00, 0xe0, 0x0a, 0x00, 0xf9, 0x00, 0x10, 0x7f, 0x00, 0x50, 0x2f, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x5f, 0x00, 0x70, 0x1e, 0x00, 0xf0, 0x08, 0x00, 0xea, 0x00, 0x60, 0x2f,
    0x00, 0xf4, 0x04, 0x30, 0x5f, 0x00, 0xf3, 0x05, 0x60, 0x2f, 0x00, 0xea, 0x00, 0xf0, 0x09, 0x70, 0x1f, 0x20, 0x5f,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x0b, 0x00, 0x00, 0xa0, 0x09, 0x00, 0xb4, 0xa6, 0x69, 0x4b, 0xb4,
    0xfd, 0xcf, 0x3b, 0x00, 0xe5, 0x4f, 0x00, 0x10, 0x8e, 0xe8, 0x01, 0x20, 0x1b, 0xc1, 0x02, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf3, 0x01, 0x00, 0x00, 0x30, 0x1f, 0x00, 0x00, 0x00, 0xf3,
    0x01, 0x00, 0xf3, 0xff, 0xff, 0xff, 0x03, 0x33, 0xf6, 0x35, 0x03, 0x00, 0x30, 0x1f, 0x00, 0x00, 0x00, 0xf3, 0x01,
    0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x0e, 0xf0, 0x09, 0xf2, 0x04, 0xe6, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x70, 0xff, 0x7f, 0x73, 0x77, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x10, 0x01, 0xe0, 0x0f, 0xc0, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xae, 0x00, 0x40, 0x4f, 0x00, 0xa0, 0x0e, 0x00, 0xf0, 0x08, 0x00, 0xf6, 0x02, 0x00, 0xcc,
    0x00, 0x20, 0x6f, 0x00, 0x80, 0x0f, 0x00, 0xe0, 0x0a, 0x00, 0xf4, 0x04, 0x00, 0xea, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xfd, 0x6d, 0x00, 0x70,
    0xbf, 0xb7, 0x6f, 0x00, 0xde, 0x00, 0xd0, 0x0d, 0xf2, 0x08, 0x00, 0xf8, 0x32, 0x7f, 0x00, 0x60, 0x3f, 0xf5, 0x05,
    0x00, 0xf5, 0x35, 0x7f, 0x00, 0x60, 0x4f, 0xf2, 0x08, 0x00, 0xf8, 0x02, 0xdd, 0x00, 0xd0, 0x0e, 0x60, 0xbf, 0xb7,
    0x7f, 0x00, 0x60, 0xfd, 0x7d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe3, 0x0f, 0x00, 0x00, 0xf5, 0xff, 0x00, 0x00,
    0xf5, 0xb9, 0x0f, 0x00, 0x00, 0x05, 0xfb, 0x00, 0x00, 0x00, 0xb0, 0x0f, 0x00, 0x00, 0x00, 0xfb, 0x00, 0x00, 0x00,
    0xb0, 0x0f, 0x00, 0x00, 0x00, 0xfb, 0x00, 0x00, 0x00, 0xb0, 0x0f, 0x00, 0x00, 0x00, 0xfb, 0x00, 0x00, 0x00, 0xb0,
    0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x92, 0xfe, 0x8d, 0x00, 0xe0, 0x9e, 0xb7, 0x8f, 0x00, 0x03, 0x00, 0xd0, 0x0d,
    0x00, 0x00, 0x00, 0xdd, 0x00, 0x00, 0x00, 0xf3, 0x08, 0x00, 0x00, 0xe1, 0x0d, 0x00, 0x00, 0xd1, 0x2e, 0x00, 0x00,
    0xd2, 0x1d, 0x00, 0x00, 0xe2, 0x0b, 0x00, 0x00, 0xe1, 0x8f, 0x77, 0x77, 0x52, 0xff, 0xff, 0xff, 0x5f, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xb5, 0xfe, 0x8d, 0x00, 0xe0, 0x8c, 0xb7, 0x8f, 0x00, 0x01, 0x00, 0xe0, 0x0d, 0x00, 0x00, 0x00, 0xce,
    0x00, 0x00, 0x10, 0xf8, 0x05, 0x00, 0xf9, 0xef, 0x05, 0x00, 0x30, 0x75, 0xfa, 0x09, 0x00, 0x00, 0x00, 0xfa, 0x02,
    0x00, 0x00, 0xb0, 0x2f, 0xb5, 0x58, 0xb6, 0xbf, 0x20, 0xeb, 0xff, 0x7c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xfd, 0x01, 0x00, 0x00, 0xfa, 0x1f, 0x00, 0x00, 0xf5, 0xfa, 0x01, 0x00, 0xe1, 0x77, 0x1f, 0x00, 0xc0, 0x0b, 0xf9,
    0x01, 0x80, 0x1e, 0x90, 0x1f, 0x30, 0x4f, 0x00, 0xf9, 0x01, 0xfb, 0xff, 0xff, 0xff, 0x4b, 0x55, 0x55, 0xfb, 0x46,
    0x00, 0x00, 0x90, 0x1f, 0x00, 0x00, 0x00, 0xf9, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf7, 0xff, 0xff, 0x05, 0x80, 0x7f,
    0x77, 0x27, 0x00, 0xf9, 0x00, 0x00, 0x00, 0xb0, 0x0d, 0x00, 0x00, 0x00, 0xfc, 0xfe, 0x8e, 0x00, 0x60, 0x78, 0xc7,
    0xbf, 0x00, 0x00, 0x00, 0xc0, 0x1f, 0x00, 0x00, 0x00, 0xf9, 0x02, 0x00, 0x00, 0xc0, 0x0f, 0xd1, 0x79, 0xc7, 0x7f,
    0x00, 0xea, 0xff, 0x6c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc7, 0xff, 0x06, 0x00, 0xfc, 0x6a, 0x36, 0x00, 0xf8,
    0x03, 0x00, 0x00, 0xe0, 0x0a, 0x00, 0x00, 0x20, 0x7f, 0xe9, 0xbf, 0x02, 0xf3, 0xae, 0x75, 0xde, 0x30, 0xaf, 0x00,
    0x70, 0x4f, 0xf2, 0x07, 0x00, 0xf5, 0x05, 0xce, 0x00, 0x80, 0x3f, 0x50, 0xbf, 0x96, 0xcf, 0x00, 0x50, 0xfd, 0x9e,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x70, 0xff, 0xff, 0xff, 0x5f, 0x73, 0x77, 0x77, 0xfc, 0x03, 0x00, 0x00, 0xe0, 0x0b, 0x00,
    0x00, 0x60, 0x4f, 0x00, 0x00, 0x00, 0xde, 0x00, 0x00, 0x00, 0xf5, 0x05, 0x00, 0x00, 0xd0, 0x0e, 0x00, 0x00, 0x50,
    0x6f, 0x00, 0x00, 0x00, 0xec, 0x00, 0x00, 0x00, 0xf4, 0x07, 0x00, 0x00, 0xc0, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x91, 0xfe, 0x9e, 0x01, 0xb0, 0x8f, 0x85, 0xbf, 0x00, 0xef, 0x00, 0xe0, 0x0e, 0x90, 0x8f, 0x71, 0x8f, 0x00,
    0x90, 0xff, 0x7f, 0x00, 0x30, 0xde, 0xf9, 0x3e, 0x00, 0xee, 0x01, 0xe3, 0x0e, 0xf4, 0x08, 0x00, 0xf8, 0x34, 0x9f,
    0x00, 0xa0, 0x3f, 0xd0, 0x7f, 0x85, 0xcf, 0x00, 0x91, 0xfe, 0x9e, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0xfe, 0x5d,
    0x00, 0xb0, 0x9f, 0xb6, 0x6f, 0x20, 0x9f, 0x00, 0xc0, 0x0e, 0xf5, 0x05, 0x00, 0xf6, 0x32, 0x7f, 0x00, 0x90, 0x3f,
    0xd0, 0x8e, 0x95, 0xfe, 0x03, 0xb2, 0xef, 0x7a, 0x2f, 0x00, 0x00, 0x00, 0xea, 0x00, 0x00, 0x00, 0xf3, 0x08, 0x30,
    0x65, 0xf9, 0x0d, 0x00, 0xf7, 0xcf, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x0d, 0xe0, 0x0f,
    0x10, 0x01, 0x00, 0x00, 0x00, 0x00, 0x10, 0x01, 0xe0, 0x0f, 0xc0, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x0d, 0xe0, 0x0f, 0x10, 0x01, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xe0, 0x0d, 0xf0, 0x09, 0xf3, 0x03, 0xd6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x91, 0x03, 0x00, 0x10, 0xf9, 0x1d, 0x00, 0x91, 0xcf, 0x04, 0x00, 0xf9,
    0x3a, 0x00, 0x00, 0xf2, 0x6e, 0x00, 0x00, 0x00, 0x60, 0xfd, 0x39, 0x00, 0x00, 0x00, 0xc5, 0xcf, 0x01, 0x00, 0x00,
    0x30, 0x3a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf3, 0xff, 0xff, 0xff, 0x13, 0x55, 0x55, 0x55, 0x15, 0x30,
    0x33, 0x33, 0x33, 0x30, 0xff, 0xff, 0xff, 0x3f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x93, 0x01, 0x00, 0x00,
    0x10, 0xfd, 0x19, 0x00, 0x00, 0x00, 0xc4, 0x9f, 0x01, 0x00, 0x00, 0x30, 0xfa, 0x09, 0x00, 0x00, 0x60, 0xfe, 0x02,
    0x30, 0xf9, 0x6d, 0x00, 0xc1, 0xcf, 0x05, 0x00, 0x30, 0x3a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0xeb, 0xdf, 0x06, 0xc8, 0x78, 0xfc, 0x04, 0x00, 0x10, 0x9f, 0x00, 0x00, 0xf2,
    0x08, 0x00, 0xd1, 0x1e, 0x00, 0xe2, 0x2d, 0x00, 0xa0, 0x1d, 0x00, 0x00, 0x9d, 0x00, 0x00, 0x20, 0x01, 0x00, 0x10,
    0xef, 0x00, 0x00, 0xd0, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x81, 0xfd, 0xcf, 0x06, 0x00, 0x00, 0xe3, 0x5b, 0x22, 0xd6,
    0x0b, 0x00, 0xe1, 0x07, 0x00, 0x00, 0xd1, 0x08, 0x90, 0x0b, 0xb2, 0xff, 0x0c, 0xe6, 0x00, 0x5e, 0xe0, 0x2a, 0xf5,
    0x11, 0x1f, 0xf2, 0x52, 0x0f, 0x40, 0x0f, 0xf1, 0x33, 0x1f, 0xf5, 0x00, 0xf6, 0x20, 0x0f, 0xf2, 0x32, 0x6f, 0xc2,
    0x3f, 0xb9, 0x00, 0x6e, 0x70, 0xee, 0x77, 0xcf, 0x01, 0x80, 0x2e, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x7e, 0x23,
    0x74, 0x07, 0x00, 0x00, 0x60, 0xfc, 0xef, 0x4b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0xff, 0x01,
    0x00, 0x00, 0x70, 0xff, 0x07, 0x00, 0x00, 0xd0, 0xab, 0x0d, 0x00, 0x00, 0xf3, 0x45, 0x3f, 0x00, 0x00, 0xe9, 0x00,
    0x9e, 0x00, 0x00, 0x9e, 0x00, 0xe9, 0x00, 0x50, 0xff, 0xff, 0xff, 0x05, 0xb0, 0x7e, 0x77, 0xe7, 0x0b, 0xf1, 0x09,
    0x00, 0x90, 0x1f, 0xf6, 0x04, 0x00, 0x40, 0x6f, 0xfc, 0x00, 0x00, 0x00, 0xcf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x90, 0xff, 0xff, 0x7c, 0x00, 0x90, 0x9f, 0x87, 0xfd, 0x07, 0x90, 0x3f, 0x00, 0xf1, 0x0c, 0x90, 0x3f, 0x00, 0xf0,
    0x0c, 0x90, 0x3f, 0x00, 0xf7, 0x07, 0x90, 0xff, 0xff, 0x8f, 0x00, 0x90, 0x8f, 0x65, 0xfa, 0x09, 0x90, 0x3f, 0x00,
    0xb0, 0x1f, 0x90, 0x3f, 0x00, 0xc0, 0x1f, 0x90, 0x9f, 0x77, 0xfb, 0x0c, 0x90, 0xff, 0xff, 0x9d, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0xeb, 0xef, 0x2a, 0x00, 0xf9, 0x8e, 0xa7, 0x1e, 0x50, 0xbf, 0x00, 0x00, 0x00,
    0xb0, 0x2f, 0x00, 0x00, 0x00, 0xf0, 0x0d, 0x00, 0x00, 0x00, 0xf0, 0x0b, 0x00, 0x00, 0x00, 0xf0, 0x0d, 0x00, 0x00,
    0x00, 0xc0, 0x1f, 0x00, 0x00, 0x00, 0x60, 0xaf, 0x00, 0x00, 0x00, 0x00, 0xfb, 0x8d, 0x97, 0x1d, 0x00, 0x70, 0xfc,
    0xef, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf9, 0xff, 0xcf, 0x06, 0x00, 0x90, 0x8f, 0x87, 0xfc, 0x0b,
    0x00, 0xf9, 0x01, 0x00, 0xf9, 0x07, 0x90, 0x1f, 0x00, 0x00, 0xdf, 0x00, 0xf9, 0x01, 0x00, 0xc0, 0x0f, 0x90, 0x1f,
    0x00, 0x00, 0xfb, 0x01, 0xf9, 0x01, 0x00, 0xc0, 0x0f, 0x90, 0x1f, 0x00, 0x10, 0xdf, 0x00, 0xf9, 0x01, 0x00, 0xfa,
    0x06, 0x90, 0x8f, 0x87, 0xfd, 0x0a, 0x00, 0xf9, 0xff, 0xbe, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x90, 0xff, 0xff, 0x1f, 0x90, 0x8f, 0x77, 0x07, 0x90, 0x1f, 0x00, 0x00, 0x90, 0x1f, 0x00, 0x00, 0x90, 0x1f, 0x00,
    0x00, 0x90, 0xff, 0xff, 0x0d, 0x90, 0x8f, 0x77, 0x06, 0x90, 0x1f, 0x00, 0x00, 0x90, 0x1f, 0x00, 0x00, 0x90, 0x8f,
    0x77, 0x07, 0x90, 0xff, 0xff, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0xff, 0xff, 0x7f, 0x90, 0x8f, 0x77, 0x37, 0x90, 0x1f, 0x00, 0x00,
    0x90, 0x1f, 0x00, 0x00, 0x90, 0x1f, 0x00, 0x00, 0x90, 0xff, 0xff, 0x3f, 0x90, 0x8f, 0x77, 0x17, 0x90, 0x1f, 0x00,
    0x00, 0x90, 0x1f, 0x00, 0x00, 0x90, 0x1f, 0x00, 0x00, 0x90, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb4, 0xfe,
    0xce, 0x05, 0x00, 0xf9, 0x9e, 0x87, 0x5d, 0x00, 0xf6, 0x0b, 0x00, 0x00, 0x00, 0xc0, 0x1f, 0x00, 0x00, 0x00, 0x00,
    0xcf, 0x00, 0x00, 0x00, 0x00, 0xf1, 0x0b, 0x10, 0xff, 0xdf, 0x00, 0xcf, 0x00, 0x70, 0xe7, 0x0d, 0xd0, 0x0f, 0x00,
    0x00, 0xdd, 0x00, 0xf7, 0x0a, 0x00, 0xd0, 0x0d, 0x00, 0xfb, 0x8d, 0x87, 0xdf, 0x00, 0x00, 0xc7, 0xff, 0xbe, 0x07,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf9, 0x01, 0x00, 0xf1, 0x09, 0x90, 0x1f, 0x00, 0x10, 0x9f,
    0x00, 0xf9, 0x01, 0x00, 0xf1, 0x09, 0x90, 0x1f, 0x00, 0x10, 0x9f, 0x00, 0xf9, 0xff, 0xff, 0xff, 0x09, 0x90, 0x8f,
    0x77, 0x87, 0x9f, 0x00, 0xf9, 0x01, 0x00, 0xf1, 0x09, 0x90, 0x1f, 0x00, 0x10, 0x9f, 0x00, 0xf9, 0x01, 0x00, 0xf1,
    0x09, 0x90, 0x1f, 0x00, 0x10, 0x9f, 0x00, 0xf9, 0x01, 0x00, 0xf1, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf7,
    0x05, 0x70, 0x5f, 0x00, 0xf7, 0x05, 0x70, 0x5f, 0x00, 0xf7, 0x05, 0x70, 0x5f, 0x00, 0xf7, 0x05, 0x70, 0x5f, 0x00,
    0xf7, 0x05, 0x70, 0x5f, 0x00, 0xf7, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xfb, 0x00, 0xb0, 0x0f, 0x00, 0xfb, 0x00, 0xb0, 0x0f, 0x00, 0xfb, 0x00, 0xb0, 0x0f, 0x00, 0xfb, 0x00,
    0xb0, 0x0f, 0x00, 0xfb, 0x00, 0xb0, 0x0f, 0x00, 0xfb, 0x00, 0xe0, 0x2e, 0xa7, 0x8f, 0xf3, 0x9e, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x3f, 0x00, 0x80, 0x6f, 0x70, 0x3f, 0x00, 0xf6, 0x09, 0x70, 0x3f, 0x40, 0xaf,
    0x00, 0x70, 0x3f, 0xf3, 0x0c, 0x00, 0x70, 0x6f, 0xde, 0x01, 0x00, 0x70, 0xff, 0xff, 0x02, 0x00, 0x70, 0xaf, 0xf5,
    0x0c, 0x00, 0x70, 0x3f, 0x80, 0x8f, 0x00, 0x70, 0x3f, 0x00, 0xfc, 0x03, 0x70, 0x3f, 0x00, 0xe2, 0x0d, 0x70, 0x3f,
    0x00, 0x50, 0xaf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0x1f, 0x00, 0x00, 0x90, 0x1f, 0x00, 0x00, 0x90, 0x1f, 0x00,
    0x00, 0x90, 0x1f, 0x00, 0x00, 0x90, 0x1f, 0x00, 0x00, 0x90, 0x1f, 0x00, 0x00, 0x90, 0x1f, 0x00, 0x00, 0x90, 0x1f,
    0x00, 0x00, 0x90, 0x1f, 0x00, 0x00, 0x90, 0x8f, 0x77, 0x47, 0x90, 0xff, 0xff, 0x9f, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90,
    0xff, 0x00, 0x00, 0x00, 0xff, 0x09, 0x90, 0xff, 0x06, 0x00, 0x60, 0xff, 0x09, 0x90, 0xce, 0x0b, 0x00, 0xc0, 0xfa,
    0x09, 0x90, 0x7f, 0x1f, 0x00, 0xf1, 0xf6, 0x09, 0x90, 0x1f, 0x6f, 0x00, 0xe7, 0xf2, 0x09, 0x90, 0x0f, 0xcb, 0x00,
    0x9d, 0xf1, 0x09, 0x90, 0x0f, 0xf6, 0x31, 0x3f, 0xf1, 0x09, 0x90, 0x0f, 0xf1, 0x87, 0x0e, 0xf1, 0x09, 0x90, 0x0f,
    0xb0, 0xed, 0x08, 0xf1, 0x09, 0x90, 0x0f, 0x50, 0xff, 0x02, 0xf1, 0x09, 0x90, 0x0f, 0x00, 0xdf, 0x00, 0xf1, 0x09,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0xdf, 0x00, 0x00,
    0xf0, 0x09, 0x90, 0xff, 0x07, 0x00, 0xf0, 0x09, 0x90, 0xde, 0x2f, 0x00, 0xf0, 0x09, 0x90, 0x3f, 0xbf, 0x00, 0xf0,
    0x09, 0x90, 0x0f, 0xf9, 0x05, 0xf0, 0x09, 0x90, 0x0f, 0xe0, 0x0e, 0xf0, 0x09, 0x90, 0x0f, 0x50, 0x9f, 0xf0, 0x09,
    0x90, 0x0f, 0x00, 0xfb, 0xf3, 0x09, 0x90, 0x0f, 0x00, 0xf2, 0xfd, 0x09, 0x90, 0x0f, 0x00, 0x70, 0xff, 0x09, 0x90,
    0x0f, 0x00, 0x00, 0xfd, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xfc,
    0xcf, 0x07, 0x00, 0x00, 0xfb, 0x8c, 0xc8, 0xbf, 0x00, 0x70, 0x9f, 0x00, 0x00, 0xf9, 0x07, 0xd0, 0x0f, 0x00, 0x00,
    0xf0, 0x0d, 0xf0, 0x0c, 0x00, 0x00, 0xc0, 0x0f, 0xf1, 0x0b, 0x00, 0x00, 0xb0, 0x1f, 0xf0, 0x0c, 0x00, 0x00, 0xc0,
    0x0f, 0xd0, 0x0f, 0x00, 0x00, 0xf0, 0x0d, 0x70, 0x9f, 0x00, 0x00, 0xf9, 0x07, 0x00, 0xfb, 0x8c, 0xc8, 0xbf, 0x00,
    0x00, 0x70, 0xfc, 0xcf, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf9, 0xff, 0xae,
    0x01, 0x90, 0x8f, 0xa7, 0xdf, 0x00, 0xf9, 0x01, 0x90, 0x3f, 0x90, 0x1f, 0x00, 0xf8, 0x03, 0xf9, 0x01, 0xe3, 0x0f,
    0x90, 0xff, 0xff, 0x4f, 0x00, 0xf9, 0x78, 0x05, 0x00, 0x90, 0x1f, 0x00, 0x00, 0x00, 0xf9, 0x01, 0x00, 0x00, 0x90,
    0x1f, 0x00, 0x00, 0x00, 0xf9, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xfc, 0xcf, 0x07, 0x00,
    0x00, 0xfb, 0x8c, 0xc8, 0xbf, 0x00, 0x70, 0x9f, 0x00, 0x00, 0xf9, 0x07, 0xd0, 0x0f, 0x00, 0x00, 0xf0, 0x0d, 0xf0,
    0x0c, 0x00, 0x00, 0xc0, 0x0f, 0xf1, 0x0b, 0x00, 0x00, 0xb0, 0x1f, 0xf0, 0x0c, 0x00, 0x00, 0xc0, 0x0f, 0xd0, 0x0f,
    0x00, 0x00, 0xf0, 0x0d, 0x70, 0x9f, 0x00, 0x00, 0xf9, 0x06, 0x00, 0xfb, 0x8c, 0xc8, 0xbf, 0x00, 0x00, 0x70, 0xfc,
    0xff, 0x08, 0x00, 0x00, 0x00, 0x00, 0xe3, 0x2e, 0x00, 0x00, 0x00, 0x00, 0x30, 0xee, 0x03, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0xff, 0xff, 0x6c, 0x00, 0x70,
    0x9f, 0x87, 0xfe, 0x06, 0x70, 0x3f, 0x00, 0xf1, 0x0c, 0x70, 0x3f, 0x00, 0xe0, 0x0d, 0x70, 0x3f, 0x00, 0xf7, 0x08,
    0x70, 0xff, 0xff, 0x8f, 0x00, 0x70, 0x9f, 0xd7, 0x0d, 0x00, 0x70, 0x3f, 0x30, 0x9f, 0x00, 0x70, 0x3f, 0x00, 0xfa,
    0x03, 0x70, 0x3f, 0x00, 0xe1, 0x0d, 0x70, 0x3f, 0x00, 0x60, 0x8f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0xea, 0xdf,
    0x09, 0xc0, 0x9f, 0xa7, 0x0d, 0xf1, 0x0a, 0x00, 0x00, 0xf1, 0x0b, 0x00, 0x00, 0xb0, 0xbf, 0x03, 0x00, 0x00, 0xf9,
    0xcf, 0x02, 0x00, 0x10, 0xf8, 0x0e, 0x00, 0x00, 0x70, 0x4f, 0x00, 0x00, 0x70, 0x4f, 0xd3, 0x79, 0xe8, 0x0d, 0xb1,
    0xfe, 0xae, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xfb, 0xff, 0xff, 0xbf, 0x75, 0xe7, 0x7e, 0x57, 0x00, 0xd0, 0x0d, 0x00, 0x00, 0xd0, 0x0d,
    0x00, 0x00, 0xd0, 0x0d, 0x00, 0x00, 0xd0, 0x0d, 0x00, 0x00, 0xd0, 0x0d, 0x00, 0x00, 0xd0, 0x0d, 0x00, 0x00, 0xd0,
    0x0d, 0x00, 0x00, 0xd0, 0x0d, 0x00, 0x00, 0xd0, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfb, 0x01, 0x00, 0xf1, 0x0b, 0xb0,
    0x1f, 0x00, 0x10, 0xbf, 0x00, 0xfb, 0x01, 0x00, 0xf1, 0x0b, 0xb0, 0x1f, 0x00, 0x10, 0xbf, 0x00, 0xfb, 0x01, 0x00,
    0xf1, 0x0b, 0xb0, 0x1f, 0x00, 0x10, 0xbf, 0x00, 0xfb, 0x01, 0x00, 0xf1, 0x0b, 0xa0, 0x1f, 0x00, 0x10, 0x9f, 0x00,
    0xf7, 0x06, 0x00, 0xf6, 0x06, 0x00, 0xfd, 0x7a, 0xfa, 0x0d, 0x00, 0x10, 0xe9, 0xef, 0x19, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xd0, 0x0e, 0x00, 0x00, 0xde, 0xf7, 0x03, 0x00, 0xf3, 0x27, 0x8f, 0x00, 0x90, 0x2f, 0xd0,
    0x0d, 0x00, 0xdd, 0x00, 0xf8, 0x02, 0xf2, 0x07, 0x30, 0x7f, 0x70, 0x2f, 0x00, 0xd0, 0x0c, 0xdc, 0x00, 0x00, 0xf8,
    0xf3, 0x08, 0x00, 0x30, 0xaf, 0x3f, 0x00, 0x00, 0xe0, 0xdf, 0x00, 0x00, 0x00, 0xf9, 0x08, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xfc, 0x00, 0x00, 0xef, 0x00, 0x00, 0xce, 0xf8, 0x03, 0x40, 0xff, 0x03, 0x30, 0x8f, 0xf4, 0x06,
    0x80, 0xee, 0x07, 0x60, 0x4f, 0xf0, 0x0a, 0xc0, 0xba, 0x0c, 0xa0, 0x0f, 0xc0, 0x0e, 0xf1, 0x77, 0x0f, 0xe0, 0x0c,
    0x80, 0x2f, 0xf5, 0x32, 0x5f, 0xf2, 0x08, 0x40, 0x5f, 0xe9, 0x00, 0x9e, 0xf5, 0x04, 0x00, 0x8f, 0xad, 0x00, 0xca,
    0xf9, 0x00, 0x00, 0xcc, 0x5f, 0x00, 0xf6, 0xcc, 0x00, 0x00, 0xf8, 0x1f, 0x00, 0xf2, 0x8f, 0x00, 0x00, 0xf4, 0x0d,
    0x00, 0xd0, 0x4f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x7f,
    0x00, 0x60, 0x6f, 0xc0, 0x1e, 0x00, 0xce, 0x00, 0xf3, 0x09, 0xf8, 0x03, 0x00, 0xf9, 0xf4, 0x09, 0x00, 0x10, 0xfe,
    0x0e, 0x00, 0x00, 0xb0, 0xaf, 0x00, 0x00, 0x30, 0xdf, 0x3f, 0x00, 0x00, 0xdd, 0xe0, 0x0c, 0x00, 0xf7, 0x04, 0xf6,
    0x06, 0xe1, 0x0b, 0x00, 0xed, 0xa1, 0x2f, 0x00, 0x40, 0xaf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x2f, 0x00, 0x20, 0xbf, 0xf2,
    0x0a, 0x00, 0xfa, 0x02, 0xfa, 0x02, 0xf2, 0x09, 0x20, 0xaf, 0xb0, 0x1f, 0x00, 0x90, 0x7f, 0x8f, 0x00, 0x00, 0xf1,
    0xef, 0x00, 0x00, 0x00, 0xf8, 0x07, 0x00, 0x00, 0x50, 0x5f, 0x00, 0x00, 0x00, 0xf5, 0x05, 0x00, 0x00, 0x50, 0x5f,
    0x00, 0x00, 0x00, 0xf5, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0xff, 0xff, 0xff, 0x5f, 0x72, 0x77, 0x77, 0xff, 0x02,
    0x00, 0x00, 0xf7, 0x06, 0x00, 0x00, 0xf2, 0x0b, 0x00, 0x00, 0xc0, 0x1e, 0x00, 0x00, 0x80, 0x5f, 0x00, 0x00, 0x30,
    0xaf, 0x00, 0x00, 0x00, 0xed, 0x00, 0x00, 0x00, 0xf9, 0x04, 0x00, 0x00, 0xf4, 0x7d, 0x77, 0x77, 0x73, 0xff, 0xff,
    0xff, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xfd, 0x9f, 0xd0, 0x3c, 0x02, 0xbd, 0x00, 0xd0, 0x0b, 0x00, 0xbd, 0x00, 0xd0, 0x0b, 0x00,
    0xbd, 0x00, 0xd0, 0x0b, 0x00, 0xbd, 0x00, 0xd0, 0x0b, 0x00, 0xbd, 0x00, 0xd0, 0x3c, 0x02, 0xfd, 0x9f, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xea, 0x00, 0x00, 0xf4, 0x04, 0x00, 0xe0, 0x0a, 0x00, 0x80, 0x0f, 0x00, 0x20,
    0x6f, 0x00, 0x00, 0xcc, 0x00, 0x00, 0xf6, 0x02, 0x00, 0xf0, 0x08, 0x00, 0xa0, 0x0e, 0x00, 0x40, 0x4f, 0x00, 0x00,
    0xae, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0xff, 0x0d, 0x32,
    0xdc, 0x00, 0xb0, 0x0d, 0x00, 0xdb, 0x00, 0xb0, 0x0d, 0x00, 0xdb, 0x00, 0xb0, 0x0d, 0x00, 0xdb, 0x00, 0xb0, 0x0d,
    0x00, 0xdb, 0x00, 0xb0, 0x0d, 0x32, 0xdc, 0x90, 0xff, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xd0, 0x07, 0x00, 0x00, 0xf4, 0x0e, 0x00, 0x00, 0x8b, 0x7c, 0x00, 0x20, 0x1f, 0xe4, 0x01, 0xa0, 0x0a, 0xc0,
    0x08, 0xf1, 0x03, 0x50, 0x1f, 0xc8, 0x00, 0x00, 0x8d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10,
    0xec, 0x02, 0x00, 0x00, 0x00, 0xd8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0xea, 0xef, 0x09, 0x00, 0xb1, 0x56, 0xf8, 0x08, 0x00, 0x00,
    0x00, 0xbe, 0x00, 0x92, 0xfd, 0xff, 0x0b, 0xe1, 0x5e, 0x11, 0xbf, 0x30, 0x7f, 0x00, 0xf1, 0x0b, 0xf2, 0x5d, 0xc6,
    0xbe, 0x00, 0xe6, 0xdf, 0x95, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x0d, 0x00, 0x00, 0x00, 0xdd, 0x00, 0x00, 0x00, 0xd0, 0x0d, 0x00, 0x00, 0x00,
    0xdd, 0x00, 0x00, 0x00, 0xd0, 0x6d, 0xfe, 0x1b, 0x00, 0xfd, 0x6c, 0xf9, 0x0b, 0xd0, 0x1f, 0x00, 0xfb, 0x01, 0xed,
    0x00, 0x70, 0x3f, 0xd0, 0x0e, 0x00, 0xf7, 0x03, 0xfd, 0x01, 0xb0, 0x1f, 0xd0, 0xcf, 0x96, 0xbf, 0x00, 0x9d, 0xe7,
    0xaf, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe9, 0xdf, 0x04,
    0xfa, 0x7a, 0x29, 0xf1, 0x0b, 0x00, 0x30, 0x7f, 0x00, 0x00, 0xf3, 0x07, 0x00, 0x10, 0xbf, 0x00, 0x00, 0xb0, 0xaf,
    0x97, 0x05, 0x90, 0xfe, 0x3d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0xdd, 0x00, 0x00, 0x00, 0xd0, 0x0d, 0x00, 0x00, 0x00, 0xdd, 0x00, 0x00, 0x00, 0xd0, 0x0d, 0x10,
    0xfa, 0x7e, 0xdd, 0x00, 0xfb, 0x69, 0xfc, 0x0d, 0xf1, 0x0b, 0x00, 0xdf, 0x30, 0x7f, 0x00, 0xd0, 0x0d, 0xf3, 0x07,
    0x00, 0xdd, 0x10, 0xbf, 0x00, 0xf0, 0x0d, 0xb0, 0x9f, 0xb6, 0xdf, 0x00, 0xb1, 0xef, 0xa6, 0x0d, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd6, 0xef, 0x09, 0x00,
    0xf7, 0x48, 0xe7, 0x0b, 0xf0, 0x0b, 0x00, 0xf8, 0x22, 0xff, 0xff, 0xff, 0x3f, 0xf2, 0x3a, 0x33, 0x33, 0x00, 0xdf,
    0x00, 0x00, 0x00, 0x70, 0xbf, 0x56, 0xa7, 0x00, 0x60, 0xfc, 0xdf, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xe7, 0xbf, 0x30, 0xcf, 0x56, 0x70, 0x3f,
    0x00, 0x70, 0x1f, 0x00, 0xf7, 0xff, 0x0d, 0x92, 0x5f, 0x03, 0x70, 0x1f, 0x00, 0x70, 0x1f, 0x00, 0x70, 0x1f, 0x00,
    0x70, 0x1f, 0x00, 0x70, 0x1f, 0x00, 0x70, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20,
    0xfc, 0xff, 0xbf, 0xd0, 0x2c, 0xf5, 0x09, 0xf3, 0x06, 0xd0, 0x0c, 0xf3, 0x06, 0xd0, 0x0c, 0xd0, 0x2c, 0xf5, 0x07,
    0x30, 0xff, 0x8e, 0x00, 0xb0, 0x0b, 0x00, 0x00, 0x80, 0xff, 0xff, 0x1b, 0xe4, 0x79, 0x97, 0x8f, 0xbc, 0x00, 0x00,
    0x9e, 0xeb, 0x35, 0xa4, 0x4f, 0xa1, 0xfe, 0xbe, 0x04, 0xb0, 0x0f, 0x00, 0x00, 0x00, 0xb0, 0x0f, 0x00, 0x00, 0x00,
    0xb0, 0x0f, 0x00, 0x00, 0x00, 0xb0, 0x0f, 0x00, 0x00, 0x00, 0xb0, 0x4f, 0xfc, 0x9e, 0x00, 0xb0, 0xef, 0x67, 0xfb,
    0x07, 0xb0, 0x4f, 0x00, 0xf0, 0x0b, 0xb0, 0x0f, 0x00, 0xf0, 0x0b, 0xb0, 0x0f, 0x00, 0xf0, 0x0b, 0xb0, 0x0f, 0x00,
    0xf0, 0x0b, 0xb0, 0x0f, 0x00, 0xf0, 0x0b, 0xb0, 0x0f, 0x00, 0xf0, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x0c, 0xb0, 0x0c, 0x00, 0x00,
    0x00, 0x00, 0xd0, 0x0d, 0xd0, 0x0d, 0xd0, 0x0d, 0xd0, 0x0d, 0xd0, 0x0d, 0xd0, 0x0d, 0xd0, 0x0d, 0xd0, 0x0d, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xcb, 0x00, 0xcb, 0x00, 0x00, 0x00, 0x00, 0x00, 0xdd, 0x00, 0xdd,
    0x00, 0xdd, 0x00, 0xdd, 0x00, 0xdd, 0x00, 0xdd, 0x00, 0xdd, 0x00, 0xdd, 0x00, 0xdd, 0x00, 0xdd, 0x76, 0xbf, 0xfe,
    0x2c, 0xb0, 0x0f, 0x00, 0x00, 0x00, 0xfb, 0x00, 0x00, 0x00, 0xb0, 0x0f, 0x00, 0x00, 0x00, 0xfb, 0x00, 0x00, 0x00,
    0xb0, 0x0f, 0x00, 0xeb, 0x03, 0xfb, 0x00, 0xeb, 0x03, 0xb0, 0x0f, 0xec, 0x03, 0x00, 0xeb, 0xfb, 0x07, 0x00, 0xb0,
    0xdf, 0xed, 0x02, 0x00, 0xfb, 0x20, 0xde, 0x00, 0xb0, 0x0f, 0x40, 0xbf, 0x00, 0xfb, 0x00, 0x70, 0x7f, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x0d, 0xd0,
    0x0d, 0xd0, 0x0d, 0xd0, 0x0d, 0xd0, 0x0d, 0xd0, 0x0d, 0xd0, 0x0d, 0xd0, 0x0d, 0xd0, 0x0d, 0xd0, 0x0d, 0xd0, 0x0d,
    0xd0, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xb0, 0x79, 0xfe, 0x2c, 0xe7, 0xbf, 0x01, 0xb0, 0xdf, 0x96, 0xef, 0x6c, 0xf9, 0x09, 0xb0, 0x2f, 0x00, 0xfe, 0x01,
    0xe0, 0x0d, 0xb0, 0x0e, 0x00, 0xed, 0x00, 0xd0, 0x0d, 0xb0, 0x0d, 0x00, 0xdd, 0x00, 0xd0, 0x0d, 0xb0, 0x0d, 0x00,
    0xdd, 0x00, 0xd0, 0x0d, 0xb0, 0x0d, 0x00, 0xdd, 0x00, 0xd0, 0x0d, 0xb0, 0x0d, 0x00, 0xdd, 0x00, 0xd0, 0x0d, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb0, 0x5b, 0xfd, 0x9e, 0x00, 0xb0, 0xef, 0x67, 0xfb, 0x07,
    0xb0, 0x4f, 0x00, 0xf0, 0x0b, 0xb0, 0x0f, 0x00, 0xf0, 0x0b, 0xb0, 0x0f, 0x00, 0xf0, 0x0b, 0xb0, 0x0f, 0x00, 0xf0,
    0x0b, 0xb0, 0x0f, 0x00, 0xf0, 0x0b, 0xb0, 0x0f, 0x00, 0xf0, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd8, 0xef, 0x07, 0x00, 0xf9, 0x5a, 0xfa,
    0x08, 0xf0, 0x0b, 0x00, 0xfc, 0x30, 0x7f, 0x00, 0x80, 0x3f, 0xf3, 0x07, 0x00, 0xf8, 0x03, 0xbf, 0x00, 0xc0, 0x0f,
    0x80, 0xaf, 0xa6, 0x9f, 0x00, 0x70, 0xfd, 0x7d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x6a, 0xfe, 0x1b, 0x00, 0xfd, 0x6c, 0xf9, 0x0b, 0xd0, 0x1f, 0x00,
    0xfb, 0x01, 0xdd, 0x00, 0x70, 0x3f, 0xd0, 0x0e, 0x00, 0xf7, 0x03, 0xfd, 0x01, 0xb0, 0x1f, 0xd0, 0xcf, 0x96, 0xbf,
    0x00, 0xdd, 0xe7, 0xaf, 0x01, 0xd0, 0x0d, 0x00, 0x00, 0x00, 0xdd, 0x00, 0x00, 0x00, 0xd0, 0x0d, 0x00, 0x00, 0x00,
    0xdd, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x10, 0xfa, 0x7e, 0xda, 0x00, 0xfb, 0x69, 0xfc, 0x0d, 0xf1, 0x0b, 0x00, 0xdf, 0x30, 0x7f, 0x00,
    0xd0, 0x0d, 0xf3, 0x07, 0x00, 0xdd, 0x10, 0xbf, 0x00, 0xf0, 0x0d, 0xb0, 0x8f, 0xb5, 0xdf, 0x00, 0xb1, 0xef, 0xd6,
    0x0d, 0x00, 0x00, 0x00, 0xdd, 0x00, 0x00, 0x00, 0xd0, 0x0d, 0x00, 0x00, 0x00, 0xdd, 0x00, 0x00, 0x00, 0xd0, 0x0d,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xd0, 0x58, 0xae, 0xd0, 0xed, 0x5a, 0xd0,
    0x4f, 0x00, 0xd0, 0x0e, 0x00, 0xd0, 0x0d, 0x00, 0xd0, 0x0d, 0x00, 0xd0, 0x0d, 0x00, 0xd0, 0x0d, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0xfd, 0xbe, 0x21, 0xbf, 0x65, 0x0a, 0xf3, 0x0a, 0x00, 0x00, 0xfa, 0x8e, 0x01,
    0x00, 0xa3, 0xef, 0x01, 0x00, 0x60, 0x5f, 0x93, 0x55, 0xfb, 0x23, 0xfc, 0xdf, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1f, 0x00, 0x50,
    0x1f, 0x00, 0xf7, 0xff, 0x7f, 0xb2, 0x5f, 0x13, 0x90, 0x1f, 0x00, 0x90, 0x1f, 0x00, 0x90, 0x1f, 0x00, 0x90, 0x2f,
    0x00, 0x60, 0xaf, 0x45, 0x00, 0xfa, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xb0, 0x0f, 0x00, 0xf0, 0x0b, 0xb0, 0x0f, 0x00, 0xf0, 0x0b, 0xb0, 0x0f, 0x00, 0xf0, 0x0b, 0xb0, 0x0f, 0x00,
    0xf0, 0x0b, 0xb0, 0x0f, 0x00, 0xf0, 0x0b, 0xb0, 0x0f, 0x00, 0xf4, 0x0b, 0x80, 0xbf, 0x75, 0xfe, 0x0b, 0x00, 0xe9,
    0xdf, 0xb5, 0x0b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0xec, 0x00, 0x00, 0xcf, 0xf6, 0x05, 0x50, 0x6f, 0xf0, 0x0a, 0xb0, 0x0f, 0xa0, 0x0f, 0xf0, 0x0a, 0x40, 0x5f,
    0xf6, 0x03, 0x00, 0xbd, 0xdb, 0x00, 0x00, 0xe7, 0x7e, 0x00, 0x00, 0xf1, 0x1f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfb, 0x00, 0xf0,
    0x1f, 0x00, 0xbf, 0xf6, 0x04, 0xe5, 0x5f, 0x40, 0x6f, 0xf2, 0x08, 0xb9, 0x9b, 0x80, 0x2f, 0xd0, 0x0c, 0x7e, 0xe8,
    0xc0, 0x0d, 0x90, 0x3f, 0x3f, 0xf3, 0xf3, 0x09, 0x50, 0x9f, 0x0e, 0xf0, 0xfa, 0x04, 0x00, 0xef, 0x0a, 0xb0, 0xfe,
    0x00, 0x00, 0xfc, 0x05, 0x60, 0xbf, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xf4, 0x09, 0x80, 0x4f, 0xa0, 0x3f, 0xf2, 0x0a, 0x00, 0xce,
    0xec, 0x00, 0x00, 0xf5, 0x5f, 0x00, 0x00, 0xf6, 0x6f, 0x00, 0x20, 0xaf, 0xfa, 0x02, 0xc0, 0x1e, 0xe1, 0x0c, 0xf7,
    0x06, 0x60, 0x6f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfc, 0x00, 0x00,
    0xcf, 0xf6, 0x06, 0x50, 0x6f, 0xe0, 0x0b, 0xb0, 0x1f, 0x80, 0x1f, 0xf0, 0x0b, 0x20, 0x7f, 0xf5, 0x05, 0x00, 0xcc,
    0xeb, 0x00, 0x00, 0xf5, 0x9e, 0x00, 0x00, 0xe0, 0x3f, 0x00, 0x00, 0xe0, 0x0d, 0x00, 0x00, 0xf4, 0x08, 0x00, 0x64,
    0xee, 0x01, 0x00, 0xfa, 0x3c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0xf3, 0xff, 0xff, 0x15, 0x55, 0xd5, 0x2f, 0x00, 0x60, 0x6f, 0x00, 0x10, 0xbe, 0x00, 0x00, 0xec, 0x01,
    0x00, 0xf7, 0x04, 0x00, 0xf3, 0x5d, 0x55, 0x72, 0xff, 0xff, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0x9e, 0x00, 0xf7, 0x39, 0x00, 0xf9, 0x00, 0x00,
    0xf9, 0x00, 0x00, 0xf9, 0x00, 0x20, 0xce, 0x00, 0xf9, 0x1c, 0x00, 0x93, 0xaf, 0x00, 0x00, 0xfa, 0x00, 0x00, 0xf9,
    0x00, 0x00, 0xf9, 0x00, 0x00, 0xf7, 0x39, 0x00, 0x90, 0x9e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90, 0x09,
    0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90,
    0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00,
    0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00, 0x00, 0x90, 0x09, 0x00,
    0x00, 0x90, 0x09, 0x00, 0x00, 0x00, 0x00, 0xe9, 0x09, 0x00, 0x93, 0x7f, 0x00, 0x00, 0x9f, 0x00, 0x00, 0x9f, 0x00,
    0x00, 0x9f, 0x00, 0x00, 0xdc, 0x02, 0x00, 0xc1, 0x9f, 0x00, 0xf9, 0x38, 0x00, 0xae, 0x00, 0x00, 0x9f, 0x00, 0x00,
    0x9f, 0x00, 0x93, 0x8f, 0x00, 0xe9, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0xfb,
    0xbe, 0x56, 0x38, 0x83, 0x64, 0xea, 0xbf, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc9, 0xbb, 0xcb, 0x09,
    0x90, 0x01, 0x00, 0x93, 0x00, 0x19, 0x00, 0x30, 0x09, 0x90, 0x01, 0x00, 0x93, 0x00, 0x19, 0x00, 0x30, 0x09, 0x90,
    0x01, 0x00, 0x93, 0x00, 0x19, 0x00, 0x30, 0x09, 0x90, 0x01, 0x00, 0x93, 0x00, 0x19, 0x00, 0x30, 0x09, 0x90, 0x01,
    0x00, 0x93, 0x00, 0xc9, 0xbb, 0xcb, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00
]
charactersOPEN_SANS_SEMIBOLD_11_16PX = [
    FontCharacter(4, 32, 0), FontCharacter(4, 32, 32), FontCharacter(7, 56, 64), FontCharacter(10, 80, 120),
    FontCharacter(9, 72, 200), FontCharacter(13, 104, 272), FontCharacter(11, 88, 376), FontCharacter(4, 32, 464),
    FontCharacter(5, 40, 496), FontCharacter(5, 40, 536), FontCharacter(8, 64, 576), FontCharacter(9, 72, 640),
    FontCharacter(4, 32, 712), FontCharacter(5, 40, 744), FontCharacter(4, 32, 784), FontCharacter(6, 48, 816),
    FontCharacter(9, 72, 864), FontCharacter(9, 72, 936), FontCharacter(9, 72, 1008), FontCharacter(9, 72, 1080),
    FontCharacter(9, 72, 1152), FontCharacter(9, 72, 1224), FontCharacter(9, 72, 1296), FontCharacter(9, 72, 1368),
    FontCharacter(9, 72, 1440), FontCharacter(9, 72, 1512), FontCharacter(4, 32, 1584), FontCharacter(4, 32, 1616),
    FontCharacter(9, 72, 1648), FontCharacter(9, 72, 1720), FontCharacter(9, 72, 1792), FontCharacter(7, 56, 1864),
    FontCharacter(13, 104, 1920), FontCharacter(10, 80, 2024), FontCharacter(10, 80, 2104), FontCharacter(10, 80, 2184),
    FontCharacter(11, 88, 2264), FontCharacter(8, 64, 2352), FontCharacter(8, 64, 2416), FontCharacter(11, 88, 2480),
    FontCharacter(11, 88, 2568), FontCharacter(5, 40, 2656), FontCharacter(5, 40, 2696), FontCharacter(10, 80, 2736),
    FontCharacter(8, 64, 2816), FontCharacter(14, 112, 2880), FontCharacter(12, 96, 2992), FontCharacter(12, 96, 3088),
    FontCharacter(9, 72, 3184), FontCharacter(12, 96, 3256), FontCharacter(10, 80, 3352), FontCharacter(8, 64, 3432),
    FontCharacter(8, 64, 3496), FontCharacter(11, 88, 3560), FontCharacter(9, 72, 3648), FontCharacter(14, 112, 3720),
    FontCharacter(9, 72, 3832), FontCharacter(9, 72, 3904), FontCharacter(9, 72, 3976), FontCharacter(5, 40, 4048),
    FontCharacter(6, 48, 4088), FontCharacter(5, 40, 4136), FontCharacter(8, 64, 4176), FontCharacter(6, 48, 4240),
    FontCharacter(9, 72, 4288), FontCharacter(9, 72, 4360), FontCharacter(9, 72, 4432), FontCharacter(7, 56, 4504),
    FontCharacter(9, 72, 4560), FontCharacter(9, 72, 4632), FontCharacter(6, 48, 4704), FontCharacter(8, 64, 4752),
    FontCharacter(10, 80, 4816), FontCharacter(4, 32, 4896), FontCharacter(4, 32, 4928), FontCharacter(9, 72, 4960),
    FontCharacter(4, 32, 5032), FontCharacter(14, 112, 5064), FontCharacter(10, 80, 5176), FontCharacter(9, 72, 5256),
    FontCharacter(9, 72, 5328), FontCharacter(9, 72, 5400), FontCharacter(6, 48, 5472), FontCharacter(7, 56, 5520),
    FontCharacter(6, 48, 5576), FontCharacter(10, 80, 5624), FontCharacter(8, 64, 5704), FontCharacter(12, 96, 5768),
    FontCharacter(8, 64, 5864), FontCharacter(8, 64, 5928), FontCharacter(7, 56, 5992), FontCharacter(6, 48, 6048),
    FontCharacter(8, 64, 6096), FontCharacter(6, 48, 6160), FontCharacter(9, 72, 6208), FontCharacter(9, 72, 6280)
]

FONTS = [
    Font(BAGL_FONT_LUCIDA_CONSOLE_8PX, 1, 8, 16, 0, 0x0020, 0x00ff,
         charactersLUCIDA_CONSOLE_6PT_8H, bitmapLUCIDA_CONSOLE_6PT_8H),
    Font(BAGL_FONT_OPEN_SANS_LIGHT_16_22PX, 4, 22, 16, 0, 0x0020, 0x007f,
         charactersOPEN_SANS_LIGHT_16_22PX, bitmapOPEN_SANS_LIGHT_16_22PX),
    Font(BAGL_FONT_OPEN_SANS_REGULAR_8_11PX, 4, 11, 8, 0, 0x0020, 0x007f,
         charactersOPEN_SANS_REGULAR_8_11PX, bitmapOPEN_SANS_REGULAR_8_11PX),
    Font(BAGL_FONT_OPEN_SANS_REGULAR_10_13PX, 4, 14, 10, 0, 0x0020, 0x007F,
         charactersOPEN_SANS_REGULAR_10_13PX, bitmapOPEN_SANS_REGULAR_10_13PX),
    Font(BAGL_FONT_OPEN_SANS_EXTRABOLD_11px, 1, 12, 9, 0, 0x0020, 0x007F,
         charactersOPEN_SANS_EXTRABOLD_11PX, bitmapOPEN_SANS_EXTRABOLD_11PX),
    Font(BAGL_FONT_OPEN_SANS_REGULAR_11px, 1, 12, 9, 0, 0x0020, 0x007F,
         charactersOPEN_SANS_REGULAR_11PX, bitmapOPEN_SANS_REGULAR_11PX),
    Font(BAGL_FONT_OPEN_SANS_LIGHT_16px, 1, 18, 13, 0, 0x0020, 0x007F,
         charactersOPEN_SANS_LIGHT_16PX, bitmapOPEN_SANS_LIGHT_16PX),
    Font(BAGL_FONT_OPEN_SANS_SEMIBOLD_10_13PX, 4, 14, 10, 0, 0x0020, 0x007f,
         charactersOPEN_SANS_SEMIBOLD_10_13PX, bitmapOPEN_SANS_SEMIBOLD_10_13PX),
    Font(BAGL_FONT_OPEN_SANS_SEMIBOLD_8_11PX, 4, 11, 8, 0, 0x0020, 0x007f,
         charactersOPEN_SANS_SEMIBOLD_8_11PX, bitmapOPEN_SANS_SEMIBOLD_8_11PX),
    Font(BAGL_FONT_OPEN_SANS_REGULAR_11_14PX, 4, 16, 12, 0, 0x0020, 0x007f,
         charactersOPEN_SANS_REGULAR_11_14PX, bitmapOPEN_SANS_REGULAR_11_14PX),
    Font(BAGL_FONT_OPEN_SANS_SEMIBOLD_11_16PX, 4, 16, 12, 0, 0x0020, 0x007f,
         charactersOPEN_SANS_SEMIBOLD_11_16PX, bitmapOPEN_SANS_SEMIBOLD_11_16PX),
    Font(BAGL_FONT_SYMBOLS_0, 4, 16, 16, 0, 0x0000, 0x0006,
         charactersSYMBOLS_0, bitmapSYMBOLS_0)
]


def get(font_id: int) -> Optional[Font]:
    font_id &= BAGL_FONT_ID_MASK
    for font in FONTS:
        if font.font_id == font_id:
            return font
    return None
